2021-08-18  Pawel Salek  <pawsa0@gmail.com>

	* .../Makefile.am: include '*meson*' files in the distribution package.
	* NEWS, configure.ac, meson.build: release balsa-2.6.3

2021-03-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	imap-handle: use a flexible array member

	to append data to struct ImapMsgSerialized.

	Thanks to @albrecht for the suggestion and reference to the C99
	standard, in https://gitlab.gnome.org/GNOME/balsa/-/issues/57

	* libbalsa/imap/imap-handle.c:
	  struct ImapMsgSerialized: replace
	    - gchar fetched_headers_first_char;
	    with a flexible array member
	    + gchar fetched_headers_data[];
	  (imap_message_serialize): adapt to the change;
	  (imap_message_deserialize): ditto.

2021-03-25  Peter Bloomfield  <pbloomfield@bellsouth.net>

	html: WebKit deprecation cleanup

	* libbalsa/html.c (lbh_web_view_new):
	webkit_settings_set_enable_plugins() is deprecated in 2.32 (we
	test for 2.31.91).

2021-03-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Lock destination when copying or moving

	* libbalsa/mailbox.c
	  (libbalsa_mailbox_real_messages_copy): remove guards;
	  (messages_copy_locked): helper;
	  (libbalsa_mailbox_messages_copy): guard and lock destination,
	    and use helper;
	  (libbalsa_mailbox_messages_move): ditto.

2021-03-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	imap-handle: check for non-compliant responses

	* libbalsa/imap/imap-handle.c
	  (imap_cmd_step): disconnect if a protocol error is found;
	  (ir_exists): check that the handle is either authenticated or selected;
	  (ir_recent): ditto;
	  (ir_fetch_seq): check that the handle is selected;
	  (ir_expunge): ditto; also check that the sequence number of
	    the expunged message is valid.

2021-03-09  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Try to avoid critical messages

	* libbalsa/mailbox_imap.c
	  (imap_expunge_idle): handle expunged messages in the order
	    they are expunged;
	  (libbalsa_mailbox_imap_fetch_headers): avoid a critical message.

2021-03-08  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove a scheduled idle callback at close time instead of at
	dispose time.

	* libbalsa/mailbox_imap.c
	  (libbalsa_mailbox_imap_close): remove expunged idle source, if any;
	  (libbalsa_mailbox_imap_dispose): comment that it should have
	    been removed at close time.

2021-03-08  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Handle expunged IMAP messages in an idle callback

	* libbalsa/mailbox_imap.c: add an array of expunged messages and
	    an idle id to LibBalsaMailboxImap;
	  (libbalsa_mailbox_imap_init): initialize them;
	  (libbalsa_mailbox_imap_dispose): remove any outstanding idle source;
	  (libbalsa_mailbox_imap_finalize): free the array;
	  (imap_expunge_cb): populate the array, and if necessary schedule the idle
	    callback;
	  (imap_expunge_idle): handle the expunged messages.

2020-12-21  Pawel Salek  <pawsa0@gmail.com>

    * NEWS, configure.ac, meson.build: release balsa-2.6.2


2020-12-19  Pawel Salek  <pawsa0@gmail.com>

    * libbalsa/imap/imap-auth.c: catch errors mid authentication process.
    * libbalsa/imap/imap-commands.c: simplify CAPABILITY handling
    to prevent infinite loops.

2020-12-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* meson.build: Define the FORTIFY_SOURCE macro only if the
	  optimiztion level is at least 2.

2020-11-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main-window: Do not export balsa_window_fix_paned

	* src/main-window.c (bw_fix_panes): it is now local;
	  (bw_set_panes): set the GSource for it;
	* src/main-window.h: do not export it;
	* src/main.c (balsa_activate_cb): do not use it.

2020-11-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main-window: Fix some geometry

	Use the correct GtkPaned's position to detect changes in the
	width of BalsaMBList and the height of BalsaIndex

	* src/main-window.c
	  (Private structure): add mblist_parent and notebook_parent
	    widgets;
	  (bw_mblist_parent_position_cb): callback for the mblist's
	    horizontal GtkPaned parent;
	  (bw_notebook_parent_position_cb): callback for the notebook's
	    vertical GtkPaned parent;
	  (bw_set_panes): set priv->mblist_parent and
	    priv->notebook_parent according to the layout;
	  (balsa_window_new),
	  (balsa_window_fix_paned),
	  (balsa_window_refresh),
	  (bw_show_mbtree),
	  (balsa_change_window_layout): use the appropriate parent
	  GtkPaneds, instead of paned_parent and paned_child.

2020-10-17  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-icons: rename balsa_register_pixbufs()

	to balsa_register_icon_names(), and drop its now unused parameter.

	* src/balsa-icons.c (balsa_register_icon_names):
	* src/balsa-icons.h:
	* src/main-window.c (balsa_window_new):

2020-10-17  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: Set the "icon-name" property of the
	GtkCellRendererPixbufs instead of the "pixbuf" property.

	* src/balsa-index.c (balsa_index_init): set the "icon-name" property;
	* src/balsa-icons.c (balsa_register_pixbufs):
	    register the address-view icons by name instead of pixbuf.
	* libbalsa/mailbox.c (mailbox_model_init): the status and
	    attachment columns are now strings, not pixbufs;
	  (mailbox_model_get_value): ditto;
	  (libbalsa_mailbox_set_unread_icon), (libbalsa_mailbox_set_trash_icon),
	  (libbalsa_mailbox_set_flagged_icon), (libbalsa_mailbox_set_replied_icon),
	  (libbalsa_mailbox_set_attach_icon), (libbalsa_mailbox_set_good_icon),
	  (libbalsa_mailbox_set_notrust_icon), (libbalsa_mailbox_set_bad_icon),
	  (libbalsa_mailbox_set_sign_icon), (libbalsa_mailbox_set_encr_icon):
	    the parameter is a string, not a pixbuf;
	* libbalsa/mailbox.h: ditto.

2020-10-17  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Address-view: Set the "icon-name" property of the
	GtkCellRendererPixbufs instead of the "pixbuf" property.

	* libbalsa/address-view.c (lbav_button_activated), (libbalsa_address_view_new):
	  the icon column is now G_TYPE_STRING instead of GDK_TYPE_PIXBUF;
	(libbalsa_address_view_set_book_icon),
	(libbalsa_address_view_set_close_icon),
	(libbalsa_address_view_set_drop_down_icon): the parameter is a
	  string, not a pixbuf;
	* libbalsa/address-view.h: ditto;
	* src/balsa-icons.c (balsa_register_pixmaps),
	(balsa_register_pixbufs): register the address-view icons by name instead of pixbuf.

2020-09-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove LibBalsaCellRendererButton

	We only needed it to capture clicks, which we can do with
	GtkTreeView's "row-activated" signal.

	* libbalsa/cell-renderer-button.c: removed;
	* libbalsa/cell-renderer-button.h: removed;
	* libbalsa/address-view.c: use "row-activated" instead.

2020-09-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/address-view.c (libbalsa_address_view_new): Set
	"activate-on-single-click" property to TRUE, instead of doing it
	the hard way.

2020-09-02  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: add a timeout to verify that the scrolled-to row is
	actually visible, and, if it isn't, to call scroll-to-row again

	* src/balsa-index.c
	  (bndx_scroll_to_row_verify_timeout): the timeout handler;
	  (bndx_scroll_to_row_idle): if the tree-view is realized,
	    schedule the timeout.

2020-08-24  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/libbalsa-gpgme-widgets.c
	(create_key_label_with_warn): the warning icon is (now?)
	"dialog-warning", not "gtk-dialog-warning".

2020-08-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: scroll to row in another idle handler

	* src/balsa-index.c
	  (bndx_scroll_to_row_idle): the handler;
	  (bndx_scroll_to_row): helper to schedule it;
	  (bndx_scroll_on_open_idle), (bndx_select_row), (bndx_ensure_visible_idle):
	    use the helper;
	  (bndx_destroy): remove the source, if necessary.

2020-08-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: Ensure visible in a low-priority idle callback

	* src/balsa-index.c (bndx_ensure_visible_idle): the callback;
	(balsa_index_ensure_visible): schedule it.

2020-08-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Fix some more mailbox-opening issues

	* libbalsa/mailbox.c (libbalsa_mailbox_get_has_sort_pending):
	  new function;
	* libbalsa/mailbox.h: declare it;
	* src/balsa-index.c (bndx_scroll_on_open_idle): use it;
	* src/main-window.c (bw_real_open_mbnode_idle_cb): show the
	  BalsaIndex widget here, instead of in the scroll-on-open idle
	  handler
	(balsa_window_next_unread): balsa_index_select_next_unread()
	  finds the next unread message even if it is hidden.

2020-08-17  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-message: Restore text copy

	Edit:Copy has been broken for a while, because
	BalsaMimeWidgetText is now a container, not the actual text
	widget.

	* src/balsa-message.c (balsa_message_can_select): Check the
	mime-widget's text-widget, not the mime-widget itself.

2020-07-12  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Various: Drop libbalsa_{radio,toggle}_activated

	https://developer.gnome.org/gio/stable/GActionMap.html#GActionEntry:
	Since GLib 2.40, [activate] can be NULL for stateful actions,
	in which case the default handler is used. For boolean-stated
	actions with no parameter, this is a toggle. For other state
	types (and parameter type equal to the state type) this will be a
	function that just calls change_state…

	* libbalsa/application-helpers.c (libbalsa_window_add_accelerator):
	* libbalsa/application-helpers.h:
	* libbalsa/source-viewer.c (libbalsa_show_message_source):
	* src/ab-main.c (get_main_menu):
	* src/main-window.c:
	* src/message-window.c:
	* src/sendmsg-window.c:

2020-07-05  Peter Bloomfield  <pbloomfield@bellsouth.net>

	body: If a part with content-type "message/external-body" has
	access-type URL, use its URL parameter as the filename, instead
	of g_mime_part_get_filename(), so that the previous commit can
	work.

	* libbalsa/body.c (libbalsa_message_body_set_filename): get the
	  "access-type" parameter; if it is non-NULL and equals
	  "URL", get the "URL" parameter and use it as the part's
	  filename; we do not need to verify that the content-type is
	  "message/external-body", as the "access-type" parameter is
	  NULL for any other content-type.

2020-07-05  Peter Bloomfield  <pbloomfield@bellsouth.net>

	compose-window: Attachments of type "message/external-body" must
	have a filename, because libbalsa_message_create_mime_message()
	uses it to distinguish access-type=URL from
	access-type=local-file.

	* src/sendmsg-window.c (attachment2message):

2020-07-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	compose-window: Handle attachments of type
	"message/external-body" when continuing a draft message.

	* src/sendmsg-window.c (add_urlref_attachment): do not free the
	    URL string;
	  (attachments_add): free it here;
	  (add_file_attachment): new helper;
	  (continue_body): use it.

2020-07-03  Peter Bloomfield  <pbloomfield@bellsouth.net>

	compose-window: Use gtk_selection_data_get_uris() instead of our
	own code.

	* src/sendmsg-window.c (attachments_add), (drag_data_quote):

2020-06-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	compose-window: Make the "Open" option on the urlref-attachment
	context menu work.

	* src/sendmsg-window.cs
	  (on_open_url_cb): Get the top-level window from the compose
	  window; getting it from the menu-item leads to a Wayland
	  error;
	  (add_urlref_attachment): Populate BalsaAttachInfo:file_uri.

2020-06-24  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mime-widget-text: Actually pop up the context menu when
	right-clicking on an URL.

	* src/balsa-mime-widget-text.c (text_view_url_popup):

2020-06-16  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main: Sandbox all the webkit

	https://gitlab.gnome.org/GNOME/Initiatives/-/wikis/Sandbox-all-the-WebKit!

	* src/main.c (balsa_startup_cb):

2020-06-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Various: Use GtkTreeView's "row-activated" signal instead of
	connecting to "button-press-event".

	* libbalsa/autocrypt.c (autocrypt_db_dialog_run),
	(row_activated_cb):
	* libbalsa/libbalsa-gpgme-cb.c (row_activated_cb),
	(lb_gpgme_select_key):

2020-06-09  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Various: restore filtering in a mailbox that is not currently
	being viewed.

	* libbalsa/mailbox.c (libbalsa_mailbox_message_match),
	(lbm_cache_message): make sure we cache message info when we need it
	for matching;
	* libbalsa/mailbox_local.c (message_match_real): guard against
	NULL threading-info;
	* src/filter-run-dialog.c (available_list_selection_changed),
	(selected_list_selection_changed): no need to disable the
	"Apply" buttons when the mailbox is not being viewed.

2020-06-08  Peter Bloomfield  <pbloomfield@bellsouth.net>

	filter-run-dialog: Disable "Apply selected" and "Apply now" when
	the mailbox is not currently being viewed in the main window. It
	no longer crashes, because of the previous commit, but it does
	not actually carry out any filters, so the user should see the
	option as disabled.

	* src/filter-run-dialog.c (available_list_selection_changed),
	(selected_list_selection_changed):

2020-06-08  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Do not crash when selecting "Apply selected" when the mailbox is
	not being viewed in the main window.

	* libbalsa/mailbox_local.c (message_match_real): check for NULL
	values;
	* src/filter-run-dialog.c (balsa_filter_run_dialog_new): call
	prepare-threading to get ready for filtering.

2020-06-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-message: Do not crash

	if the message part is changed while the find-in-message bar is
	active.

	* src/balsa-message.c (bm_find_entry_changed_cb):

2020-06-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	toolbar-factory: Stop using direct access to GdkEvent structs

	Use gdk_event_get_event_type instead of directly accessing
	event->type.

	* src/toolbar-factory.c (tm_popup_context_menu_cb):

2020-06-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Find in message: Make it work again

	* src/balsa-mime-widget-text.c
	(balsa_mime_widget_text_get_text_widget): new getter;
	* src/balsa-mime-widget-text.h: ditto;
	* src/balsa-message.c (bm_find_entry_changed_cb), (bm_find_again),
	(bm_find_pass_to_entry), (balsa_message_find_in_message): use it
	to get the real text widget (GtkTextView, GtkSourceView).

2020-06-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mblist: Stop using direct access to GdkEvent structs

	Use GdkEvent getters instead of directly accessing fields.

	* src/balsa-mblist.c (bmbl_select_mailbox), (bmbl_mru_selected_cb):

2020-06-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	compose window: Connect to the "pressed" signal of a
	GtkGestureMultiPress instead of the "button-press-event" widget
	signal.

	* src/sendmsg-window.c (attachment_button_press_cb),
	(sw_attachment_list):

2020-06-05  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mime-widget-text: Use bmwt_html_ prefix

	for all HTML-related functions.

	* src/balsa-mime-widget-text.c (bmwt_html_zoom_in),
	(bmwt_html_zoom_out), (bmwt_html_zoom_reset),
	(bmwt_html_select_all_cb), (bmwt_html_populate_popup_menu),
	(bmwt_html_popup_context_menu), (bmwt_html_gesture_pressed_cb),
	(bmwt_html_populate_popup_cb), (bm_widget_new_html):

2020-06-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main-window: Connect to "notify::focus" signal instead of the
	"focus-in" and "focus-out" widget signals.

	And use the focus status to block the window's accelerator keys
	when the search entry has the keyboard focus.

	* src/main-window.c (bw_check_filter), (bw_create_index_widget),
	(bw_add_win_action_entries), (bw_set_menus), (balsa_window_new):

2020-06-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	application-helpers: Add the capability to block accels

	* libbalsa/application-helpers.c
	  (accel_activate): check whether they are blocked;
	  (libbalsa_window_block_accels): new function;
	* libbalsa/application-helpers.h: ditto.

2020-06-03  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mime-widget-text: Connect to the "pressed" signal of a
	GtkGestureMultiPress instead of the "button-press-event" widget
	signal.

	The HTML part context menu was the last user of an event signal.

	* src/balsa-mime-widget-text.c (mwt_gesture_pressed_cb),
	(bm_widget_new_html):

2020-06-03  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mime-widget-text: Use event-controllers instead of connecting to
	event signals.

	* src/balsa-mime-widget-text.c
	  (mwt_controller_motion_cb), (mwt_controller_leave_cb):
	    GtkEventControllerMotion callbacks;
	  (balsa_mime_widget_new_text): use event-controllers instead of connecting
	    to event signals;
	  (store_button_coords), (check_over_url), (check_call_url): new API.

2020-06-02  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mime-widget-image: Connect to the "pressed" signal of a
	GtkGestureMultiPress instead of the "button-press-event" widget
	signal.

	* src/balsa-mime-widget-image.c (balsa_image_button_press_cb),
	(balsa_mime_widget_new_image):

2020-06-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-message: Connect to the "pressed" signal of a
	GtkGestureMultiPress instead of the "button-press-event" widget
	signal.

	* src/balsa-message.c (balsa_message_init),
	(tree_mult_selection_popup), (tree_button_press_cb):

2020-06-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Various: Connect to the "focus-{in,out}" signals of a
	GtkEventControllerKey instead of the "focus-{in,out}-event" widget
	signals.

	This is preparation for GTK4, but will still need to be changed
	to use GtkEventControllerFocus in that distant future.

	* src/balsa-message.c (bm_header_tl_buttons), (balsa_message_init):
	* src/balsa-mime-widget-message.c (bm_header_widget_new):
	* src/balsa-mime-widget.c (balsa_mime_widget_new):
	* src/balsa-mime-widget-callbacks.c
	  (balsa_mime_widget_limit_focus),
	  (balsa_mime_widget_unlimit_focus): new signature;
	* src/balsa-mime-widget-callbacks.h: ditto.

2020-06-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Various: Connect to the "key-pressed" signal of a
	GtkEventControllerKey instead of the "key-press-event" widget
	signal.

	* src/balsa-message.c (bm_header_tl_buttons), (balsa_message_init):
	* src/balsa-mime-widget-message.c (bm_header_widget_new):
	* src/balsa-mime-widget-text.c (balsa_mime_widget_new_text),
	  (bm_widget_new_html):
	* src/balsa-mime-widget-callbacks.c
	  (balsa_mime_widget_key_pressed): rename and new signature;
	* src/balsa-mime-widget-callbacks.h: ditto.

2020-06-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-mblist: Connect to the "pressed" signal of a
	GtkGestureMultiPress instead of the "button-press-event" widget
	signal.

	* src/balsa-mblist.c (bmbl_gesture_pressed_cb), (bmbl_do_popup),
	(balsa_mblist_default_signal_bindings):

2020-05-31  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: Connect to the "pressed" signal of a
	GtkGestureMultiPress instead of the "button-press-event" widget
	signal.

	* src/balsa-index.c (balsa_index_init), (bndx_gesture_pressed_cb),
	(bndx_do_popup):

2020-05-31  Peter Bloomfield  <pbloomfield@bellsouth.net>

	ab-main: Connect to the "key-pressed" signal of a
	GtkEventControllerKey instead of the "key-press-event" widget
	signal.

	Also drop a pointless "delete-event" handler.

	* src/ab-main.c (ew_key_pressed), (bab_window_new), (main):

2020-05-29  Peter Bloomfield  <pbloomfield@bellsouth.net>

	autocrypt: Connect to the "pressed" signal of a
	GtkGestureMultiPress instead of the "button_press_event" widget
	signal.

	* libbalsa/autocrypt.c (autocrypt_db_dialog_run),
	(gesture_pressed_cb):

2020-05-29  Peter Bloomfield  <pbloomfield@bellsouth.net>

	address-view: Connect to "notify::has-focus" signal instead of
	"focus-out-event".

	* libbalsa/address-view.c (lbav_notify_has_focus_cb),
	(lbav_row_editing_cb):

2020-05-29  Peter Bloomfield  <pbloomfield@bellsouth.net>

	compose window: Hold a reference to identity

	It is possible for BalsaSendmsg:ident to be unreffed by the
	identity configuration editor; it is only a minor inconvenience,
	but we can make it more robust by holding a reference.

	* src/sendmsg-window.c (update_bsmsg_identity),
	  (set_identity_from_mailbox), (guess_identity_from_list),
	  (sendmsg_window_new): manage the reference;
	  (balsa_sendmsg_destroy_handler): ditto; also do not bother to
	    clear members of BalsaSendmsg, as it is about to be deallocated.

2020-05-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	autocrypt: Stop using direct access to GdkEvent structs

	Use GdkEvent getters instead of directly accessing fields.

	* libbalsa/autocrypt.c (key_button_event_press_cb):

2020-05-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	address-view: Stop using direct access to GdkEvent structs

	Use GdkEvent getters instead of directly accessing fields.

	* libbalsa/address-view.c (lbav_key_pressed_cb),
	(lbav_selection_changed_cb):

2020-05-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	address-book and subclasses: Clean up #includes

	* libbalsa/address-book-extern.c:
	* libbalsa/address-book-extern.h:
	* libbalsa/address-book-gpe.c:
	* libbalsa/address-book-gpe.h:
	* libbalsa/address-book-ldap.c:
	* libbalsa/address-book-ldap.h:
	* libbalsa/address-book-ldif.c:
	* libbalsa/address-book-osmo.c:
	* libbalsa/address-book-osmo.h:
	* libbalsa/address-book-rubrica.c:
	* libbalsa/address-book-text.c:
	* libbalsa/address-book-text.h:
	* libbalsa/address-book-vcard.c:
	* libbalsa/address-book.c:

2020-05-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	compose window: BalsaSendmsg:ident may be destroyed while the
	compose window is open, and the only way we can know is if it
	is removed from BalsaApplication:indenties

	* src/sendmsg-window.c (balsa_sendmsg_destroy_handler): check if
	BalsaSendmsg:ident can be found in BalsaApplication:indenties.

2020-05-14  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Bump required versions as discussed in
	https://mail.gnome.org/archives/balsa-list/2020-May/msg00010.html
	and remove corresponding conditional compilation directives.

	* configure.ac:
	* libbalsa/html.c (lbh_web_process_terminated_cb),
	(lbh_web_view_new):
	* libbalsa/identity.c (help_ident_cb):
	* libbalsa/mime.c (is_in_url):
	* libbalsa/misc.c (libbalsa_font_string_to_css):
	* libbalsa/smtp-server.c (smtp_server_response):
	* meson.build:
	* src/address-book-config.c (help_button_cb):
	* src/balsa-index.c (bndx_do_popup):
	* src/balsa-mblist.c (bmbl_do_popup):
	* src/balsa-message.c (balsa_headers_attachments_popup),
	(tree_mult_selection_popup), (tree_button_press_cb):
	* src/balsa-mime-widget-image.c (balsa_image_button_press_cb):
	* src/balsa-mime-widget-message.c (extbody_call_url):
	* src/balsa-mime-widget-text.c (balsa_mime_widget_new_text),
	(handle_url):
	* src/filter-edit-callbacks.c (condition_dialog_response),
	(fe_dialog_response):
	* src/filter-run-callbacks.c (fr_dialog_response):
	* src/folder-conf.c (folder_conf_response):
	* src/main-window.c (help_activated), (bw_notebook_label_new),
	(bw_find_real):
	* src/pref-manager.c (balsa_help_pbox_display), (add_menu_cb):
	* src/sendmsg-window.c (on_open_url_cb),
	(attachment_button_press_cb), (attachment_popup_cb),
	(create_text_area), (create_lang_menu):
	* src/toolbar-factory.c (tm_popup_context_menu_cb):
	* src/toolbar-prefs.c (tp_dialog_response_cb):

2020-05-11  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-message.c (display_face): Fix a scan-build report
	  when building with compface = false.

2020-05-10  Pawel Salek  <pawsa0@gmail.com>

	* NEWS, configure.ac, meson.build: release balsa-2.6.1


2020-05-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/sendmsg-window.c (add_attachment): Insert separators
	  between logically distinct sections of the popup menu.

2020-04-11  Pawel Salek  <pawsa0@gmail.com>

	* NEWS, configure.ac, meson.build: release balsa-2.6.0

2020-03-09  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Drop LibBalsaMailbox:is_directory

	It was a write-only flag.

	* libbalsa/mailbox.c (libbalsa_mailbox_init),
	(libbalsa_mailbox_set_msg_tree_changed):
	* libbalsa/mailbox.h:
	* libbalsa/mailbox_maildir.c (libbalsa_mailbox_maildir_new):
	* libbalsa/mailbox_mbox.c (libbalsa_mailbox_mbox_new):
	* libbalsa/mailbox_mh.c (libbalsa_mailbox_mh_new):

2020-03-09  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove libbalsa_mailbox_local_load_messages from the API, and
	replace it with LibBalsaMailbox::check virtual method.

	* libbalsa/mailbox_local.c (libbalsa_mailbox_local_class_init),
	(lbml_load_messages_idle_cb), (libbalsa_mailbox_local_check),
	(libbalsa_mailbox_local_set_threading):
	* libbalsa/mailbox_local.h:
	* libbalsa/mailbox_maildir.c (libbalsa_mailbox_maildir_check):
	* libbalsa/mailbox_mbox.c (libbalsa_mailbox_mbox_check):
	* libbalsa/mailbox_mh.c (libbalsa_mailbox_mh_check):

2020-03-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Make cache-message a class method

	* libbalsa/mailbox.c (libbalsa_mailbox_class_init),
	(lbm_cache_message), (libbalsa_mailbox_get_message),
	(libbalsa_mailbox_real_cache_message),
	(libbalsa_mailbox_cache_message):
	* libbalsa/mailbox.h:
	* libbalsa/mailbox_local.c (libbalsa_mailbox_local_class_init),
	(lbm_local_cache_message), (libbalsa_mailbox_local_cache_message):
	* libbalsa/mailbox_local.h:
	* libbalsa/mailbox_mbox.c (parse_mailbox):

2020-03-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Guard against out-of-bounds access to a GPtrArray

	* libbalsa/mailbox.c (mailbox_compare_func),
	(libbalsa_mailbox_msgno_get_status),
	(libbalsa_mailbox_msgno_get_subject),
	(libbalsa_mailbox_get_index_entry): use a new macro
	LBM_GET_INDEX_ENTRY() to safely access priv->mindex.

2020-03-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Do not cache message info if the mailbox is not being
	viewed.

	* libbalsa/mailbox.c (lbm_cache_message):

2020-03-03  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-local: Do not pass message to LibBalsaMailbox

	in a case not covered by commit d95c3a90b2478e9dcd18d50ba0bf4efd3a10f64b

	* libbalsa/mailbox_local.c (lbm_local_cache_message):

2020-03-03  Albrecht Dreß  <albrecht.dress@arcor.de>

	Move recheck crypto button to menu, toolbar

	* libbalsa/body.[ch]:
	  • add new function libbalsa_message_body_has_crypto_content()
	    which recursively checks if a LibBalsaMessageBody contains any
	    not yet decrypted or any signed content which may be rechecked
	  • fix comment typo
	* libbalsa/gmime-part-rfc2440.c: g_mime_part_check_rfc2440()
	    make sure to lock/unlock a shared stream
	* libbalsa/message.[ch]:
	  • rename libbalsa_message_is_pgp_(signed|encrypted)()
	    to libbalsa_message_is_(signed|encrypted)(), do not export them,
	    and detect S/MIME (RFC 8551) content
	  • add and export libbalsa_message_has_crypto_content() to check
	    if a message contains any not yet decrypted or any signed content
	    which may be rechecked
	* src/balsa-message.[ch]:
	  • remove recheck crypto button from bm_header_tl_buttons()
	  • rename message_recheck_crypto_cb() to balsa_message_recheck_crypto()
	    and export it
	  • remove ancient code relevant for Gtk+-3.0 < 3.15.0 only
	* src/main-window.c, src/message-window.c:
	  • add “recheck crypto” button to extra toolbar items
	  • add recheck crypto callback, and connect it to the menu item
	  • appropriately disable/enable menu item and button
	* src/toolbar-factory.c: register “Recheck cryptography” button
	* ui/main-window.ui, ui/message-window.ui: add menu item to the ui

2020-02-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-local: Do not pass message to LibBalsaMailbox

	for caching, when we're not preparing a threaded view.

	* libbalsa/mailbox_local.c (lbm_local_cache_message):

2020-02-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use g_print() instead of g_printerr()

	to print network status.
	Fixes https://gitlab.gnome.org/GNOME/balsa/issues/29.

	* src/main-window.c (print_network_status):

2020-02-24  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main: Save the config files

	* src/main.c (balsa_shutdown_cb): the only case where Balsa must
	  not go through the shutdown procedure is when it is called
	  with the -s/--get-stats option; in that case, nothing has been
	  set up, and balsa-app-destroy would cause all sorts of havoc.

2020-02-24  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main: Use non-copying GVariant formats

	Since
	https://gitlab.gnome.org/GNOME/glib/-/commit/325f1e3eb54d3969d3be104481fa1097ffa37d7b,
	the GApplication docs recommend using non-copying variant formats.

	* src/main.c
	  (balsa_check_open_mailboxes): use g_free(), not g_strfreev(),
	    to free cmd_line_open_mailboxes, because it is now a shallow copy;
	  (scan_mailboxes_idle_cb): ditto;
	  (balsa_check_open_compose_window): ditto opt_attach_list;
	  (parse_options): ditto remaining_args; use the non-copying formats.

2020-02-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main: Parse command line arguments in the local instance

	* src/main.c
	  (balsa_check_open_compose_window): opt_compose_email must not
	    be free'd; coding style;
	  (parse_options): use the GVariantDict instead of parsing the
	    command-line arguments;
	  (scan_mailboxes_idle_cb): coding style;
	  (balsa_handle_local_options_cb): new function for handling
	    command line options that do not need to be passed to the
	    primary instance (currently just "--version");
	  (balsa_command_line_cb):  use the GVariantDict instead of parsing
	    the command-line arguments;
	  (main): use g_application_add_main_option_entries() and connect
	    to the "handle-local-options" signal.
	  (handle_remote): coding style;

2020-02-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main: Behave as documented

	The man page says that Balsa exits immediately if given
	--version, --help, or --get-stats, so it should.

	Also, if it is given more than one of those options, it should
	respond to all of them.

	* src/main.c
	  (config_init): is no longer called with a boolean argument;
	  (balsa_startup_cb): do not use cmd_get_stats, it has not been set;
	  (balsa_shutdown_cb): go through the shut-down process only if
	    the main window has been created; it does not get created
	    when Balsa exits immediately after responding to those
	    options;
	  (parse_options): respond to both --help and --version, if
	    requested;
	  (balsa_command_line_cb): activate Balsa only if not exiting
	    immediately;
	  (balsa_get_stats): coding style;
	  (scan_mailboxes_idle_cb): ditto.

2020-02-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use a GThreadPool to open mailboxes

	* src/balsa-index.c
	  (balsa_index_set_mailbox_node): new function, called in a thread;
	  (balsa_index_load_mailbox_node): mailbox-node has already been set;
	* src/balsa-index.h: export balsa_index_set_mailbox_node;
	* src/main-window.c
	  (balsa_window_class_init): rename destroy to dispose;
	  (balsa_window_init): create the GThreadPool, and a GPtrArray
	    to hold the task info structures;
	  (balsa_window_new): make priv->preview a weak pointer;
	  (bw_real_open_mbnode_idle_cb): we no longer need to guard
	    against being called after the main window has been
	    destroyed;
	  (bw_open_mbnode_info_free): a new cleanup function to be
	    passed to g_idle_add_full();
	  (bw_real_open_mbnode_thread): GThreadPool manages the GThread
	    instances, so we no longer need a GMutex; we no longer need
	    to guard against being called after the main window has been
	    destroyed;
	  (balsa_window_real_open_mbnode): push the task to the thread
	    pool instead of creating a new GThread;
	  (balsa_window_dispose): free the thread pool and the pointer
	    array;
	  (bw_add_mbox_to_checklist): cosmetics.

2020-02-16  Albrecht Dreß  <albrecht.dress@arcor.de>

	imap-handle: Do not crash on PREAUTH greeting

	when it hasn't resulted in storing last-message.

	* libbalsa/imap/imap-handle.c (imap_mbox_connect): do not
	dereference NULL ImapHandle:last_msg;
	(ir_preauth): parse PREAUTH greeting the same as OK.

	Fixes https://gitlab.gnome.org/GNOME/balsa/issues/23

2020-02-07  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Sort when new details about a message are found

	* libbalsa/mailbox.c (lbm_cache_message): if we get new
	information about the message, queue rethreading;
	(libbalsa_mailbox_finalize),
	(libbalsa_mailbox_close),
	(lbm_sort_idle_cb),
	(lbm_set_threading): rename
	LibBalsaMailboxPrivate:set_threading_idle_id to
	lbm_sort_idle_cb.

2020-02-02  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main-window: Simplify and make more robust

	* src/main-window.c (balsa_window_destroy): bw_idle_remove() has
	been removed, so remove the GSource directly;
	(bw_idle_replace): ditto;
	(bw_idle_cb): scrap some useless tests;
	(bw_index_changed_cb): check that priv->preview is non-NULL.

2020-02-02  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Reset messages-threaded in the open method instead of
	the close method.

	* libbalsa/mailbox.c (libbalsa_mailbox_open),
	(libbalsa_mailbox_close):

2020-02-02  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Build: Do not check for getaddrinfo

	* .gitignore: don't ignore config.h.in;
	* configure.ac: do not check for getaddrinfo;
	* meson.build: ditto.

2020-02-02  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Add a file that's needed in the autotools build to the repository

	* config.h.in:

2020-02-02  Albrecht Dreß  <albrecht.dress@arcor.de>

	Build tools: Remove test for libresolv

	* configure.ac:
	* meson.build:

2020-02-01  Albrecht Dreß  <albrecht.dress@arcor.de>

	[Patch] ical improvements

	* README, configure.ac, meson.build: require libical >= 2.0.0 instead of 3.0.0
	* libbalsa/rfc2445.c: libbalsa_vevent_reply(): add several
	optional fields to the “REPLY” message as to work around a M$
	Exchange/Outlook bug
	* src/balsa-mime-widget-vcalendar.c: balsa_vevent_widget():
	ref the VCal object containing the time zone data if we show
	the buttons for sending a reply; vevent_reply(): construct he
	reply as multipart/alternative, store it the the sentbox

2020-02-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Remove another idle handler when closing the mailbox

	* libbalsa/mailbox.c (libbalsa_mailbox_close): remove the idle
	handler for sorting the mailbox.

2020-02-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Do not sort until messages are threaded.

	* libbalsa/mailbox.c (lbm_set_threading_idle_cb): if threading
	is not complete, reschedule the handler; also drop
	lbm_check_and_sort()--it did not check, and sorting can be done
	in line.

2020-01-31  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Message threading cleanup

	Remove duplicate idle handler, and make
	libbalsa_mailbox_local_set_threading_info() private.

	* libbalsa/mailbox_local.c (libbalsa_mailbox_local_init),
	(libbalsa_mailbox_local_finalize),
	(libbalsa_mailbox_local_close_mailbox): drop thread_id, and use
	set_threading_id instead;
	(message_match_real): add test for msgno > 0;
	(lbm_local_set_threading_info): renamed from
	libbalsa_mailbox_local_set_threading_info now that it is
	private;
	(libbalsa_mailbox_local_set_threading): use the new name;
	(lbm_local_prepare_msgno): declare it void; no gboolean return
	value is needed;
	(libbalsa_mailbox_local_prepare_threading): drop the idle
	handler;
	* libbalsa/mailbox_local.h:
	libbalsa_mailbox_local_set_threading_info() is now private;
	* libbalsa/mailbox_mbox.c (parse_mailbox): do not call it.

2020-01-31  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-local: Fetch threading info when needed

	Add missing_info and missing_parent members to ThreadingInfo,
	and use them to decide when complete rethreading is needed.

	* libbalsa/mailbox_local.c (lbml_info_setup): initialize them to
	FALSE;
	(lbml_thread_messages): if both are TRUE, we must fetch
	threading info for all messages, in case the parent is present
	but has not been seen;
	(lbml_set_parent): set missing_info if the info is missing;
	(lbml_find_parent): set missing_paarent if the message has
	references but no parent was found.

2020-01-30  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Move messages-loaded from LibBalsaMailbox to LibBalsaMailboxLocal

	* libbalsa/mailbox.c (libbalsa_mailbox_close),
	(libbalsa_mailbox_set_has_unread_messages): drop the getter and
	setter;
	* libbalsa/mailbox.h: ditto;
	* libbalsa/mailbox_local.c (libbalsa_mailbox_local_close_mailbox),
	(lbml_load_messages_idle_cb),
	(libbalsa_mailbox_local_load_messages),
	(lbml_set_threading_idle_cb),
	(libbalsa_mailbox_local_set_threading): add and use
	LibBalsaMailboxLocalPrivate:messages_loaded.

2020-01-30  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-local: Improve threading

	* libbalsa/mailbox_local.c
	(lbm_local_cache_message),
	(libbalsa_mailbox_local_cache_message): Add a guard to the
	public method, and an unguarded static version; schedule
	rethreading if we have new threading info;
	(message_match_real), (lbml_load_messages_idle_cb),
	(lbm_local_prepare_msgno): use the static version;
	(lbm_local_get_message_with_msg_info): cache the threading info;
	(libbalsa_mailbox_local_set_threading): pass local instead of
	mailbox to lbml_set_threading_idle_cb (cosmetic);
	(libbalsa_mailbox_local_load_messages): set messages-loaded to
	FALSE before loading them.

2020-01-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/mailbox.c (libbalsa_mailbox_msgno_inserted): lock the
	mailbox from start to finish, not just to access the private
	structure.

2020-01-27  Albrecht Dreß  <albrecht.dress@arcor.de>

	Unify wrapped label creation

	* libbalsa/misc.[ch]: add new helper libbalsa_create_wrap_label()
	  for creating a label with word wrap and with or without markup;
	  libbalsa_create_grid_label(): add missing xalign
	* libbalsa/html.c, libbalsa/libbalsa-gpgme-cb.c,
	  libbalsa/libbalsa-gpgme-widgets.c,
	  src/balsa-mime-widget-message.c, src/balsa-mime-widget-text.c,
	  src/balsa-mime-widget-vcalendar.c, src/folder-conf.c,
	  src/sendmsg-window.c: use libbalsa_create_wrap_label()
	* src/pref-manager.c: use libbalsa_create_wrap_label(); remove
	  redundant calls to set default value
	* src/print-gtk.c: add_font_button(), add_margin_spinbtn(): add
	  missing xalign, remove default justify; add_margin_spinbtn():
	  do not wrap the (short) units string; create_options_group():
	  use libbalsa_create_wrap_label()

2020-01-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-local: Drop a redundant auxiliary structure

	* libbalsa/mailbox_local.c (lbml_set_threading_idle_cb),
	(libbalsa_mailbox_local_set_threading): Drop
	LbmlSetThreadingInfo, it's redundant; just pass the mailbox.

2020-01-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-local: Lock the mailbox in idle callbacks

	* libbalsa/mailbox_local.c (libbalsa_mailbox_local_finalize): no
	need to clear pointers and hendler ids in a finalize() method;
	(lbml_set_threading_idle_cb): lock and unlock the mailbox; no
	need to unref the mailbox; clear the handler id;
	(libbalsa_mailbox_local_set_threading): store the handler id,
	and do not ref the mailbox.

2020-01-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Lock the mailbox in idle callbacks

	* libbalsa/mailbox.c (lbm_msgno_filt_check_idle_cb),
	(lbm_set_threading_idle_cb):

2020-01-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Always use the idle callback to sort after changing the
	threading; save the handler id, to remove the source at finalize
	time instead of taking a ref on the mailbox.

	* libbalsa/mailbox.c (libbalsa_mailbox_finalize): remove the
	source, if the handler id has been stored and not cleared;
	(lbm_set_threading_idle_cb), (lbm_set_threading): clear and
	store, respectively, the handler id.

2020-01-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Header eye candy

	Albrecht's suggestion!

	* src/balsa-mime-widget-message.c (add_header_gchar): improve
	xalign property of header value labels.

2020-01-23  Albrecht Dreß  <albrecht.dress@arcor.de>

	Crypto eye candies

	* libbalsa/libbalsa-gpgme-widgets.c: improve xalign and yalign properties
	  of labels in signature and key details widgets
	* src/balsa-mime-widget-crypto.c: balsa_mime_widget_signature_widget:
	  wrap/align signature status in expander label;
	  balsa_mime_widget_crypto_frame: add tooltips to padlock icons
	* src/balsa-mime-widget-message.c: add_header_sigstate:
	  wrap/align signature status in headers box

2020-01-23  Albrecht Dreß  <albrecht.dress@arcor.de>

	Bug fix: S/MIME cert chain broken in identity key selection

	* libbalsa/libbalsa-gpgme-widgets.c: libbalsa_gpgme_key(): fall back
	  to the cert fingerprint for cb smime_show_chain() if the passed one is NULL
	* libbalsa/x509-cert-widget.c: x509_cert_chain_smime(): display message
	  if the cert fingerprint is NULL, requires a litte refactoring

2020-01-19  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: improve ensure-visible

	* src/balsa-index.c (balsa_index_ensure_visible): if either a
	message is selected or has the focus, scroll to it.

2020-01-19  Albrecht Dreß  <albrecht.dress@arcor.de>

	* README: fix package requirements
	* configure.ac, meson.build: require libical >= 3.0.0 (note:
	  not tested for Meson builds)
	* libbalsa/rfc2445.[ch]: mostly re-written, using the libical
	  parser and data types
	* src/balsa-mime-widget-vcalendar.c: add additional event items;
	  use the new rfc2445.h api
	* src/balsa-print-object-text.c: fix two pango test layout memory
	  leaks; add additional event items; use the new rfc2445.h api
	* src/print-gtk.c: fix part selection for printing text/calendar

2020-01-19  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: Simplify managing idle handlers

	* src/balsa-index.c (bndx_destroy): use
	g_source_remove_by_user_data() instead of saving ids;
	(balsa_index_scroll_on_open), (bndx_scroll_on_open_idle),
	(bndx_mailbox_changed_idle), (bndx_queue_draw_idle):
	we do not save the id;
	(bndx_mailbox_row_inserted_cb), (bndx_mailbox_row_inserted_idle):
	store the msgno in the BalsaIndex, instead of allocating a new
	structure;
	(bndx_expand_to_row_and_select), (bndx_expand_to_row_and_select_idle),
	(bndx_update_tree_idle), (balsa_index_update_tree):
	we do not need to add a reference to the BalsaIndex.

2020-01-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: Fix the "mostly" part of the previous commit, by
	using yet another idle handler to allow the tree-view's layout
	settle down.

	* src/balsa-index.c (bndx_expand_to_row_and_select_idle): new
	idle handler that scrolls to the desired row;
	(bndx_expand_to_row_and_select): use it, instead of scrolling
	immediately after expanding to the row.

2020-01-17  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: improve expand and collapse

	If a message is being viewed, it should still be visible after
	View:Expand-all (Ctrl e) or View:Collapse-all (Ctrl l). This
	commit achieves that for Expand-all, and mostly for
	Collapse-all.

	Only mostly: if the viewed message is near the bottom of the
	message index, Collapse-all may leave it a few rows below the current
	view of the message index. Unfortunately, if the current sort
	order puts the latest threads at the bottom, those are the most
	likely to be viewed!

	* src/balsa-index.c (bndx_selection_changed_idle),
	(bndx_scroll_on_open_idle), (bndx_mailbox_row_inserted_idle),
	(bndx_expand_to_row_and_select), (bndx_mailbox_changed_idle):
	actually, gtk_tree_view_expand_to_path() doesn't do what we want: it
	expands to the row, and the row itself, so we use it instead on
	the parent of the row, using bndx_expand_to_row() again;
	(bndx_update_tree_idle), (balsa_index_update_tree): do the
	re-expansion in an idle handler, after the tree-view's layout
	has settled down;
	(bndx_expand_to_row): restore it, but using
	gtk_tree_view_expand_to_path() to expand to the row's parent.

2020-01-16  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: Use gtk_tree_view_expand_to_path()

	instead of reimplementing it.

	* src/balsa-index.c (bndx_selection_changed_idle),
	(bndx_scroll_on_open_idle), (bndx_mailbox_row_inserted_idle),
	(bndx_expand_to_row_and_select), (bndx_mailbox_changed_idle):

2020-01-16  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Revert 90ee8bcc82d8ebdae0bd286212c21d1138531658

	Moving code to the mailbox-opening thread resulted in calls to
	Gtk from the thread; moving those calls to an idle handler in
	the main thread got things out of order. We need a more radical
	refactoring to get more work done in threads.

	This commit reverses the changes in commit
	90ee8bcc82d8ebdae0bd286212c21d1138531658, while keeping the
	later fixes.

	* src/balsa-index.c (bndx_scroll_on_open_idle),
	(balsa_index_load_mailbox_node):
	* src/main-window.c (bw_real_open_mbnode_idle_cb),
	(bw_real_open_mbnode_thread):

2020-01-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-local: Set messages-loaded

	* libbalsa/mailbox_local.c (libbalsa_mailbox_local_set_threading):
	set messages-loaded when the message tree is successfully restored
	from the cache.

2020-01-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Fix a few bugs

	* libbalsa/mailbox_local.c
	(libbalsa_mailbox_local_set_threading): thread messages only if
	there are some; otherwise just set messages-threaded;
	* src/balsa-index.c (bndx_scroll_on_open_idle): if the mailbox
	is empty, just show it and return;
	(balsa_index_scroll_on_open): do not special case an empty
	mailbox;
	* src/main-window.c (bw_real_open_mbnode_idle_cb),
	(balsa_window_real_open_mbnode): register open mailbox earlier,
	to avoid a race with an idle handler;
	(bw_real_open_mbnode_thread): add a warning.

2020-01-14  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Move some more code to a thread

	* src/balsa-index.c (bndx_scroll_on_open_idle): reschedule if
	the tree-view does not yet have a model;
	(balsa_index_scroll_on_open): do not bother scrolling if the
	mailbox is not showing any messages;
	(bndx_load_mailbox_node_idle): new idle handler for doing the
	Gtk-related part of the load;
	(balsa_index_load_mailbox_node): move the Gtk-related part of
	the load to the new idle handler.
	* src/main-window.c (bw_real_open_mbnode_idle_cb),
	(bw_real_open_mbnode_thread): move the call to
	balsa_index_load_mailbox_node() from the idle handler back to
	the thread.

2020-01-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: Use a low priority idle handler instead of a
	timeout to schedule scroll-on-open. That's enough to let
	GtkTreeView do its layout work before the scroll-on-open handler
	gets called.

	* src/balsa-index.c (bndx_scroll_on_open_idle),
	(balsa_index_scroll_on_open):

2020-01-12  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Stop using gtk_main_iteration_do()

	Stop using gtk_main_iteration_do() to make the progress bar
	update. It caused all sorts of side effects by processing other events
	while the one needed the progress indicator was held up. Several
	hacky guards against bad consequences can be dropped.

	The progress bar is now not updated in the UI if it is used to
	indicate progress in a task that is executed in the main thread.
	A task that takes long enough to need it most likely needs to be
	carried out in a thread, anyway, and should be re-implemented as
	such.

	Scroll-on-open apparently depended on some of the less bad
	consequences, and to make it work again the order of execution
	of idle handlers for:
	• message loading;
	• message threading;
	• optional thread expansion;
	has to be managed.

	* libbalsa/mailbox.c (lbm_changed_idle_cb),
	(lbm_run_filters_on_reception_idle_cb): drop the guards;
	* libbalsa/mailbox_local.c (lbml_set_threading),
	(lbml_set_threading_idle_cb),
	(libbalsa_mailbox_local_set_threading),
	(lbm_local_update_view_filter),
	(libbalsa_mailbox_local_prepare_threading): drop guards, and
	manage order of execution;
	* src/balsa-index.c (balsa_index_init), (bndx_scroll_on_open_idle),
	(balsa_index_scroll_on_open): manage order of execution;
	* src/main-window.c (balsa_window_progress_bar_set_fraction):
	this was misleadingly named;
	* src/main-window.h: rename it;
	* src/main.c (balsa_progress_set_fraction): use the new name.

2020-01-10  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Check for finalized mailbox

	* libbalsa/mailbox.c (lbm_changed_idle_cb):

2020-01-10  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-local: Check for error return value

	* libbalsa/mailbox_local.c
	(libbalsa_mailbox_local_set_threading): check the value returned
	by libbalsa_mailbox_prepare_threading(); if it is FALSE, the
	operation failed, perhaps because the mailbox was closed or
	finalized, so just quit.

2020-01-10  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Guard against mailbox being closed or finalized during a call to
	libbalsa_progress_set_fraction().

	* libbalsa/mailbox.c (lbm_run_filters_on_reception_idle_cb):
	* libbalsa/mailbox_local.c (lbm_local_update_view_filter),
	(libbalsa_mailbox_local_prepare_threading):

2020-01-09  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Check whether the mailbox was closed during
	set-fraction, while running filters on reception.

	* libbalsa/mailbox.c (lbm_run_filters_on_reception_idle_cb):

2020-01-09  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main-window: Really disconnect from a network monitor signal

	* src/main-window.c (balsa_window_init): store the network
	monitor's "network-changed" signal handler id;
	(balsa_window_destroy): use it to disconnect the handler.

2020-01-09  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: when closing a mailbox, remove the source of any
	pending run-filters-on-reception idle callback.

	* libbalsa/mailbox.c (libbalsa_mailbox_close): remove the
	source, if any;
	(libbalsa_mailbox_run_filters_on_reception): check that no
	callback is pending.

2020-01-09  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: minor cleanup

	* src/balsa-index.c (bndx_scroll_on_open_idle): rename 'total'
	to 'n_children', as in:
	(balsa_index_ensure_visible): use
	gtk_tree_path_new_from_indices() instead of
	gtk_tree_model_iter_nth_child() and gtk_tree_model_get_path().

2020-01-08  Peter Bloomfield  <pbloomfield@bellsouth.net>

	libbalsa/x509-cert-widget: keep scan-build happy

	* libbalsa/x509-cert-widget.c (x509_cert_chain_smime): keep
	  scan-build happy by checking for NULL chain.

2020-01-08  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: do not scroll to first-unread message when
	LibBalsaMailbox::changed signal is received.

	It is not needed, and it blocks scroll-on-open from scrolling to
	the first-unread message.

	* src/balsa-index.c (bndx_mailbox_changed_idle): do not clear
	LibBalsaMailbox:first_unread; and do not scroll to it, either.

2020-01-07  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main-window: Avoid recursive entry

	to an idle callback. It happens because of a call to
	libbalsa_progress_set_fraction(), which then results in a call
	to gtk_main_iteration_do(); the current event is apparently
	still in the queue, so it gets re-entered.

	The progress indicator needs to be rethought!

	* src/main-window.c (bw_real_open_mbnode_idle_cb),
	(balsa_window_real_open_mbnode):

2020-01-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	libbalsa-mailbox: Pack booleans in contiguous 1-bit fields

	It saves run-time storage, and also reduces binary code size (at
	least on x-86-64, with gcc -O2).
	Small differences in both cases!

	* libbalsa/mailbox.c (libbalsa_mailbox_set_msg_tree_changed),
	(libbalsa_mailbox_set_is_directory),
	(libbalsa_mailbox_set_readonly),
	(libbalsa_mailbox_set_no_reassemble),
	(libbalsa_mailbox_set_has_unread_messages),
	(libbalsa_mailbox_set_messages_loaded),
	(libbalsa_mailbox_set_messages_threaded): Make sure that
	gboolean arguments really are boolean.

2020-01-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Fix expand-on-open

	See https://mail.gnome.org/archives/balsa-list/2019-August/msg00008.html
	Because of a race among idle callbacks, we could call
	gtk_tree_view_expand_all() before the message tree was populated
	and threaded. So when it was populated and threaded, threads
	were in the default state, collapsed.

	* libbalsa/mailbox.c (libbalsa_mailbox_close), (lbm_set_threading),
	(libbalsa_mailbox_get_messages_loaded),
	(libbalsa_mailbox_get_messages_threaded),
	(libbalsa_mailbox_set_has_unread_messages),
	(libbalsa_mailbox_set_messages_loaded),
	(libbalsa_mailbox_set_messages_threaded): add messages_loaded
	and messages_threaded members to the private structure, and
	manage access to them;
	* libbalsa/mailbox.h: add accessors;
	* libbalsa/mailbox_imap.c (libbalsa_mailbox_imap_set_threading):
	set messages_threaded;
	* libbalsa/mailbox_local.c (lbml_load_messages_idle_cb): set
	messages_loaded;
	(lbml_set_threading): if messages have been loaded, set
	messages_threaded;
	* src/balsa-index.c (bndx_scroll_on_open_idle): if messages have
	not been loaded and threaded, reschedule the timeout;
	(balsa_index_scroll_on_open): use a 10 millisecond timeout
	instead of an idle call, to avoid a flurry of rescheduling.

2020-01-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main-window: Disconnect from a network monitor signal

	to avoid scheduling an idle callback after some objects have
	been finalized.

	* src/main-window.c (balsa_window_destroy):

2020-01-02  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: Store idle handler ids

	and use them to remove the corresponding sources at dispose
	time, instead of taking a strong reference to the BalsaIndex and
	then testing whether it is the last reference.

	* src/balsa-index.c (bndx_destroy), (bndx_selection_changed_idle),
	(bndx_selection_changed), (bndx_scroll_on_open_idle),
	(balsa_index_scroll_on_open), (bndx_queue_draw_idle),
	(bndx_mailbox_changed_idle), (bndx_mailbox_changed_cb):

2019-11-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Address book editor: do not crash if no address books are
	available for editing.

	* src/ab-main.c (bab_set_intial_address_book), (main): check for
	NULL address book list.

2019-11-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	libbalsa_message_body_get_mime_type() is guaranteed to return a
	lower case string, so we can safely use strcmp().

	* libbalsa/body.c (libbalsa_message_body_set_parts),
	(libbalsa_message_body_get_pixbuf),
	(libbalsa_message_body_is_flowed):
	* libbalsa/html.c (lbh_cid_cb), (libbalsa_html_type):
	* src/balsa-message.c (mpart_content_name), (display_part),
	(part_create_menu), (libbalsa_can_display), (preferred_part),
	(get_crypto_content_icon), (libbalsa_msg_try_decrypt),
	(libbalsa_msg_perform_crypto_real):
	* src/balsa-mime-widget.c (balsa_mime_widget_new):
	* src/balsa-print-object.c (balsa_print_objects_append_from_body):
	* src/print-gtk.c (find_alt_part), (scan_body):

2019-11-17  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix handling of Multipart/Related

	* libbalsa/body.[ch]: implement a new helper function
	  libbalsa_message_body_mp_related_root() returning the root object
	  of a multipart/related;
	* libbalsa/html.c: pass the HTML body to the Webkit callbacks
	  when printing;
	* src/balsa-message.c: use the new helper for fetching the
	  multipart/related root object;
	* src/print-gtk.c: properly handle multipart/related

2019-11-14  Albrecht Dreß  <albrecht.dress@arcor.de>

	Display S/MIME and TLS certificate chains

	The patch addresses the following:

	S/MIME signatures:
	Currently, Balsa shows the certificate data and the issuer's
	name, serial and chain id.  It is not possible to view the entire
	certification chain.
	The patch adds a button to the issuer section of a S/MIME
	signature, which opens a new dialogue, showing the certification
	tree in the upper and the details of the selected certificate in
	the lower part.  I.e. it is now possible to inspect/verify the
	whole tree, up to the root certificate.  If you have any S/MIME
	signed messages in a mailbox, you can simply test this feature.

	TLS:
	When opening an encrypted SMTP, POP3 or IMAP connection, balsa
	shows a dialogue with the untrusted certificate, asking whether
	the user accepts or rejects it.
	With the patch, if the untrusted certificate is not self-signed
	and the issuer certificate(s) can be loaded, the whole chain
	is displayed as above for inspection.  For testing, you
	could temporarily disable the trust for your provider's root
	certificate, which should pop up the modified dialogue.

	* libbalsa/Makefile.am, libbalsa/meson.build: add new source and header file
	* libbalsa/libbalsa-gpgme-widgets.[ch]: add button to S/MIME
	signature widget; implement button callback for displaying the
	certificate chain
	* libbalsa/libbalsa.c: replace printf() by g_debug()
	calls in ask_idle() and libbalsa_ask(); use new api for
	creating certificate (chain) widget; delete stuff shifted to
	x509-cert-widget.[ch]
	* libbalsa/x509-cert-widget.[ch]: implement two functions for
	creating a certificate (chain) widget either from the S/MIME
	certificate fingerprint, or from a GTlsCertificate.  If the
	passed certificate is self-signed or if the issuer cannot
	be determined, the function returns a widget containing the
	certificate information.  Otherwise, the returned widget is a
	vertical GtkBox, containing the certificate chain tree view in
	the upper and a GtkStack in the lower part.  The latter displays
	the certificate selected in the tree view.
	* src/save-restore.c: add certificate chain dialogue to the
	geometry manager

2019-11-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	meson.build: Use dependency()'s capabilities

	* meson.build: dependency() can find gpgme's configuration, (it's
	  not limited to pkg-config) so we do not need the custom code.

2019-11-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	meson.build: Use meson's "optimization" option

	And avoid a warning from ninja.

	* meson.build: Use meson's "optimization" option instead of the
	  "-O2" compiler flag.

2019-11-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	meson.build: Do not enter endless loop

	* meson.build:  With meson version 0.52,
	  "run_command('rm', '-f', conftest_htm)" makes ninja go into
	  an endless loop, so we'll skip it, and just leave conftest.htm
	  in the current build dir.

2019-11-09  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Fix a mailbox-threading bug.

	When adding a new mailbox, we used the UI to set its threading
	type; unfortunately, the UI sets the threading on the currently
	shown mailbox instead. Spotted when the new local mailbox should
	have threading enabled, and the current mailbox is IMAP and
	does not support threading.

	* libbalsa/mailbox.c (libbalsa_mailbox_set_threading_type): call
	libbalsa_mailbox_set_threading() if the mailbox is non-NULL,
	instead of making the caller do it;
	* src/balsa-index.c (balsa_index_set_thread_messages): do not call
	libbalsa_mailbox_set_threading();
	* src/mailbox-conf.c: drop BalsaMailboxConfView:mailbox--no one
	is now using it;
	(mailbox_conf_view_new_full): no one is now using
	BalsaMailboxConfView:mailbox;
	(mailbox_conf_view_check): set the threading type directly on
	the mailbox, instead of using the UI;
	* src/main-window.c: drop balsa_window_set_thread_messages, as
	it is no longer needed;
	(bw_enable_mailbox_menus): include the guts of
	balsa_window_set_thread_messages in-line;
	* src/main-window.h: drop balsa_window_set_thread_messages.

2019-10-19  Pawel Salek  <pawsa0@gmail.com>

	* NEWS, configure.ac, meson.build: release balsa-2.5.9

2019-10-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	More efforts to get HTML parts to fill the pane

	* libbalsa/html.c (lbh_web_view_new): connect to "load-changed"
	signal;
	(lbh_load_changed_cb): call-back for it; if the load has
	finished, call gtk_widget_queue_resize();
	* src/balsa-message.c (add_part): pack the widget with
	expand=FALSE, so that an HTML part's v-expand takes precedence.

2019-10-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Do not use archaic 200px default height; now that we set
	GtkWidget:vexpand to TRUE, the natural height works better.

	* libbalsa/html.c: for cosmetics, define LBH_NATURAL_SIZE as -1;
	(lbh_web_view_new): use it for the height;
	(libbalsa_html_print_bitmap): ditto;
	(libbalsa_html_new): use it for the width.

2019-10-12  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/html.c (lbh_web_view_new): set v-expand on the
	web-view to TRUE, so that HTML mail uses the whole pane.

2019-10-10  Pawel Salek  <pawsa0@gmail.com>

	* NEWS, configure.ac, meson.build: release balsa-2.5.8

2019-10-11  Peter Bloomfield  <pbloomfield@bellsouth.net>

	libbalsa-html: Look deeper to find the WebKitWebView

	* libbalsa/html.c (libbalsa_html_new), (lbh_get_web_view_helper),
	(lbh_get_web_view): if the widget is not a WebKitWebView but is
	a GtkContainer, look at all its descendants for a WebKitWebView.

2019-10-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Build: we need -Wformat for -Wformat-security to be effective

	* configure.ac:
	* meson.build:

2019-10-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Build: GTimeVal, used in GtkSourceView-3, is deprecated in glib
	version 2.62; we will use GtkSourceView-4 if available, which
	doesn't use GTimeVal, or otherwise continue to use GtkSourceView-3
	with -DGLIB_VERSION_MIN_REQUIRED=GLIB_VERSION_2_48 to suppress the
	deprecation warning.

	* configure.ac:
	* meson.build:

2019-09-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	ab-main: Use GMenu API instead of GtkBuilder

	* src/ab-main.c (bab_cleanup), (set_address_book_menu_items),
	(file_delete_activated):
	* ui/ab-main.ui: no need for place-holder

2019-09-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	address-book-config: Do not crash

	* src/address-book-config.c (edit_book_response): destroy the
	dialog as the last step; otherwise the struct is freed before we
	use it.

2019-09-14  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mime-widget: subclass GtkBox instead of GObject

	This makes BalsaMimeWidget inherit from GtkBox, so it is
	actually a widget. A subclass that used to create a vertical
	GtkBox can use the BalsaMimeWidget itself. Other subclasses can
	add their custom widget to the BalsaMimeWidget.

	* src/balsa-message.c (bm_find_scroll_to_rectangle),
	(bm_find_entry_changed_cb), (bm_find_again), (balsa_message_init),
	(balsa_message_destroy), (part_info_init), (add_part),
	(gtk_tree_hide_func), (balsa_message_current_part_widget),
	(balsa_message_can_select), (balsa_message_grab_focus),
	(balsa_message_can_zoom), (balsa_message_zoom),
	(balsa_message_find_in_message):
	* src/balsa-mime-widget-crypto.c (balsa_mime_widget_new_signature),
	(balsa_mime_widget_new_pgpkey):
	* src/balsa-mime-widget-image.c (img_check_size),
	(balsa_mime_widget_new_image):
	* src/balsa-mime-widget-message.c (balsa_mime_widget_new_message),
	(bmw_message_extbody_url), (bmw_message_extbody_mail),
	(balsa_mime_widget_new_message_tl):
	* src/balsa-mime-widget-multipart.c
	(balsa_mime_widget_new_multipart):
	* src/balsa-mime-widget-text.c (balsa_mime_widget_new_text),
	(bm_widget_new_html), (bm_widget_new_vcard):
	* src/balsa-mime-widget-vcalendar.c
	(balsa_mime_widget_new_vcalendar):
	* src/balsa-mime-widget.c (balsa_mime_widget_init),
	(balsa_mime_widget_new), (balsa_mime_widget_new_unknown):
	* src/balsa-mime-widget.h:

2019-09-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mime-widget-text: Actually show the context menu

	This time, the HTML widget's context menu.

	* src/balsa-mime-widget-text.c (bmwt_populate_popup_menu),
	(bmwt_populate_popup_cb):

2019-09-12  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mime-widget-text: Actually show the context menu

	* src/balsa-mime-widget-text.c (balsa_mime_widget_new_text):
	drop an obsolete signal connection;
	(text_view_populate_popup): show the popup menu.

2019-09-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mime-widget-text: Subclass BalsaMimeWidget

	Make it a class with useful info in the struct, instead of
	extensively using GObject data.

	* src/balsa-mime-widget-text.c (balsa_mime_widget_text_finalize),
	(balsa_mime_widget_text_class_init), (balsa_mime_widget_text_init),
	(balsa_mime_widget_new_text), (create_text_widget),
	(fix_text_widget), (structured_phrases_toggle),
	(text_view_url_popup), (text_view_populate_popup),
	(store_button_coords), (check_over_url), (prepare_url_offsets),
	(url_found_cb), (check_call_url), (find_url), (handle_url),
	(free_url), (draw_cite_bar_real), (draw_cite_bars),
	(balsa_gtk_html_popup), (balsa_gtk_html_button_press_cb),
	(bm_widget_new_vcard), (check_text_encoding),
	(fill_text_buf_cited):
	* src/balsa-mime-widget-text.h:

2019-09-02  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mime-widget-image: Simplify resizing

	Catch the size-allocate signal only for BalsaMimeWidgetImage
	widgets.

	* src/balsa-message.c (balsa_message_init):
	* src/balsa-mime-widget-image.c (balsa_mime_widget_image_init),
	(balsa_mime_widget_image_dispose), (img_check_size),
	(img_size_allocate_cb), (balsa_mime_widget_new_image):
	* src/balsa-mime-widget-image.h:

2019-09-02  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mime-widget-image: Declare BalsaMimeWidgetImage final

	It was already private, so no accessors are needed.

	* src/balsa-mime-widget-image.h:

2019-08-31  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mime-widget: Declare BalsaMimeWidget derivable

	Make the struct private, and provide accessors for the widget,
	container, and header_widget members.

	* src/balsa-message.c (bm_find_scroll_to_rectangle),
	(bm_find_entry_changed_cb), (bm_find_again), (balsa_message_init),
	(add_part), (gtk_tree_hide_func), (hide_all_parts), (select_part),
	(balsa_message_current_part_widget), (balsa_message_can_select),
	(balsa_message_grab_focus), (balsa_message_can_zoom),
	(balsa_message_zoom), (balsa_message_find_in_message):
	* src/balsa-mime-widget-callbacks.c
	(balsa_mime_widget_limit_focus), (balsa_mime_widget_unlimit_focus):
	* src/balsa-mime-widget-crypto.c (balsa_mime_widget_new_signature),
	(balsa_mime_widget_new_pgpkey):
	* src/balsa-mime-widget-image.c (balsa_mime_widget_new_image):
	* src/balsa-mime-widget-message.c (balsa_mime_widget_new_message),
	(bmw_message_extbody_url), (bmw_message_extbody_mail),
	(balsa_mime_widget_new_message_tl), (bmw_message_set_headers_d),
	(bmw_message_set_headers):
	* src/balsa-mime-widget-multipart.c
	(balsa_mime_widget_new_multipart):
	* src/balsa-mime-widget-text.c (balsa_mime_widget_new_text),
	(bm_widget_new_html), (bm_widget_new_vcard):
	* src/balsa-mime-widget-vcalendar.c
	(balsa_mime_widget_new_vcalendar):
	* src/balsa-mime-widget.c (balsa_mime_widget_init),
	(balsa_mime_widget_class_init), (balsa_mime_widget_new),
	(balsa_mime_widget_new_unknown), (vadj_change_cb),
	(balsa_mime_widget_get_widget), (balsa_mime_widget_get_container),
	(balsa_mime_widget_get_header_widget),
	(balsa_mime_widget_set_widget), (balsa_mime_widget_set_container),
	(balsa_mime_widget_set_header_widget):
	* src/balsa-mime-widget.h:

2019-08-25  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-print-object-text.c
	(balsa_print_object_text_calendar): Use ngettext() for plural
	forms of strings.

2019-08-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	imap-handle: Use modern macros to declare and define ImapMboxHandle

	* libbalsa/imap/imap-handle.c (imap_mbox_handle_init),
	(imap_mbox_handle_class_init), (imap_mbox_handle_new),
	(imap_mbox_handle_finalize):
	* libbalsa/imap/imap-handle.h:

2019-08-14  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-message: Use "balsa_message" consistntly as its
	identifier, and use "bm_" consistently as the prefix for static
	functions.

	* src/balsa-message.c (balsa_headers_attachments_popup),
	(bm_header_tl_buttons), (bm_on_set_style), (bm_find_set_status),
	(bm_find_scroll_to_rectangle), (bm_find_scroll_to_selection),
	(bm_find_cb), (bm_find_entry_changed_cb), (bm_find_again),
	(bm_find_bar_new), (bm_find_pass_to_entry),
	(bm_disable_find_entry), (balsa_message_init),
	(balsa_message_destroy), (balsa_message_new),
	(tree_activate_row_cb), (tree_mult_selection_popup),
	(tree_menu_popup_key_cb), (tree_button_press_cb), (bm_clear_tree),
	(balsa_message_set), (balsa_message_save_current_part),
	(bm_set_embedded_hdr), (balsa_message_set_displayed_headers),
	(balsa_message_set_wrap), (display_headers), (part_info_init),
	(atattchments_menu_cb), (add_to_attachments_popup),
	(toggle_all_inline_cb), (add_toggle_inline_menu_item),
	(display_part), (display_parts), (display_face), (display_content),
	(bm_next_part_info), (balsa_message_next_part),
	(balsa_message_has_next_part), (bm_previous_part_info),
	(balsa_message_previous_part), (balsa_message_has_previous_part),
	(part_info_from_body), (add_body), (add_multipart_digest),
	(add_multipart_mixed), (add_multipart), (add_part),
	(hide_all_parts), (select_part),
	(balsa_message_current_part_widget), (balsa_message_can_select),
	(balsa_message_grab_focus), (balsa_message_can_zoom),
	(balsa_message_zoom), (bm_scan_signatures),
	(message_recheck_crypto_cb), (balsa_message_find_in_message),
	(balsa_message_get_wrap_text), (balsa_message_get_focus_state),
	(balsa_message_get_scroll), (balsa_message_get_bm_widget),
	(balsa_message_get_message), (balsa_message_get_shown_headers),
	(balsa_message_get_face_box), (balsa_message_get_tree_view),
	(balsa_message_set_focus_state), (balsa_message_set_face_box):

2019-08-14  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-message: Add the attach-button to the struct instead of
	using GObject-data

	* src/balsa-message.c (bm_header_tl_buttons),
	(balsa_message_set_displayed_headers), (display_content):

2019-08-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	rfc 2445: Set a struct as GObject-data instead of three separate
	items.

	* libbalsa/rfc2445.c (libbalsa_vcal_attendee_to_str),
	(libbalsa_vcal_attendee_rsvp), (cal_address_2445_to_lbaddress):

2019-08-12  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-imap: Store cache-manager in the object instead of
	using GObject-data.

	* libbalsa/mailbox_imap.c (libbalsa_mailbox_imap_finalize),
	(libbalsa_mailbox_imap_open), (libbalsa_mailbox_imap_close):

2019-08-12  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Store message-partial ids in the object instead of
	using GObject-data.

	* libbalsa/mailbox.c (lbm_try_reassemble_idle),
	(libbalsa_mailbox_try_reassemble):

2019-08-12  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Drop redundant dynamic cast

	* src/mailbox-node.c (balsa_mailbox_node_finalize):

2019-08-12  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Unref structure members in a dispose method

	* libbalsa/libbalsa-vfs.c (libbalsa_vfs_class_init),
	(libbalsa_vfs_dispose), (libbalsa_vfs_finalize):

2019-08-12  Peter Bloomfield  <pbloomfield@bellsouth.net>

	In calls to g_signal_connect_swapped(), do not cast data using
	G_OBJECT(data).

	The argument is a gpointer, so the cast is redundant.

	* src/filter-run-dialog.c (balsa_filter_run_dialog_init):

2019-08-11  Peter Bloomfield  <pbloomfield@bellsouth.net>

	In calls to g_signal*(), do not cast object using
	G_OBJECT(object).

	The argument is a gpointer, so the cast is redundant.

	* libbalsa/address.c (libbalsa_address_get_edit_widget):
	* libbalsa/filter-funcs.c (libbalsa_filter_list_new):
	* libbalsa/folder-scanners.c (libbalsa_scanner_imap_dir),
	(imap_tree_scan):
	* libbalsa/identity.c (setup_ident_frame):
	* libbalsa/imap/imap-commands.c (imap_mbox_select_unlocked):
	* libbalsa/imap/imap-handle.c (imap_mbox_connect),
	(imap_mbox_handle_get_delim), (ir_list_lsub), (ir_exists),
	(ir_expunge):
	* libbalsa/libbalsa-gpgme-cb.c (lb_gpgme_select_key):
	* libbalsa/libbalsa-progress.c
	(libbalsa_progress_dialog_ensure_real), (create_progress_widget):
	* libbalsa/libbalsa-vfs.c (libbalsa_vfs_mime_button):
	* libbalsa/macosx-helpers.c (libbalsa_macosx_menu),
	(libbalsa_macosx_menu_for_parent):
	* libbalsa/mailbox.c (libbalsa_mailbox_progress_notify):
	* libbalsa/mailbox_imap.c
	(libbalsa_mailbox_imap_get_selected_handle), (lbm_imap_check):
	* libbalsa/mailbox_pop3.c (libbalsa_mailbox_pop3_startup):
	* libbalsa/send.c (lbs_process_queue_init_session):
	* libbalsa/server.c (libbalsa_server_set_username),
	(libbalsa_server_set_host), (libbalsa_server_config_changed),
	(lbs_get_password):
	* libbalsa/smtp-server.c (libbalsa_smtp_server_dialog):
	* libinit_balsa/assistant_helper.c (balsa_init_add_grid_entry):
	* libinit_balsa/assistant_init.c (balsa_initdruid_apply),
	(balsa_initdruid):
	* libinit_balsa/assistant_page_defclient.c
	(balsa_druid_page_defclient_init):
	* libinit_balsa/assistant_page_directory.c
	(balsa_druid_page_directory_init):
	* libinit_balsa/assistant_page_user.c (balsa_druid_page_user):
	* libnetclient/net-client.c (net_client_start_tls):
	* libnetclient/test/tests.c (test_basic_crypt), (test_smtp),
	(test_pop3):
	* src/ab-main.c (bab_window_list_new), (bab_get_edit_button_box),
	(bab_get_filter_box), (bab_window_new), (main):
	* src/ab-window.c (balsa_ab_window_list), (balsa_ab_window_init),
	(balsa_ab_window_menu_changed):
	* src/address-book-config.c (create_local_dialog),
	(create_generic_dialog), (create_osmo_dialog),
	(balsa_address_book_add_menu):
	* src/balsa-index.c (bndx_selection_changed), (bndx_row_activated),
	(bndx_compose_foreach), (bndx_compose_from_list),
	(create_stock_menu_item), (bndx_changed_find_row):
	* src/balsa-mblist.c (balsa_mblist_init),
	(balsa_mblist_default_signal_bindings), (bmbl_store_redraw_mbnode),
	(balsa_mblist_mru_option_menu):
	* src/balsa-message.c (bm_header_tl_buttons), (balsa_message_init),
	(tree_mult_selection_popup), (add_to_attachments_popup),
	(add_toggle_inline_menu_item), (part_create_menu), (select_part),
	(create_mdn_dialog):
	* src/balsa-mime-widget-crypto.c
	(balsa_mime_widget_signature_widget), (create_import_keys_widget):
	* src/balsa-mime-widget-image.c (balsa_mime_widget_new_image):
	* src/balsa-mime-widget-message.c (bmw_message_extbody_url),
	(bmw_message_extbody_mail), (bm_header_extend_popup),
	(bmw_message_set_headers_d):
	* src/balsa-mime-widget-text.c (balsa_mime_widget_new_text),
	(text_view_url_popup), (text_view_populate_popup),
	(bmwt_populate_popup_menu), (fill_text_buf_cited):
	* src/balsa-mime-widget-vcalendar.c (balsa_vevent_widget):
	* src/balsa-mime-widget.c (balsa_mime_widget_new),
	(balsa_mime_widget_new_unknown):
	* src/filter-edit-callbacks.c (add_button), (add_check),
	(get_field_frame), (build_type_notebook), (fe_edit_condition):
	* src/filter-edit-dialog.c (fe_build_option_menu),
	(build_left_side), (build_match_page), (build_action_page),
	(build_right_side), (filters_edit_dialog):
	* src/filter-export-dialog.c (filters_export_dialog):
	* src/filter-run-dialog.c (selected_filters_new),
	(balsa_filter_run_dialog_init):
	* src/folder-conf.c (folder_conf_clicked_ok),
	(folder_conf_imap_node), (folder_conf_imap_sub_node):
	* src/information-dialog.c (balsa_information_list):
	* src/mailbox-conf.c (run_mailbox_conf),
	(create_local_mailbox_dialog):
	* src/mailbox-node.c (imap_scan_attach_mailbox),
	(balsa_mailbox_node_new_from_mailbox),
	(balsa_mailbox_node_new_from_dir),
	(balsa_mailbox_node_new_from_config),
	(balsa_mailbox_node_new_imap_node),
	(balsa_mailbox_node_new_imap_folder), (add_menu_entry),
	(balsa_mailbox_node_get_context_menu):
	* src/main-window.c (bw_enable_filter), (bw_disable_filter),
	(bw_create_index_widget), (new_message_activated),
	(balsa_window_new), (bw_check_mailbox_list), (bw_find_real):
	* src/message-window.c (destroy_message_window):
	* src/pref-manager.c (pm_combo_box_new), (create_pref_option_menu),
	(server_add_menu_widget),
	(pm_grid_add_remote_mailbox_servers_group),
	(pm_grid_add_outgoing_mail_group), (open_preferences_manager):
	* src/print-gtk.c (message_prefs_widget):
	* src/sendmsg-window.c (address_book_cb),
	(balsa_sendmsg_destroy_handler), (sw_get_user_codeset),
	(add_attachment), (add_urlref_attachment), (sw_attach_dialog),
	(create_info_pane), (sw_attachment_list), (create_text_area),
	(create_lang_menu), (sendmsg_window_set_field),
	(sw_include_file_activated), (sendmsg_window_new):
	* src/store-address.c (balsa_store_address_from_messages),
	(balsa_store_address):
	* src/toolbar-prefs.c (customize_dialog_cb), (create_toolbar_page):

2019-08-10  Peter Bloomfield  <pbloomfield@bellsouth.net>

	In calls to g_object_unref(), do not cast object using
	G_OBJECT(object).

	The argument is a gpointer, so the cast is redundant.

	* libbalsa/autocrypt.c (autocrypt_db_dialog_run):
	* libbalsa/body.c (libbalsa_message_body_free):
	* libbalsa/gmime-multipart-crypt.c (g_mime_gpgme_mpe_decrypt):
	* libbalsa/html.c (html2text):
	* libbalsa/libbalsa-gpgme-cb.c (lb_gpgme_select_key):
	* libbalsa/libbalsa.c (ask_cert_real):
	* libbalsa/mailbox_imap.c (imap_exists_idle),
	(libbalsa_mailbox_imap_get_message):
	* libbalsa/mailbox_pop3.c (pop_handler_close),
	(libbalsa_mailbox_pop3_startup), (libbalsa_mailbox_pop3_check):
	* libbalsa/rfc3156.c (libbalsa_sign_mime_object),
	(libbalsa_encrypt_mime_object),
	(libbalsa_sign_encrypt_mime_object),
	(libbalsa_body_check_signature), (libbalsa_body_decrypt),
	(libbalsa_rfc2440_verify), (libbalsa_rfc2440_decrypt):
	* libbalsa/send.c (msg_queue_item_destroy),
	(send_message_info_destroy), (add_mime_body_plain),
	(balsa_send_message_real), (libbalsa_message_create_mime_message),
	(libbalsa_fill_msg_queue_item_from_queu):
	* libnetclient/net-client-pop.c (net_client_pop_new):
	* libnetclient/net-client-siobuf.c (net_client_siobuf_new):
	* libnetclient/net-client-smtp.c (net_client_smtp_new):
	* libnetclient/net-client.c (net_client_new),
	(net_client_shutdown), (net_client_set_cert_from_pem),
	(net_client_set_cert_from_file), (net_client_start_tls),
	(net_client_finalise):
	* src/ab-window.c (balsa_ab_window_get_recipients),
	(balsa_ab_window_swap_real), (balsa_ab_window_activate_address):
	* src/balsa-message.c (balsa_message_init),
	(balsa_message_set_embedded_hdr), (display_part),
	(handle_mdn_request), (mdn_dialog_response),
	(message_recheck_crypto_cb):
	* src/balsa-mime-widget-crypto.c (balsa_mime_widget_new_pgpkey):
	* src/balsa-mime-widget-message.c (extbody_send_mail):
	* src/balsa-mime-widget-vcalendar.c (vevent_reply):
	* src/balsa-print-object-decor.c (bpo_decor_print_frame_begin):
	* src/balsa-print-object-default.c
	(balsa_print_object_default_full):
	* src/balsa-print-object-header.c
	(balsa_print_object_header_new_real),
	(balsa_print_object_header_crypto),
	(balsa_print_object_header_draw):
	* src/balsa-print-object-text.c (balsa_print_object_text_plain),
	(balsa_print_object_text), (balsa_print_object_text_draw):
	* src/mailbox-conf.c (mailbox_conf_add):
	* src/print-gtk.c (print_header_footer), (begin_print),
	(message_print_page_setup), (message_print):
	* src/save-restore.c (config_global_load):
	* src/sendmsg-window.c (balsa_attach_info_finalize),
	(balsa_sendmsg_destroy_handler), (collect_for_quote),
	(sw_save_draft), (send_message_handler), (message_postpone):

2019-08-10  Peter Bloomfield  <pbloomfield@bellsouth.net>

	In calls to g_object_ref(), do not cast object using
	G_OBJECT(object).

	The macro now casts the return value to the type of the
	argument, so casting away its actual type is unhelpful.

	* libbalsa/mailbox_imap.c (imap_exists_cb):
	* libbalsa/rfc3156.c (libbalsa_sign_encrypt_mime_object):
	* libbalsa/send.c (libbalsa_fill_msg_queue_item_from_queu):
	* src/balsa-message.c (message_recheck_crypto_cb):
	* src/balsa-print-object-header.c
	(balsa_print_object_header_new_real):
	* src/folder-conf.c (create_imap_folder_dialog):
	* src/print-gtk.c (message_print):
	* src/sendmsg-window.c (sw_buffer_swap):

2019-08-09  Peter Bloomfield  <pbloomfield@bellsouth.net>

	In calls to g_object_[gs]et(), do not cast object using
	G_OBJECT(object).

	The argument is a gpointer, so the cast is redundant.

	* libbalsa/files.c (libbalsa_icon_finder):
	* libbalsa/libbalsa.c (libbalsa_is_cert_known), (ask_cert_real),
	(get_gnutls_cert):
	* libbalsa/mime.c (get_quote_tag):
	* libbalsa/server-config.c (libbalsa_server_cfg_new):
	* libnetclient/test/tests.c (check_cert):
	* src/balsa-app.c (ask_password_real):
	* src/balsa-mblist.c (balsa_mblist_init):
	* src/balsa-message.c (balsa_message_init):
	* src/balsa-mime-widget-message.c (balsa_mime_widget_new_message):
	* src/balsa-mime-widget-text.c (structured_phrases_toggle):
	* src/balsa-mime-widget.c (balsa_mime_widget_new):
	* src/main-window.c (balsa_window_new):
	* src/pref-manager.c (apply_prefs):
	* src/sendmsg-window.c (sw_attachment_list), (sw_can_undo_cb),
	(sw_can_redo_cb):
	* src/toolbar-factory.c (tm_populate):

2019-08-03  Albrecht Dreß  <albrecht.dress@arcor.de>

	SMTP logging

	See
	<URL:https://mail.gnome.org/archives/balsa-list/2019-July/msg00005.html>

	When Balsa sends a message to a local or remote SMTP server,
	a feedback is given only on failure.  However, sometimes it is necessary
	to trace sent messages on the SMTP server.

	* libbalsa/send.c: new function balsa_send_message_syslog(),
	  changed API of net_client_smtp_send_msg();
	* libnetclient/net-client-smtp.[ch]: extend API of net_client_smtp_send_msg()
	  for optionally passing the final SMTP server reply.

2019-08-03  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-imap: Clear search filter when mailbox is closed

	See
	<URL:https://mail.gnome.org/archives/balsa-list/2019-July/msg00006.html>

	* libbalsa/mailbox_imap.c (libbalsa_mailbox_imap_close): unref
	search filter.

2019-07-30  Peter Bloomfield  <pbloomfield@bellsouth.net>

	folder-conf: Refactor dialog data strucures

	* src/folder-conf.c (folder_conf_destroy_common_data),
	(folder_conf_response), (validate_folder),
	(imap_update_subscriptions), (folder_conf_clicked_ok),
	(on_subscription_toggled), (create_imap_folder_dialog),
	(folder_conf_imap_subscriptions), (folder_data_subscribed_toggled),
	(folder_conf_imap_node), (validate_sub_folder), (browse_button_cb),
	(subfolder_conf_clicked_ok), (folder_conf_imap_sub_node),
	(folder_conf_delete):

2019-07-30  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-node: Scrap the "load-config" and "save-config" signals.
	No one needed to connect to them.

	* src/mailbox-node.c (balsa_mailbox_node_class_init),
	(balsa_mailbox_node_init), (balsa_mailbox_node_load_config),
	(balsa_mailbox_node_save_config):

2019-07-30  Peter Bloomfield  <pbloomfield@bellsouth.net>

	sendmsg-window: Use modern macros to declare and define
	BalsaAttachInfo

	* src/sendmsg-window.c (balsa_attach_info_class_init),
	(balsa_attach_info_init), (balsa_attach_info_new),
	(balsa_attach_info_finalize), (sw_attachment_list):

2019-07-29  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use parent-class set by G_DEFINE_TYPE instead of our own
	variable

	* src/mailbox-node.c (balsa_mailbox_node_class_init),
	(balsa_mailbox_node_dispose), (balsa_mailbox_node_finalize):

2019-07-29  Peter Bloomfield  <pbloomfield@bellsouth.net>

	rfc2445: Use GDateTime instead of GTimeVal, which is deprecated
	in glib version 2.62.

	* libbalsa/rfc2445.c (date_time_2445_to_time_t):

2019-07-29  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main-window: declare it derivable

	Put the details in BalsaWindowPrivate, and provide accessors.

	* src/balsa-mime-widget-text.c (statusbar_pop), (handle_url),
	(bm_widget_on_url):
	* src/information-dialog.c (balsa_information_list),
	(status_bar_refresh), (balsa_information_bar):
	* src/mailbox-node.c (imap_dir_cb):
	* src/main-window.c (bw_network_changed_cb), (balsa_window_init),
	(bw_pass_to_filter), (bw_filter_entry_activate),
	(bw_create_index_widget), (bw_set_panes), (bw_is_active_notify),
	(bw_action_set_enabled), (find_in_message_activated),
	(zoom_in_activated), (zoom_out_activated), (zoom_normal_activated),
	(reset_filter_activated), (next_part_activated),
	(previous_part_activated), (save_part_activated),
	(copy_message_activated), (select_text_activated),
	(show_mailbox_tabs_change_state), (show_toolbar_change_state),
	(show_statusbar_change_state), (show_sos_bar_change_state),
	(wrap_change_state), (show_all_headers_change_state),
	(header_change_state), (threading_change_state), (bw_alt_n_cb),
	(balsa_window_new), (balsa_window_fix_paned),
	(balsa_window_update_book_menus), (bw_enable_message_menus),
	(bw_enable_part_menu_items), (bw_real_open_mbnode_idle_cb),
	(balsa_window_real_close_mbnode), (balsa_window_destroy),
	(balsa_window_refresh), (bw_check_mailbox_list),
	(bw_mailbox_check), (bw_check_messages_thread),
	(bw_display_new_mail_notification),
	(bw_change_connection_status_can_reach_cb),
	(bw_change_connection_status_idle),
	(balsa_window_find_current_index), (bw_get_view_filter),
	(bw_reset_filter), (bw_show_mbtree), (balsa_change_window_layout),
	(bw_notebook_switch_page_cb), (bw_index_changed_cb),
	(bw_idle_replace), (bw_idle_remove), (bw_idle_cb),
	(bw_progress_timeout), (bw_update_progress_bar),
	(balsa_window_increase_activity), (balsa_window_decrease_activity),
	(balsa_window_setup_progress), (balsa_window_increment_progress),
	(balsa_window_set_statusbar), (balsa_window_next_unread),
	(balsa_window_get_statusbar):
	* src/main-window.h:

2019-07-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	address-book-config: Do not leak structures

	* src/address-book-config.c (balsa_address_book_config_new),
	(balsa_address_book_config_new_from_type):

2019-07-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-node: Do not give access to BalsaMailboxNode:scanned

	We can do all the checking in mailbox-node.c.

	* src/mailbox-node.c (balsa_mailbox_node_append_subtree): check
	whether the mbnode has been scanned;
	* src/mailbox-node.h: drop accessors;
	* src/balsa-mblist.c (balsa_mblist_mailbox_node_append): no need
	to check whether the mbnode has been scanned.

2019-07-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-mailbox-node: Use modern macros to declare and define.

	* src/mailbox-node.h: declare BalsaMailboxNode final;
	* src/mailbox-node.c: use G_DEFINE_TYPE();
	(balsa_mailbox_node_class_init),
	(balsa_mailbox_node_init), (get_parent_folder_name),
	(add_imap_entry), (handle_imap_path), (mark_imap_path),
	(balsa_mailbox_node_set_dir), (balsa_mailbox_node_set_name),
	(balsa_mailbox_node_set_config_prefix),
	(balsa_mailbox_node_set_last_use_time),
	(balsa_mailbox_node_change_style): adapt;
	(balsa_mailbox_node_set_list_inbox),
	(balsa_mailbox_node_set_subscribed),
	(balsa_mailbox_node_set_scanned), (balsa_mailbox_node_get_mailbox),
	(balsa_mailbox_node_get_name),
	(balsa_mailbox_node_get_config_prefix),
	(balsa_mailbox_node_get_last_use_time),
	(balsa_mailbox_node_get_server), (balsa_mailbox_node_get_style),
	(balsa_mailbox_node_get_subscribed),
	(balsa_mailbox_node_get_scanned),
	(balsa_mailbox_node_get_list_inbox),
	(balsa_mailbox_node_get_delim), (balsa_mailbox_node_get_dir),
	(balsa_mailbox_node_get_parent): new functions;
	* libbalsa/folder-scanners.h:
	* libinit_balsa/assistant_page_user.c (create_imap_mbx):
	* src/balsa-app.c (find_mailbox), (find_path), (find_url),
	(balsa_find_mailbox_by_url), (balsa_get_short_mailbox_name),
	(balsa_find_iter_by_data_func), (ba_remove_children_mailbox_nodes),
	(balsa_remove_children_mailbox_nodes):
	* src/balsa-index.c (bndx_destroy), (bndx_selection_changed_idle),
	(bndx_selection_changed), (bndx_find_current_msgno),
	(bndx_scroll_on_open_idle), (balsa_index_load_mailbox_node),
	(bndx_search_iter), (bndx_search_iter_and_select),
	(bndx_mailbox_changed_idle), (balsa_index_selected_msgnos_new),
	(balsa_index_selected_msgnos_free), (bndx_view_source),
	(bndx_compose_foreach), (bndx_compose_from_list), (bndx_do_delete),
	(balsa_message_move_to_trash), (balsa_find_notebook_page_num),
	(balsa_index_toggle_flag), (bi_toggle_deleted_cb), (mru_menu_cb),
	(bndx_do_popup), (balsa_index_set_thread_messages),
	(balsa_index_set_view_filter), (balsa_index_transfer),
	(balsa_index_expunge), (bndx_next_msgno), (balsa_index_pipe),
	(balsa_index_select_thread), (balsa_index_set_last_use_time),
	(balsa_index_get_last_use_time), (balsa_index_get_mailbox):
	* src/balsa-mblist.c (bmbl_selection_func), (bmbl_tree_expand),
	(bmbl_tree_collapse_helper), (bmbl_tree_collapse),
	(bmbl_row_compare), (bmbl_drag_cb), (bmbl_select_mailbox),
	(bmbl_row_activated_cb), (bmbl_find_all_unread_mboxes_func),
	(get_lru_descendant), (bmbl_real_disconnect_mbnode_signals),
	(bmbl_store_redraw_mbnode), (bmbl_node_style),
	(bmbl_mru_selected_cb), (bmbl_mru_activated_cb),
	(balsa_mblist_mailbox_node_append):
	* src/filter-edit-callbacks.c (update_filters_mailbox):
	* src/folder-conf.c (folder_conf_clicked_ok),
	(folder_conf_imap_subscriptions), (folder_conf_imap_node),
	(validate_sub_folder), (browse_button_cb),
	(subfolder_conf_clicked_ok), (folder_conf_imap_sub_node),
	(folder_conf_delete), (folder_conf_add_imap_sub_cb):
	* src/mailbox-conf.c (mailbox_conf_delete_cb),
	(mailbox_conf_delete), (run_mailbox_conf), (mailbox_conf_edit):
	* src/main-window.c (bw_enable_mailbox_menus),
	(bw_notebook_label_new), (bw_real_open_mbnode_idle_cb),
	(bw_real_open_mbnode_thread), (balsa_window_real_open_mbnode),
	(balsa_window_real_close_mbnode), (bw_check_mailbox_list),
	(bw_add_mbox_to_checklist), (mw_mbox_change_connection_status),
	(bw_change_connection_status_idle), (balsa_window_update_tab):
	* src/main.c (periodic_expunge_cb):
	* src/pref-manager.c (add_other_server), (server_del_cb),
	(update_mail_servers):
	* src/save-restore.c (folder_section_path),
	(migrate_imap_mailboxes), (config_folder_delete),
	(config_folder_init):
	* src/save-restore.h: use them.

2019-07-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	filter-run: Make filter-run.h private

	* src/filter-run-callbacks.c: define OK_TO_INCLUDE_FILTER_RUN_H;
	* src/filter-run-dialog.c: ditto;
	* src/filter-run.h: error if it is not defined.

2019-07-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Cleanup after using G_DECLARE_FINAL_TYPE()

	* libbalsa/mailbox_imap.c: drop redundant class struct
	declaration;
	* libbalsa/mailbox_maildir.c: ditto;
	* libbalsa/mailbox_mbox.c: ditto;
	* libbalsa/mailbox_mh.c: ditto;
	* libbalsa/mailbox_pop3.c: ditto;
	* libbalsa/message.c: ditto;
	* src/ab-window.c: ditto;
	* src/balsa-cite-bar.c: ditto; drop parant_class variable;
	  (balsa_cite_bar_class_init): no more parent_class.

2019-07-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/libbalsa-gpgme-widgets.c (create_uid_str): Do not
	leak an empty string.

2019-07-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-message.c (balsa_message_destroy): Do not leak
	BalsaMessage::face_box.

2019-07-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-message: Use modern macros to declare and define.

	Make BalsaMessage opaque, and provide and use necessary accessors.

	* src/balsa-message.c (balsa_part_info_class_init),
	(balsa_message_class_init), (balsa_message_destroy),
	(balsa_part_info_init), (balsa_part_info_new),
	(balsa_part_info_dispose), (balsa_part_info_finalize),
	(balsa_message_get_wrap_text), (balsa_message_get_focus_state),
	(balsa_message_get_scroll), (balsa_message_get_bm_widget),
	(balsa_message_get_message), (balsa_message_get_shown_headers),
	(balsa_message_get_face_box), (balsa_message_get_tree_view),
	(balsa_message_set_focus_state), (balsa_message_set_face_box):
	* src/balsa-message.h:
	* src/balsa-mime-widget-callbacks.c (scroll_change),
	(balsa_mime_widget_key_press_event),
	(balsa_mime_widget_limit_focus), (balsa_mime_widget_unlimit_focus):
	* src/balsa-mime-widget-message.c (balsa_mime_widget_new_message),
	(bm_header_widget_new), (add_header_address_list),
	(bmw_message_set_headers_d),
	(balsa_mime_widget_message_set_headers),
	(balsa_mime_widget_message_set_headers_d):
	* src/balsa-mime-widget-text.c (balsa_mime_widget_new_text),
	(check_text_encoding):
	* src/balsa-mime-widget-vcalendar.c
	(balsa_mime_widget_new_vcalendar):
	* src/main-window.c (bw_index_changed_cb), (bw_idle_replace):
	* src/message-window.c (mw_set_part_buttons_sensitive):

2019-07-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-mblist: Use modern macros to declare and define.

	Make BalsaMBList opaque; no accessors needed.

	* src/balsa-mblist.c (balsa_mblist_class_init), (bmbl_drag_motion),
	(balsa_mblist_init):
	* src/balsa-mblist.h:

2019-07-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: Another convenience function

	* src/balsa-index.c (balsa_index_get_last_use_time): another
	convenience function;
	* src/balsa-index.h: declare it;
	* src/main-window.c (bw_close_mailbox_on_timer): use it.

2019-07-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	send.c: Fix the build

	* libbalsa/send.c (libbalsa_message_create_mime_message):
	LibBalsaIdentity *identity is used only in an autocrypt build.

2019-07-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: Add a convenience function
	balsa_index_get_mailbox().

	* src/balsa-index.c (balsa_index_get_mailbox): define it;
	* src/balsa-index.h: declare it;
	* src/balsa-app.c (balsa_find_index_by_mailbox):
	* src/balsa-mblist.c (bmbl_tree_expand), (bmbl_drag_cb),
	(bmbl_update_mailbox):
	* src/main-window.c (continue_activated), (print_activated),
	(mailbox_close_activated), (select_filters_activated),
	(remove_duplicates_activated), (threading_change_state),
	(bw_enable_message_menus), (balsa_window_set_thread_messages),
	(balsa_window_real_close_mbnode), (bw_find_real),
	(bw_hide_changed_set_view_filter), (bw_notebook_switch_page_cb),
	(bw_idle_cb), (bw_notebook_drag_received_cb),
	(bw_notebook_page_notify_cb), (balsa_window_next_unread):
	* src/message-window.c (mw_set_buttons_sensitive):
	* src/sendmsg-window.c (attachments_add), (drag_data_quote): use
	it.

2019-07-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-index: Use modern macros to declare and define.

	Make BalsaIndex opaque, and provide necessary accessors.

	* src/balsa-index.c: use G_DEFINE_TYPE to define BalsaIndex;
	(balsa_index_class_init), (bndx_destroy),
	(balsa_index_init), (balsa_index_select_thread),
	(balsa_index_get_mailbox_node), (balsa_index_get_current_msgno),
	(balsa_index_get_filter_no), (balsa_index_get_next_message),
	(balsa_index_get_prev_message), (balsa_index_get_filter_string),
	(balsa_index_set_last_use_time):
	* src/balsa-index.h: use G_DECLARE_FINAL_TYPE;
	* src/balsa-app.c (balsa_find_index_by_mailbox):
	* src/balsa-mblist.c (bmbl_tree_expand), (bmbl_drag_cb),
	(bmbl_open_mailbox), (bmbl_update_mailbox):
	* src/main-window.c (continue_activated), (print_activated),
	(reset_filter_activated), (mailbox_close_activated),
	(select_filters_activated), (remove_duplicates_activated),
	(threading_change_state), (bw_enable_mailbox_menus),
	(balsa_window_update_book_menus), (bw_enable_message_menus),
	(balsa_window_set_thread_messages),
	(balsa_window_real_close_mbnode), (bw_close_mailbox_on_timer),
	(bw_find_real), (bw_hide_changed_set_view_filter),
	(bw_reset_filter), (bw_notebook_switch_page_cb),
	(bw_index_changed_cb), (bw_idle_cb),
	(bw_notebook_drag_received_cb), (bw_notebook_page_notify_cb),
	(balsa_window_next_unread):
	* src/message-window.c (mw_set_buttons_sensitive):
	* src/sendmsg-window.c (attachments_add), (drag_data_quote): use
	the accessors.

2019-07-19  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/filter-file.c (libbalsa_mailbox_filters_load_config):
	Fix loading filters.

2019-07-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-cite-bar: Declare it final

	* src/balsa-cite-bar.c: Copyright update;
	* src/balsa-cite-bar.h: use G_DECLARE_FINAL_TYPE().

2019-07-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	ab-window: Use modern macros to declare and define.

	* src/ab-window.c: use G_DEFINE_TYPE();
	* src/ab-window.h: use G_DECLARE_FINAL_TYPE().

2019-07-17  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/mailbox_maildir.c
	(libbalsa_mailbox_maildir_fetch_message_structure): do not unref
	a NULL GMimeMessage.

2019-07-17  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/gmime-part-rfc2440.c (g_mime_part_check_rfc2440): use
	g_str_has_prefix() instead of strncmp().

2019-07-16  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mime-stream-shared: Use modern macros to declare and define.

	* libbalsa/mime-stream-shared.c: Use G_DEFINE_TYPE();
	(libbalsa_mime_stream_shared_class_init): do not handle
	parent_class;
	(libbalsa_mime_stream_shared_init): new stub, required by
	G_DEFINE_TYPE();
	(lbmss_lock_new): do not ref-count locks;
	(lbmss_finalize): use GMimeStreamFs::owner to decide when to
	free the lock;
	(lbmss_stream_read), (lbmss_stream_write),
	(lbmss_stream_reset), (lbmss_stream_seek),
	(lbmss_stream_substream), (libbalsa_mime_stream_shared_new):
	parent class stuff;
	(libbalsa_mime_stream_shared_lock),
	(libbalsa_mime_stream_shared_unlock): cosmetics;
	* libbalsa/mime-stream-shared.h: Use G_DECLARE_FINAL_TYPE().

2019-07-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Fix some Valgrind-detected issues

	* libbalsa/filter-file.c (libbalsa_mailbox_filters_load_config):
	initialize LibBalsaMailboxFilter::when;
	* libbalsa/mailbox.c (libbalsa_mailbox_finalize): clear the
	GRecMutex;
	* libbalsa/mailbox_imap.c (libbalsa_mailbox_imap_load_envelope):
	do not leak an InternetAddressList;
	(get_struct_from_cache): do not leak GMimeMessage;
	* libbalsa/send.c (lbs_message_queue_real): ref the GMimeMessage
	to preserve it, and then unref it.

2019-07-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-message: Pass message headers to disposition-notify handler

	* src/balsa-message.c (balsa_message_set), (handle_mdn_request):

2019-07-11  Peter Bloomfield  <pbloomfield@bellsouth.net>

	message: Declare it final

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaMessage, make it
	private, and provide necessary getters and setters.

	* libbalsa/autocrypt.c (autocrypt_from_message):
	* libbalsa/body.c (libbalsa_message_body_set_text_rfc822headers),
	(libbalsa_message_body_get_part_stream),
	(libbalsa_message_body_get_message_part_stream),
	(libbalsa_message_body_get_stream),
	(libbalsa_message_body_get_content),
	(libbalsa_message_body_get_pixbuf),
	(libbalsa_message_body_save_stream):
	* libbalsa/filter.c (libbalsa_condition_matches),
	(libbalsa_condition_can_match):
	* libbalsa/mailbox.c (get_from_field),
	(lbm_index_entry_populate_from_msg),
	(libbalsa_mailbox_real_release_message),
	(libbalsa_mailbox_release_message),
	(libbalsa_mailbox_set_msg_headers),
	(libbalsa_mailbox_get_message_part), (lbm_get_mime_msg),
	(lbm_try_reassemble):
	* libbalsa/mailbox_imap.c (lbimap_update_flags), (imap_flags_cb),
	(imap_expunge_cb), (free_messages_info),
	(libbalsa_mailbox_imap_load_envelope),
	(libbalsa_mailbox_imap_get_message), (get_struct_from_cache),
	(libbalsa_mailbox_imap_fetch_structure),
	(libbalsa_mailbox_imap_fetch_headers), (get_section_for),
	(lbm_imap_get_msg_part_from_cache):
	* libbalsa/mailbox_local.c (lbm_local_get_message_with_msg_info),
	(message_match_real), (libbalsa_mailbox_local_cache_message),
	(libbalsa_mailbox_local_fetch_structure),
	(libbalsa_mailbox_local_fetch_headers),
	(libbalsa_mailbox_local_messages_change_flags):
	* libbalsa/mailbox_maildir.c (libbalsa_mailbox_maildir_check),
	(free_message_info), (libbalsa_mailbox_maildir_sync),
	(libbalsa_mailbox_maildir_fetch_message_structure):
	* libbalsa/mailbox_mbox.c (parse_mailbox), (free_message_info),
	(libbalsa_mailbox_mbox_sync),
	(libbalsa_mailbox_mbox_fetch_message_structure),
	(lbm_mbox_add_message):
	* libbalsa/mailbox_mh.c (lbm_mh_free_message_info),
	(libbalsa_mailbox_mh_check), (libbalsa_mailbox_mh_sync),
	(libbalsa_mailbox_mh_fetch_message_structure):
	* libbalsa/message.c (libbalsa_message_class_init),
	(libbalsa_message_dispose), (libbalsa_message_finalize),
	(lb_message_headers_extra_destroy),
	(libbalsa_message_headers_destroy),
	(libbalsa_message_body_charset),
	(libbalsa_message_header_get_helper),
	(libbalsa_message_find_user_hdr),
	(libbalsa_message_header_get_one),
	(libbalsa_message_header_get_all),
	(libbalsa_message_get_user_header),
	(libbalsa_message_set_user_header), (prepend_header_misc),
	(libbalsa_message_user_hdrs_from_gmime),
	(libbalsa_message_get_part_by_id), (libbalsa_message_save),
	(libbalsa_message_get_attach_icon), (libbalsa_message_reply),
	(libbalsa_message_body_ref), (libbalsa_message_body_unref),
	(libbalsa_message_is_multipart), (libbalsa_message_is_partial),
	(has_attached_part), (libbalsa_message_has_attachment),
	(libbalsa_message_get_subject), (libbalsa_message_get_lines),
	(libbalsa_message_get_length), (lb_message_recipients),
	(lb_message_headers_basic_from_gmime),
	(lb_message_headers_extra_from_gmime),
	(libbalsa_message_init_from_gmime),
	(libbalsa_message_refs_for_threading), (references_decode),
	(libbalsa_message_set_references_from_string),
	(libbalsa_message_set_in_reply_to_from_string), (lbmsg_set_header),
	(lb_message_set_headers_from_string),
	(libbalsa_message_load_envelope_from_stream),
	(libbalsa_message_load_envelope), (libbalsa_message_stream),
	(libbalsa_message_copy), (libbalsa_message_set_subject),
	(libbalsa_message_set_subject_from_header),
	(libbalsa_message_get_tempdir), (libbalsa_message_get_mailbox),
	(libbalsa_message_get_headers), (libbalsa_message_get_body_list),
	(libbalsa_message_get_mime_message), (libbalsa_message_get_flags),
	(libbalsa_message_get_message_id), (libbalsa_message_get_msgno),
	(libbalsa_message_get_has_all_headers),
	(libbalsa_message_get_sender), (libbalsa_message_get_request_dsn),
	(libbalsa_message_get_references), (libbalsa_message_get_identity),
	(libbalsa_message_get_parameters), (libbalsa_message_get_subtype),
	(libbalsa_message_get_gpg_mode),
	(libbalsa_message_get_in_reply_to),
	(libbalsa_message_get_attach_pubkey),
	(libbalsa_message_get_protect_state),
	(libbalsa_message_get_body_ref), (libbalsa_message_set_flags),
	(libbalsa_message_set_mailbox), (libbalsa_message_set_msgno),
	(libbalsa_message_set_has_all_headers),
	(libbalsa_message_set_length), (libbalsa_message_set_mime_message),
	(libbalsa_message_set_sender), (libbalsa_message_set_message_id),
	(libbalsa_message_set_protect_state),
	(libbalsa_message_set_request_dsn), (libbalsa_message_set_subtype),
	(libbalsa_message_set_body_list),
	(libbalsa_message_set_references),
	(libbalsa_message_set_in_reply_to),
	(libbalsa_message_set_gpg_mode),
	(libbalsa_message_set_attach_pubkey),
	(libbalsa_message_set_identity), (libbalsa_message_add_parameters):
	* libbalsa/message.h:
	* libbalsa/rfc3156.c (libbalsa_body_check_signature),
	(libbalsa_body_decrypt):
	* libbalsa/send.c (lbs_message_queue_real),
	(lbs_process_queue_msg), (balsa_send_message_success),
	(balsa_send_message_error), (balsa_send_message_real),
	(message_add_references), (libbalsa_message_create_mime_message),
	(libbalsa_message_postpone), (libbalsa_create_msg),
	(libbalsa_fill_msg_queue_item_from_queu), (lb_send_from),
	(libbalsa_create_rfc2440_buffer), (do_multipart_crypto):
	* libbalsa/source-viewer.c (lsv_escape_change_state),
	(libbalsa_show_message_source):
	* src/balsa-message.c (balsa_message_set),
	(balsa_message_set_displayed_headers), (balsa_message_set_wrap),
	(display_headers), (display_content), (handle_mdn_request),
	(create_mdn_reply), (balsa_message_scan_signatures),
	(libbalsa_msg_try_decrypt), (libbalsa_msg_part_2440),
	(balsa_message_perform_crypto), (message_recheck_crypto_cb):
	* src/balsa-mime-widget-message.c (extbody_send_mail):
	* src/balsa-mime-widget-text.c (check_text_encoding):
	* src/balsa-mime-widget-vcalendar.c
	(balsa_mime_widget_new_vcalendar), (vevent_reply):
	* src/balsa-mime-widget.c (balsa_mime_widget_new_unknown):
	* src/balsa-print-object-header.c
	(balsa_print_object_header_from_message):
	* src/main-window.c (bw_index_changed_cb):
	* src/message-window.c (message_window_idle_handler),
	(mw_set_buttons_sensitive), (mw_expunged_cb), (mw_reply_activated),
	(mw_reply_all_activated), (mw_reply_group_activated),
	(mw_forward_attached_activated), (mw_forward_inline_activated),
	(mw_forward_default_activated):
	* src/print-gtk.c (begin_print):
	* src/sendmsg-window.c (sw_delete_draft),
	(balsa_sendmsg_destroy_handler), (update_bsmsg_identity),
	(create_info_pane), (continue_body), (message_part_get_subject),
	(quote_message_body), (fill_body_from_message),
	(bsmsg_set_subject_from_body), (sw_save_draft),
	(setup_headers_from_message), (set_identity_from_mailbox),
	(guess_identity), (bsm_prepare_for_setup), (bsm_finish_setup),
	(bsmsg2message), (check_autocrypt_recommendation),
	(send_message_handler), (sendmsg_window_reply),
	(sendmsg_window_forward), (sendmsg_window_continue):
	* src/store-address.c (store_address_note_frame):

2019-07-11  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Rename LIBBALSA_MAILBOX_REMOTE_SERVER() to
	LIBBALSA_MAILBOX_REMOTE_GET_SERVER()

	* libbalsa/mailbox_imap.c (libbalsa_mailbox_imap_dispose),
	(libbalsa_mailbox_imap_update_url), (clean_cache),
	(libbalsa_mailbox_imap_get_handle),
	(libbalsa_mailbox_imap_get_selected_handle), (lbm_imap_check),
	(libbalsa_mailbox_imap_save_config),
	(libbalsa_mailbox_imap_reconnect),
	(libbalsa_mailbox_imap_fetch_structure),
	(libbalsa_mailbox_imap_messages_copy):
	* libbalsa/mailbox_pop3.c (libbalsa_mailbox_pop3_check),
	(libbalsa_mailbox_pop3_save_config),
	(libbalsa_mailbox_pop3_load_config):
	* libbalsa/mailbox_remote.h:
	* libinit_balsa/assistant_page_directory.c (unconditional_mailbox):
	* libinit_balsa/assistant_page_user.c (create_pop3_mbx):
	* src/mailbox-conf.c (update_pop_mailbox),
	(create_pop_mailbox_dialog):
	* src/save-restore.c (config_mailbox_init):

2019-07-11  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/mailbox_imap.c (libbalsa_mailbox_imap_messages_copy):
	Fix some bad logic from commit 2d54e175561c9e382701d63ed8dde4746959559b

2019-07-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Fix some scan-build reports

	* libbalsa/mailbox.c (libbalsa_mailbox_set_threading_type),
	(libbalsa_mailbox_set_subject_gather),
	(libbalsa_mailbox_set_sort_type),
	(libbalsa_mailbox_set_sort_field), (libbalsa_mailbox_set_show),
	(libbalsa_mailbox_set_subscribe), (libbalsa_mailbox_set_exposed),
	(libbalsa_mailbox_set_open), (libbalsa_mailbox_set_filter):
	remove a dead store;
	* libbalsa/mailbox_imap.c
	(libbalsa_mailbox_imap_get_selected_handle): initialize readonly
	to FALSE.

2019-07-06  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-{remote,imap}: Simplify dispose() methods

	* libbalsa/mailbox_imap.c (libbalsa_mailbox_imap_dispose): the
	  server will be destroyed in the parent-class (LibBalsaMailboxRemote)
	  method;
	* libbalsa/mailbox_remote.c (libbalsa_mailbox_remote_dispose):
	  chain up to the parent-class (LibBalsaMailbox) method, to make
	  sure the mailbox is closed, before destroying the server.

2019-07-05  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-pop3: Declare it final

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaMailboxPOP3, make it
	private, and provide necessary getters and setters.

	* libbalsa/mailbox_pop3.c
	(libbalsa_mailbox_pop3_get_delete_from_server),
	(libbalsa_mailbox_pop3_get_check),
	(libbalsa_mailbox_pop3_get_filter),
	(libbalsa_mailbox_pop3_get_filter_cmd),
	(libbalsa_mailbox_pop3_get_disable_apop),
	(libbalsa_mailbox_pop3_get_enable_pipe),
	(libbalsa_mailbox_pop3_set_msg_size_limit),
	(libbalsa_mailbox_pop3_set_check),
	(libbalsa_mailbox_pop3_set_disable_apop),
	(libbalsa_mailbox_pop3_set_delete_from_server),
	(libbalsa_mailbox_pop3_set_filter),
	(libbalsa_mailbox_pop3_set_filter_cmd),
	(libbalsa_mailbox_pop3_set_enable_pipe):
	* libbalsa/mailbox_pop3.h:
	* libinit_balsa/assistant_page_user.c (create_pop3_mbx):
	* src/mailbox-conf.c (update_pop_mailbox),
	(create_pop_mailbox_dialog):

2019-07-05  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-imap: Declare it final

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaMailboxImap

	No new accessors needed.

	* libbalsa/mailbox_imap.h:

2019-07-05  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-remote: declare it derivable

	Use G_DECLARE_DERIVABLE_TYPE to declare LibBalsaMailboxRemote
	and provide libbalsa_mailbox_remote_get_server().

	* libbalsa/mailbox_imap.c (libbalsa_mailbox_imap_class_init),
	(libbalsa_mailbox_imap_dispose), (libbalsa_mailbox_imap_finalize),
	(get_header_cache_path), (get_cache_name_pair),
	(libbalsa_mailbox_imap_close), (libbalsa_mailbox_imap_save_config),
	(libbalsa_mailbox_imap_load_config),
	(libbalsa_mailbox_imap_add_messages),
	(libbalsa_mailbox_imap_messages_copy):
	* libbalsa/mailbox_imap.h:
	* libbalsa/mailbox_pop3.c (libbalsa_mailbox_pop3_class_init),
	(libbalsa_mailbox_pop3_init), (libbalsa_mailbox_pop3_finalize),
	(libbalsa_mailbox_pop3_new), (libbalsa_mailbox_pop3_open),
	(libbalsa_mailbox_pop3_startup), (update_msg_list),
	(libbalsa_mailbox_pop3_check), (libbalsa_mailbox_pop3_save_config),
	(libbalsa_mailbox_pop3_load_config),
	(libbalsa_mailbox_pop3_set_inbox),
	(libbalsa_mailbox_pop3_set_msg_size_limit):
	* libbalsa/mailbox_pop3.h:
	* libbalsa/mailbox_remote.c (libbalsa_mailbox_remote_class_init),
	(libbalsa_mailbox_remote_init), (libbalsa_mailbox_remote_dispose),
	(libbalsa_mailbox_remote_test_can_reach),
	(libbalsa_mailbox_remote_set_server),
	(libbalsa_mailbox_remote_get_server):
	* libbalsa/mailbox_remote.h:
	* libinit_balsa/assistant_page_user.c (create_pop3_mbx),
	(create_imap_mbx):
	* src/mailbox-conf.c (update_pop_mailbox),
	(create_pop_mailbox_dialog):
	* src/main-window.c (bw_check_mailbox_list):

2019-07-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-mh: Declare it final

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaMailboxMh

	No new accessors needed.

	* libbalsa/mailbox_mh.c:
	* libbalsa/mailbox_mh.h:

2019-07-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-mbox: Declare it final

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaMailboxMbox

	No new accessors needed.

	* libbalsa/mailbox_mbox.c (libbalsa_mailbox_mbox_class_init),
	(libbalsa_mailbox_mbox_dispose), (lbm_mbox_check_files),
	(libbalsa_mailbox_mbox_get_message_stream),
	(libbalsa_mailbox_mbox_remove_files),
	(libbalsa_mailbox_mbox_close_mailbox),
	(libbalsa_mailbox_mbox_fetch_message_structure):
	* libbalsa/mailbox_mbox.h:

2019-07-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-maildir: Declare it final

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaMailboxMaildir

	No new accessors needed.

	* libbalsa/mailbox_maildir.c (libbalsa_mailbox_maildir_class_init),
	(libbalsa_mailbox_maildir_finalize),
	(libbalsa_mailbox_maildir_load_config), (lbm_maildir_remove_files),
	(libbalsa_mailbox_maildir_close_mailbox),
	(libbalsa_mailbox_maildir_fetch_message_structure):
	* libbalsa/mailbox_maildir.h:

2019-07-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_DERIVABLE_TYPE to declare LibBalsaMailboxLocal

	No new accessors needed.

	* libbalsa/mailbox_local.c (libbalsa_mailbox_local_class_init),
	(libbalsa_mailbox_local_init), (lbml_message_pool_take_message),
	(lbm_local_free_info), (libbalsa_mailbox_local_finalize),
	(libbalsa_mailbox_local_save_config),
	(libbalsa_mailbox_local_load_config), (lbm_local_save_tree_real),
	(lbm_local_queue_save_tree),
	(libbalsa_mailbox_local_close_mailbox), (message_match_real),
	(libbalsa_mailbox_local_cache_message),
	(lbml_load_messages_idle_cb),
	(libbalsa_mailbox_local_load_messages),
	(libbalsa_mailbox_local_set_threading_info),
	(libbalsa_mailbox_local_msgno_removed), (lbm_local_prepare_msgno),
	(lbm_local_thread_idle),
	(libbalsa_mailbox_local_prepare_threading), (lbml_get_info),
	(lbm_local_sync_real), (lbm_local_sync_idle),
	(lbm_local_sync_queue), (lbm_local_sort),
	(libbalsa_mailbox_local_duplicate_msgnos):
	* libbalsa/mailbox_local.h:

2019-07-03  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_DERIVABLE_TYPE to declare LibBalsaMailbox

	and provide and use the necessary getters and setters.

	Also move mailbox locking to a GRecMutex in the
	LibBalsaMailboxPrivate structure, instead of our home-brewed
	lock.

	* libbalsa/filter-file.c (libbalsa_mailbox_filters_load_config),
	(libbalsa_mailbox_filters_save_config):
	* libbalsa/libbalsa.c:
	* libbalsa/mailbox-filter.c (config_mailbox_filters_load):
	* libbalsa/mailbox.c (libbalsa_mailbox_class_init),
	(libbalsa_mailbox_init), (libbalsa_mailbox_dispose),
	(get_from_field), (libbalsa_mailbox_index_entry_clear),
	(libbalsa_mailbox_index_set_flags), (libbalsa_mailbox_finalize),
	(libbalsa_mailbox_free_mindex), (libbalsa_mailbox_open),
	(libbalsa_mailbox_is_open), (libbalsa_mailbox_close),
	(libbalsa_mailbox_set_unread_messages_flag),
	(libbalsa_mailbox_check), (lbm_changed_idle_cb),
	(lbm_changed_schedule_idle), (libbalsa_mailbox_changed),
	(lbm_run_filters_on_reception_idle_cb),
	(libbalsa_mailbox_run_filters_on_reception),
	(libbalsa_mailbox_save_config),
	(libbalsa_mailbox_real_messages_copy),
	(libbalsa_mailbox_real_sort), (libbalsa_mailbox_real_save_config),
	(libbalsa_mailbox_real_load_config),
	(libbalsa_mailbox_type_from_path), (lbm_node_has_unseen_child),
	(lbm_msgno_changed_expunged_cb), (lbm_msgno_row_changed),
	(lbm_msgnos_changed_idle_cb), (lbm_msgno_changed),
	(libbalsa_mailbox_msgno_changed), (lbm_need_threading_idle_cb),
	(libbalsa_mailbox_msgno_inserted),
	(libbalsa_mailbox_msgno_filt_in), (libbalsa_mailbox_msgno_removed),
	(libbalsa_mailbox_msgno_filt_out), (lbm_msgno_filt_check),
	(libbalsa_mailbox_msgno_filt_check),
	(libbalsa_mailbox_search_iter_view), (libbalsa_mailbox_msgno_find),
	(libbalsa_mailbox_sync_storage), (lbm_cache_message),
	(libbalsa_mailbox_get_message),
	(libbalsa_mailbox_messages_change_flags),
	(libbalsa_mailbox_set_view_filter),
	(libbalsa_mailbox_make_view_filter_persistent),
	(libbalsa_mailbox_real_can_do), (lbm_check_and_sort),
	(lbm_set_threading), (libbalsa_mailbox_view_free), (lbm_get_view),
	(libbalsa_mailbox_set_identity_name),
	(libbalsa_mailbox_set_threading_type),
	(libbalsa_mailbox_set_subject_gather),
	(libbalsa_mailbox_set_sort_type),
	(libbalsa_mailbox_set_sort_field), (libbalsa_mailbox_set_show),
	(libbalsa_mailbox_set_subscribe), (libbalsa_mailbox_set_exposed),
	(libbalsa_mailbox_set_open), (libbalsa_mailbox_set_filter),
	(libbalsa_mailbox_set_crypto_mode), (libbalsa_mailbox_set_unread),
	(libbalsa_mailbox_set_total), (libbalsa_mailbox_set_mtime),
	(libbalsa_mailbox_set_position),
	(libbalsa_mailbox_get_identity_name),
	(libbalsa_mailbox_get_threading_type),
	(libbalsa_mailbox_get_subject_gather),
	(libbalsa_mailbox_get_sort_type),
	(libbalsa_mailbox_get_sort_field), (libbalsa_mailbox_get_show),
	(libbalsa_mailbox_get_subscribe), (libbalsa_mailbox_get_exposed),
	(libbalsa_mailbox_get_open), (libbalsa_mailbox_get_filter),
	(libbalsa_mailbox_get_crypto_mode), (libbalsa_mailbox_get_unread),
	(libbalsa_mailbox_get_total), (libbalsa_mailbox_get_mtime),
	(libbalsa_mailbox_get_position), (mailbox_model_init),
	(mailbox_model_get_flags), (mailbox_model_get_n_columns),
	(mailbox_model_get_column_type), (mailbox_model_get_iter),
	(mailbox_model_get_path_helper), (mailbox_model_get_path),
	(lbm_get_index_entry_expunged_cb), (lbm_get_index_entry_real),
	(lbm_get_index_entry), (mailbox_model_get_value),
	(mailbox_model_iter_next), (mailbox_model_iter_children),
	(mailbox_model_iter_has_child), (mailbox_model_iter_n_children),
	(mailbox_model_iter_nth_child), (mailbox_model_iter_parent),
	(mailbox_drag_source_init), (mailbox_row_draggable),
	(mailbox_drag_data_delete), (mailbox_drag_data_get),
	(mailbox_sortable_init), (mailbox_compare_from),
	(mailbox_compare_subject), (mailbox_compare_date),
	(mailbox_get_thread_date_traverse_func), (mailbox_get_thread_date),
	(mailbox_compare_thread_date), (mailbox_compare_size),
	(mailbox_compare_func), (lbm_has_valid_index_entry), (lbm_sort),
	(mailbox_get_sort_column_id), (mailbox_set_sort_column_id),
	(mailbox_set_sort_func), (mailbox_set_default_sort_func),
	(mailbox_has_default_sort_func),
	(libbalsa_mailbox_unlink_and_prepend), (lbm_update_msg_tree),
	(lbm_set_msg_tree), (libbalsa_mailbox_set_msg_tree),
	(lbm_try_reassemble), (libbalsa_mailbox_try_reassemble),
	(libbalsa_mailbox_msgno_get_status),
	(libbalsa_mailbox_msgno_get_subject),
	(libbalsa_mailbox_msgno_update_attach), (lbm_check_idle),
	(lbm_queue_check), (libbalsa_mailbox_search_iter_step),
	(libbalsa_mailbox_can_move_duplicates),
	(libbalsa_mailbox_move_duplicates), (libbalsa_mailbox_lock_store),
	(libbalsa_mailbox_unlock_store), (libbalsa_mailbox_cache_message),
	(lbm_set_color), (libbalsa_mailbox_set_foreground),
	(libbalsa_mailbox_set_background),
	(libbalsa_mailbox_test_can_reach), (libbalsa_mailbox_get_filters),
	(libbalsa_mailbox_get_name), (libbalsa_mailbox_get_url),
	(libbalsa_mailbox_get_unread_messages),
	(libbalsa_mailbox_get_first_unread),
	(libbalsa_mailbox_get_view_filter),
	(libbalsa_mailbox_get_msg_tree),
	(libbalsa_mailbox_get_msg_tree_changed),
	(libbalsa_mailbox_get_state), (libbalsa_mailbox_get_index_entry),
	(libbalsa_mailbox_get_view), (libbalsa_mailbox_get_stamp),
	(libbalsa_mailbox_get_open_ref), (libbalsa_mailbox_get_readonly),
	(libbalsa_mailbox_get_config_prefix),
	(libbalsa_mailbox_get_has_unread_messages),
	(libbalsa_mailbox_clear_unread_messages),
	(libbalsa_mailbox_set_filters), (libbalsa_mailbox_set_url),
	(libbalsa_mailbox_set_first_unread),
	(libbalsa_mailbox_set_msg_tree_changed),
	(libbalsa_mailbox_set_is_directory),
	(libbalsa_mailbox_set_readonly),
	(libbalsa_mailbox_set_no_reassemble), (libbalsa_mailbox_set_name),
	(libbalsa_mailbox_set_view),
	(libbalsa_mailbox_set_has_unread_messages),
	(libbalsa_mailbox_set_config_prefix),
	(libbalsa_mailbox_add_to_unread_messages), (libbalsa_lock_mailbox),
	(libbalsa_unlock_mailbox):
	* libbalsa/mailbox.h:
	* libbalsa/mailbox_imap.c (message_info_from_msgno),
	(libbalsa_mailbox_imap_init), (libbalsa_mailbox_imap_finalize),
	(libbalsa_mailbox_imap_update_url), (mi_get_imsg),
	(idle_unread_update_cb), (imap_exists_idle),
	(libbalsa_mailbox_imap_get_selected_handle), (lbm_imap_get_unseen),
	(libbalsa_mailbox_imap_open),
	(libbalsa_mailbox_imap_get_matchings),
	(libbalsa_mailbox_imap_load_config),
	(libbalsa_mailbox_imap_force_disconnect),
	(libbalsa_mailbox_imap_reconnect), (lbmi_get_imap_sort_key),
	(libbalsa_mailbox_imap_set_threading), (lbmi_compare_func),
	(libbalsa_mailbox_imap_sort):
	* libbalsa/mailbox_local.c (libbalsa_mailbox_local_init),
	(libbalsa_mailbox_local_set_path),
	(libbalsa_mailbox_local_load_message),
	(libbalsa_mailbox_local_load_config), (lbm_local_save_tree),
	(lbm_local_restore_tree), (lbm_local_save_tree_real),
	(libbalsa_mailbox_local_close_mailbox), (message_match_real),
	(lbml_load_messages_idle_cb), (lbml_set_threading),
	(libbalsa_mailbox_local_set_threading),
	(lbm_local_update_view_filter),
	(libbalsa_mailbox_local_prepare_threading), (lbml_info_setup),
	(lbml_thread_messages), (lbml_unthread_message),
	(lbml_threading_flat), (lbm_local_sync_real),
	(libbalsa_mailbox_local_messages_change_flags):
	* libbalsa/mailbox_local.h:
	* libbalsa/mailbox_maildir.c (libbalsa_mailbox_maildir_new),
	(lbm_maildir_remove_files), (lbm_maildir_parse),
	(libbalsa_mailbox_maildir_open), (libbalsa_mailbox_maildir_check),
	(libbalsa_mailbox_maildir_sync):
	* libbalsa/mailbox_mbox.c (libbalsa_mailbox_mbox_new), (mbox_lock),
	(mbox_unlock), (libbalsa_mailbox_mbox_open),
	(libbalsa_mailbox_mbox_check), (libbalsa_mailbox_mbox_sync):
	* libbalsa/mailbox_mh.c (libbalsa_mailbox_mh_new),
	(lbm_mh_parse_mailbox), (libbalsa_mailbox_mh_open),
	(libbalsa_mailbox_mh_check), (libbalsa_mailbox_mh_sync):
	* libbalsa/mailbox_pop3.c (libbalsa_mailbox_pop3_new),
	(message_cb), (libbalsa_mailbox_pop3_startup), (update_msg_list),
	(libbalsa_mailbox_pop3_check), (libbalsa_mailbox_pop3_set_inbox),
	(libbalsa_mailbox_pop3_set_msg_size_limit):
	* libbalsa/message.c (libbalsa_message_change_flags):
	* libbalsa/send.c (lbs_message_queue_real),
	(lbs_check_reachable_cb), (balsa_send_message_success):
	* libinit_balsa/assistant_page_directory.c (unconditional_mailbox):
	* libinit_balsa/assistant_page_user.c (create_pop3_mbx):
	* src/balsa-app.c (find_url), (balsa_get_short_mailbox_name),
	(ba_remove_children_mailbox_nodes):
	* src/balsa-index.c (bndx_scroll_on_open_idle),
	(bndx_mailbox_row_inserted_cb), (bndx_mailbox_changed_idle),
	(bndx_do_popup), (balsa_index_transfer), (balsa_index_expunge):
	* src/balsa-mblist.c (bmbl_mailbox_changed_cb),
	(bmbl_store_redraw_mbnode), (bmbl_node_style), (bmbl_mru_menu),
	(bmbl_mru_selected_cb), (bmbl_mru_activated_cb):
	* src/balsa-message.c (balsa_message_set),
	(balsa_message_copy_part):
	* src/filter-edit-callbacks.c (update_filters_mailbox):
	* src/filter-run-callbacks.c (save_filters),
	(fr_apply_selected_pressed_func), (fr_apply_selected_pressed),
	(fr_apply_now_pressed), (fr_add_pressed_func):
	* src/filter-run-dialog.c (balsa_filter_run_dialog_new),
	(filters_run_dialog):
	* src/folder-conf.c (browse_button_cb),
	(folder_conf_imap_sub_node):
	* src/mailbox-conf.c (mailbox_conf_delete), (update_pop_mailbox),
	(mailbox_conf_update), (mailbox_conf_add),
	(local_mailbox_dialog_cb), (create_local_mailbox_dialog),
	(create_pop_mailbox_dialog), (mailbox_conf_view_check):
	* src/mailbox-node.c (balsa_mailbox_node_dispose),
	(load_mailbox_view), (imap_scan_attach_mailbox),
	(balsa_mailbox_node_new_from_mailbox),
	(balsa_mailbox_local_append), (bmbn_scan_children_idle),
	(remove_special_mailbox_by_url), (add_local_mailbox):
	* src/main-window.c (bw_enable_mailbox_menus),
	(bw_enable_message_menus), (bw_notebook_label_new),
	(balsa_window_real_open_mbnode), (bw_check_mailbox_progress_cb),
	(bw_check_mailbox_list), (check_new_messages_count),
	(bw_mailbox_check), (bw_notebook_switch_page_cb),
	(balsa_window_set_statusbar), (balsa_window_next_unread):
	* src/main.c (initial_open_unread_mailboxes), (initial_open_inbox),
	(balsa_get_stats), (scan_mailboxes_idle_cb), (periodic_expunge_cb):
	* src/message-window.c (mw_set_buttons_sensitive),
	(message_window_new):
	* src/pref-manager.c (update_view_defaults), (add_other_server),
	(update_mail_servers):
	* src/save-restore.c (mailbox_section_path),
	(config_mailbox_set_as_special), (config_mailbox_delete),
	(config_mailbox_init), (config_mailbox_filters_save):
	* src/save-restore.h:
	* src/sendmsg-window.c (sw_delete_draft), (create_info_pane),
	(send_message_handler):

2019-06-30  Albrecht Dreß  <albrecht.dress@arcor.de>

	Small LDAP address book improvements

	* libbalsa/address-book-ldap.c:
	  • implement helpers ldap_connection_get_uri(), ldap_connection_is_ldaps()
	    and ldap_use_config_value();
	  • libbalsa_address_book_ldap_open_connection(): use ldap_use_config_value()
	    for the server uri; do not attempt to run STARTTLS for a
	    ldaps connection--print warning instead;
	  • libbalsa_address_book_set_status(),
	    libbalsa_address_book_ldap_alias_complete(): use ldap_use_config_value()
	    for the base DN;
	  • use libbalsa_information() or g_debug() & friends with log domain “ab-ldap”
	    for messaging
	* src/address-book-config.c: fix misleading label in create_ldap_dialog()

2019-06-29  Albrecht Dreß  <albrecht.dress@arcor.de>

	Migrate print objects to new scheme

	Migrate the various print objects to the modern GObject scheme
	using G_DECLARE_*_TYPE() and G_DEFINE_TYPE().

	The main difficulty was the elimination of the direct access to
	the internal fields of BalsaPrintObject, i.e. the surrounding
	rectangle of the respective object, the page number and the
	logical depth.	I added setters/getters for this purpose, which
	required some refactoring in the derived classes.  However,
	IMO the result is actually cleaner…

	* src/balsa-print-object-decor.c
	(balsa_print_object_decor_class_init),
	(balsa_print_object_decor_init),
	(balsa_print_object_decor_destroy), (decor_new_real),
	(balsa_print_object_frame_begin), (bpo_decor_print_separator),
	(bpo_decor_print_frame_end), (bpo_decor_print_frame_begin),
	(balsa_print_object_decor_draw):
	* src/balsa-print-object-decor.h:
	* src/balsa-print-object-default.c
	(balsa_print_object_default_class_init),
	(balsa_print_object_default_init),
	(balsa_print_object_default_destroy), (balsa_print_object_default),
	(balsa_print_object_default_full),
	(balsa_print_object_default_draw):
	* src/balsa-print-object-default.h:
	* src/balsa-print-object-header.c
	(balsa_print_object_header_class_init),
	(balsa_print_object_header_init),
	(balsa_print_object_header_destroy),
	(balsa_print_object_header_new_real),
	(balsa_print_object_header_crypto),
	(balsa_print_object_header_draw):
	* src/balsa-print-object-header.h:
	* src/balsa-print-object-html.c
	(balsa_print_object_html_class_init), (balsa_print_object_html),
	(balsa_print_object_html_draw):
	* src/balsa-print-object-html.h:
	* src/balsa-print-object-image.c
	(balsa_print_object_image_class_init),
	(balsa_print_object_image_init),
	(balsa_print_object_image_destroy), (balsa_print_object_image),
	(balsa_print_object_image_draw):
	* src/balsa-print-object-image.h:
	* src/balsa-print-object-text.c
	(balsa_print_object_text_class_init),
	(balsa_print_object_text_init), (balsa_print_object_text_destroy),
	(balsa_print_object_text_plain), (balsa_print_object_text),
	(get_icon), (balsa_print_object_text_vcard),
	(balsa_print_object_text_calendar), (balsa_print_object_text_draw):
	* src/balsa-print-object-text.h:
	* src/balsa-print-object.c (balsa_print_object_init),
	(balsa_print_object_class_init), (balsa_print_object_draw),
	(balsa_print_object_get_page), (balsa_print_object_get_rect),
	(balsa_print_object_set_page_depth), (balsa_print_object_set_rect),
	(balsa_print_object_set_height), (balsa_print_object_destroy):
	* src/balsa-print-object.h:
	* src/print-gtk.c (draw_page):

2019-06-29  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix build error on Buster
	One last pair of redundant declarations…

	* src/spell-check.c: Do not declare
	balsa_spell_check_class_init() and balsa_spell_check_init().

2019-06-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/address-book-gpe.c: streamline.

2019-06-25  Peter Bloomfield  <pbloomfield@bellsouth.net>

	address: rename add to append

	to make sure that addrs are in the same order as in the
	address-book, for address-books that support multiple addrs per
	address.

	* libbalsa/address-book-extern.c (lbe_load_cb):
	* libbalsa/address-book-gpe.c (gpe_read_attr):
	* libbalsa/address-book-ldap.c
	(libbalsa_address_book_ldap_get_address):
	* libbalsa/address-book-ldif.c (address_new_prefill):
	* libbalsa/address-book-rubrica.c (extract_net):
	* libbalsa/address-book-vcard.c
	(libbalsa_address_book_vcard_parse_address):
	* libbalsa/address.c (libbalsa_address_append_addr):
	* libbalsa/address.h:
	* libbalsa/rfc2445.c (cal_address_2445_to_lbaddress):
	* libbalsa/rfc6350.c (rfc6350_eval_line):
	* src/store-address.c (store_address_add_address):

2019-06-24  Peter Bloomfield  <pbloomfield@bellsouth.net>

	address: Remove libbalsa_address_get_addr_list()

	Second and final step in keeping address->addr_list private.

	* libbalsa/address.c (libbalsa_address_get_n_addrs),
	(libbalsa_address_get_nth_addr): new functions to provide access
	  to the addr-list;
	* libbalsa/address-book-extern.c
	(libbalsa_address_book_externq_add_address):
	* libbalsa/address-book-gpe.c (gpe_read_address):
	* libbalsa/address-book-ldif.c (lbab_ldif_write_addresses):
	* libbalsa/address-book-osmo.c
	(libbalsa_address_book_osmo_alias_complete):
	* libbalsa/address-book-rubrica.c (lbab_rubrica_load_xml),
	(lbab_insert_address_node), (extract_cards), (extract_net):
	* libbalsa/address-book-text.c (lbab_text_load_file):
	* libbalsa/address-book-vcard.c (lbab_vcard_write_addresses):
	* libbalsa/address.h:
	* libbalsa/rfc6350.c (rfc6350_parse_from_stream):
	* src/ab-main.c (bab_load_cb):
	* src/ab-window.c (balsa_ab_window_load_cb): Use them.

2019-06-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	address: Remove libbalsa_address_set_addr_list()

	Step 1 in keeping address->addr_list private.

	* libbalsa/address-book-ldif.c (address_new_prefill): use
	libbalsa_address_add_addr() instead;
	* libbalsa/address-book-rubrica.c (extract_cards),
	(extract_net): ditto;
	* libbalsa/address-book-vcard.c
	(libbalsa_address_book_vcard_parse_address): ditto;
	* libbalsa/address.c: remove it;
	* libbalsa/address.h: ditto.

2019-06-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Address edit widget cosmetics

	* libbalsa/address.c (lba_addr_list_widget): put the GtkTreeView
	in a GtkFrame;
	(libbalsa_address_set_edit_entries),
	(libbalsa_address_get_edit_widget),
	(libbalsa_address_new_from_edit_entries): use gtk_bin_get_child()
	to get the GtkTreeView from the GtkFrame.

2019-06-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	address-book-rubrica: Do not crash on bad card

	Do not crash if a card has multiple "Net" sections

	* libbalsa/address-book-rubrica.c (extract_cards): Call
	libbalsa_address_set_addr_list() only once, even when a card has
	multiple "Net" sections.

2019-06-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/address-book-rubrica.c
	(libbalsa_address_book_rubrica_modify_address): Fix the search
	for the card matching a given full-name.

2019-06-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Guard against null string.

	* libbalsa/abook-completion.c (completion_data_new):

2019-06-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Fix a thinko

	* libbalsa/address.c (libbalsa_address_new_from_edit_entries):

2019-06-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Allow address == NULL in libbalsa_address_set_edit_entries() and
	libbalsa_address_get_edit_widget()

	because the address book editor uses that.

	* libbalsa/address.c (libbalsa_address_set_edit_entries),
	(libbalsa_address_get_edit_widget),
	(libbalsa_address_new_from_edit_entries):

2019-06-18  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix crash using incomplete VCard items

	* libbalsa/address.c (vcard_strsplit): Ensure that the array
	  contains always 5 items.

2019-06-11  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Add -Wredundant-decls -Wshadow -Wformat-security compiler warnings

	* configure.ac:
	* meson.build:

2019-06-10  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix format string error

	* src/sendmsg-window.c (sw_insert_sig_activated): fix a “format
	  not a string literal and no format arguments” error (using
	    gcc w/ -Werror=format-security).

2019-06-10  Albrecht Dreß  <albrecht.dress@arcor.de>

	Implement VCalendar stuff using G_*_TYPE()

	* libbalsa/rfc2445.[ch]: implement LibBalsaVCal and LibBalsaVEvent
	  using G_DECLARE_FINAL_TYPE() and G_DEFINE_TYPE(); make the data
	  fields private; implement private member getters required for
	  display and printing
	* src/balsa-mime-widget-vcalendar.c: use new LibBalsaVCal and
	  LibBalsaVEvent getters; add missing “Created” DTSTAMP item
	* src/balsa-print-object-text.c: use new LibBalsaVCal and
	  LibBalsaVEvent getters; add missing “Created” DTSTAMP item;
	  use same labels as for screen display

2019-06-08  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaVfs

	Make the object private, and move the members of
	LibBalsaVfsPriv into LibBalsaVfs; as a final
	type, it does not need a private struct.

	* libbalsa/files.c (libbalsa_icon_finder):
	* libbalsa/libbalsa-vfs.c (libbalsa_vfs_class_init),
	(libbalsa_vfs_init), (libbalsa_vfs_finalize),
	(libbalsa_vfs_new_from_uri), (libbalsa_vfs_append),
	(libbalsa_vfs_dir_append), (libbalsa_vfs_get_folder),
	(libbalsa_vfs_get_uri), (libbalsa_vfs_get_uri_utf8),
	(libbalsa_vfs_get_basename_utf8), (libbalsa_vfs_get_mime_type),
	(libbalsa_vfs_get_charset), (libbalsa_vfs_get_text_attr),
	(libbalsa_vfs_get_size), (libbalsa_vfs_create_stream),
	(libbalsa_vfs_file_exists), (libbalsa_vfs_is_regular_file),
	(libbalsa_vfs_file_unlink), (libbalsa_vfs_launch_app),
	(libbalsa_vfs_launch_app_for_body), (gio_add_vfs_menu_item),
	(libbalsa_vfs_fill_menu_by_content_type),
	(libbalsa_vfs_mime_button):
	* libbalsa/libbalsa-vfs.h:

2019-06-08  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaServerCfg

	Make the object private, and move the members of
	LibBalsaServerCfgPrivate into LibBalsaServerCfg; as a final
	type, it does not need a private struct.

	* libbalsa/server-config.c (libbalsa_server_cfg_new),
	(libbalsa_server_cfg_valid), (libbalsa_server_cfg_add_check),
	(libbalsa_server_cfg_add_entry), (libbalsa_server_cfg_add_item),
	(libbalsa_server_cfg_add_row), (libbalsa_server_cfg_get_name),
	(libbalsa_server_cfg_assign_server), (libbalsa_server_cfg_init),
	(on_server_cfg_changed):
	* libbalsa/server-config.h:

2019-06-08  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaSmtpServer

	The object was already private.

	* libbalsa/smtp-server.c (libbalsa_smtp_server_finalize),
	(libbalsa_smtp_server_class_init), (libbalsa_smtp_server_init):
	* libbalsa/smtp-server.h:

2019-06-08  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaImapServer

	The object was already private.

	* libbalsa/imap-server.c (libbalsa_imap_server_set_username),
	(libbalsa_imap_server_set_host), (libbalsa_imap_server_class_init),
	(libbalsa_imap_server_finalize):
	* libbalsa/imap-server.h:

2019-06-07  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_DERIVABLE_TYPE to declare LibBalsaServer

	and provide and use the necessary getters and setters.

	* libbalsa/folder-scanners.c (libbalsa_scanner_imap_tree):
	* libbalsa/imap-server.c (libbalsa_imap_server_set_username),
	(libbalsa_imap_server_set_host), (libbalsa_imap_server_init),
	(is_info_cb), (lb_imap_server_info_new),
	(libbalsa_imap_server_new_from_config), (handle_connection_error),
	(libbalsa_imap_server_get_handle),
	(libbalsa_imap_server_get_handle_with_user),
	(libbalsa_imap_server_subscriptions):
	* libbalsa/mailbox_imap.c (get_header_cache_path),
	(get_cache_name_pair), (libbalsa_mailbox_imap_reconnect),
	(libbalsa_imap_url), (libbalsa_mailbox_imap_add_messages),
	(libbalsa_mailbox_imap_messages_copy):
	* libbalsa/mailbox_pop3.c (libbalsa_mailbox_pop3_init),
	(libbalsa_mailbox_pop3_startup), (update_msg_list),
	(libbalsa_mailbox_pop3_check):
	* libbalsa/send.c (lbs_check_reachable_cb),
	(lbs_process_queue_init_session):
	* libbalsa/server-config.c (libbalsa_server_cfg_new),
	(libbalsa_server_cfg_assign_server), (server_cfg_security_widget):
	* libbalsa/server.c (libbalsa_server_class_init),
	(libbalsa_server_init), (libbalsa_server_finalize),
	(libbalsa_server_set_password), (lbs_get_password),
	(libbalsa_server_real_set_username),
	(libbalsa_server_real_set_host),
	(libbalsa_server_load_security_config), (store_password_libsecret),
	(load_password_libsecret), (erase_password_libsecret),
	(libbalsa_server_load_config), (libbalsa_server_save_config),
	(libbalsa_server_get_auth), (libbalsa_server_get_cert_pass),
	(libbalsa_server_test_can_reach_full),
	(libbalsa_server_test_can_reach), (libbalsa_server_get_host),
	(libbalsa_server_get_user), (libbalsa_server_get_cert_file),
	(libbalsa_server_get_protocol), (libbalsa_server_get_password),
	(libbalsa_server_get_cert_passphrase),
	(libbalsa_server_get_security),
	(libbalsa_server_get_try_anonymous),
	(libbalsa_server_get_client_cert),
	(libbalsa_server_get_remember_password),
	(libbalsa_server_get_remember_cert_passphrase),
	(libbalsa_server_set_protocol), (libbalsa_server_set_cert_file),
	(libbalsa_server_set_security),
	(libbalsa_server_set_try_anonymous),
	(libbalsa_server_set_remember_password),
	(libbalsa_server_set_client_cert),
	(libbalsa_server_set_remember_cert_passphrase):
	* libbalsa/server.h:
	* libbalsa/smtp-server.c (libbalsa_smtp_server_init),
	(libbalsa_smtp_server_new):
	* libinit_balsa/assistant_page_user.c (create_pop3_mbx),
	(create_imap_mbx):
	* src/balsa-app.c (ask_password_real),
	(balsa_get_short_mailbox_name):
	* src/folder-conf.c (folder_conf_imap_sub_node):
	* src/mailbox-node.c (imap_dir_cb),
	(balsa_mailbox_node_new_from_config), (balsa_mailbox_node_is_imap):
	* src/save-restore.c (migrate_imap_mailboxes):

2019-06-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove redundant declarations

	and rename libbalsa_identity_new_config() to
	libbalsa_identity_new_from_config().

	* libbalsa/identity.c (libbalsa_identity_new_from_config):
	* libbalsa/identity.h:
	* src/save-restore.c (config_identity_load),
	(config_identities_load):

2019-06-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaIdentity

	Make the structure private, and provide and use the necessary
	getters and setters.

	* libbalsa/autocrypt.c (autocrypt_header):
	* libbalsa/autocrypt.h:
	* libbalsa/identity.c (libbalsa_identity_finalize),
	(libbalsa_identity_new_with_name), (libbalsa_identity_set_address),
	(libbalsa_identity_set_domain), (libbalsa_identity_get_signature),
	(libbalsa_identity_get_sig_prepend),
	(libbalsa_identity_get_sig_whenreply),
	(libbalsa_identity_get_sig_whenforward),
	(libbalsa_identity_get_sig_sending),
	(libbalsa_identity_get_send_mp_alternative),
	(libbalsa_identity_get_request_mdn),
	(libbalsa_identity_get_request_dsn),
	(libbalsa_identity_get_warn_send_plain),
	(libbalsa_identity_get_always_trust),
	(libbalsa_identity_get_gpg_sign),
	(libbalsa_identity_get_gpg_encrypt),
	(libbalsa_identity_get_sig_executable),
	(libbalsa_identity_get_sig_separator),
	(libbalsa_identity_get_crypt_protocol),
	(libbalsa_identity_get_identity_name),
	(libbalsa_identity_get_force_gpg_key_id),
	(libbalsa_identity_get_force_smime_key_id),
	(libbalsa_identity_get_replyto), (libbalsa_identity_get_bcc),
	(libbalsa_identity_get_reply_string),
	(libbalsa_identity_get_forward_string),
	(libbalsa_identity_get_domain), (libbalsa_identity_get_face_path),
	(libbalsa_identity_get_x_face_path),
	(libbalsa_identity_get_signature_path),
	(libbalsa_identity_get_address),
	(libbalsa_identity_get_smtp_server),
	(libbalsa_identity_get_autocrypt_mode):
	* libbalsa/identity.h:
	* libbalsa/send.c (libbalsa_message_create_mime_message),
	(lb_send_from):
	* src/balsa-message.c (handle_mdn_request), (create_mdn_reply),
	(mdn_dialog_response), (autocrypt_in_use):
	* src/balsa-mime-widget-message.c (extbody_send_mail):
	* src/balsa-mime-widget-vcalendar.c (balsa_vevent_widget),
	(vevent_reply):
	* src/mailbox-conf.c (mailbox_conf_view_check):
	* src/save-restore.c (config_identity_load),
	(config_identities_save):
	* src/sendmsg-window.c (replace_identity_signature),
	(update_bsmsg_identity), (create_email_entry),
	(sw_insert_sig_activated), (generate_forwarded_subject),
	(bsmsg_set_subject_from_body), (set_identity_from_mailbox),
	(guess_identity_from_list), (setup_headers_from_identity),
	(sw_cc_add_list), (insert_initial_sig), (bsmsg2message),
	(check_suggest_encryption), (check_autocrypt_recommendation),
	(send_message_handler), (bsmsg_update_gpg_ui_on_ident_change),
	(sendmsg_window_new), (sendmsg_window_compose),
	(sendmsg_window_reply), (sendmsg_window_reply_embedded),
	(sendmsg_window_forward):

2019-06-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaCellRendererButton

	The object was already private.

	* libbalsa/cell-renderer-button.h:

2019-06-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaAddressView

	The object was already private.

	* libbalsa/address-view.h:

2019-06-03  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaAddress

	Make the structure private, and provide and use the necessary
	getters and setters.

	* libbalsa/abook-completion.c (address_compare):
	* libbalsa/address-book-extern.c (lbe_load_cb),
	(libbalsa_address_book_externq_add_address):
	* libbalsa/address-book-gpe.c (gpe_read_attr), (create_name),
	(gpe_read_address):
	* libbalsa/address-book-ldap.c
	(libbalsa_address_book_ldap_get_address),
	(libbalsa_address_book_ldap_add_address),
	(libbalsa_address_book_ldap_remove_address),
	(libbalsa_address_book_ldap_modify_address):
	* libbalsa/address-book-ldif.c (build_name), (address_new_prefill),
	(lbab_ldif_write_dn), (lbab_ldif_write_addresses),
	(lbab_ldif_write_surname), (lbab_ldif_write_givenname),
	(lbab_ldif_write_nickname), (lbab_ldif_write_organization):
	* libbalsa/address-book-osmo.c (utf8_lba_strstr),
	(libbalsa_address_book_osmo_alias_complete), (osmo_read_addresses):
	* libbalsa/address-book-rubrica.c
	(libbalsa_address_book_rubrica_load),
	(libbalsa_address_book_rubrica_add_address),
	(libbalsa_address_book_rubrica_modify_address),
	(lbab_rubrica_load_xml), (lbab_insert_address_node),
	(extract_cards):
	* libbalsa/address-book-text.c (lbab_text_item_compare),
	(lbab_text_load_file), (libbalsa_address_book_text_load):
	* libbalsa/address-book-vcard.c (lbab_vcard_write_fn),
	(lbab_vcard_write_n), (lbab_vcard_write_nickname),
	(lbab_vcard_write_org), (lbab_vcard_write_addresses),
	(libbalsa_address_book_vcard_parse_address):
	* libbalsa/address-book.c:
	* libbalsa/address-book.h:
	* libbalsa/address.c (libbalsa_address_class_init),
	(libbalsa_address_init), (libbalsa_address_finalize),
	(libbalsa_address_new_from_vcard), (libbalsa_address_set_copy),
	(libbalsa_address_to_gchar), (lba_get_name_or_mailbox),
	(libbalsa_address_get_name_from_list),
	(libbalsa_address_get_mailbox_from_list),
	(libbalsa_address_n_mailboxes_in_list),
	(libbalsa_address_set_edit_entries), (lba_addr_list_widget),
	(addrlist_drag_received_cb), (libbalsa_address_get_edit_widget),
	(libbalsa_address_new_from_edit_entries),
	(libbalsa_address_compare), (libbalsa_address_get_full_name),
	(libbalsa_address_get_first_name),
	(libbalsa_address_get_last_name), (libbalsa_address_get_nick_name),
	(libbalsa_address_get_organization), (libbalsa_address_get_addr),
	(libbalsa_address_get_addr_list), (libbalsa_address_set_full_name),
	(libbalsa_address_set_first_name),
	(libbalsa_address_set_last_name), (libbalsa_address_set_nick_name),
	(libbalsa_address_set_organization),
	(libbalsa_address_set_addr_list), (libbalsa_address_add_addr):
	* libbalsa/address.h:
	* libbalsa/rfc2445.c (libbalsa_vevent_reply),
	(cal_address_2445_to_lbaddress):
	* libbalsa/rfc6350.c (rfc6350_parse_from_stream),
	(rfc6350_eval_line):
	* src/ab-main.c (bab_load_cb):
	* src/ab-window.c (balsa_ab_window_load_cb):
	* src/balsa-mime-widget-text.c (bm_widget_new_vcard):
	* src/balsa-mime-widget-vcalendar.c (balsa_vevent_widget):
	* src/balsa-print-object-text.c (balsa_print_object_text_vcard):
	* src/store-address.c (store_address_add_address),
	(store_address_add_lbaddress):

2019-06-02  Albrecht Dreß  <albrecht.dress@arcor.de>

	GMimeGpgmeSigstat: use G_DECLARE_FINAL_TYPE(), G_DEFINE_TYPE()

	* libbalsa/gmime-gpgme-signature.ch: implement GMimeGpgmeSigstat
	  using G_DECLARE_FINAL_TYPE() and G_DEFINE_TYPE();
	  implement getter/setter functions
	* libbalsa/body.c, libbalsa/gmime-multipart-crypt.c, libbalsa/rfc3156.c,
	  src/balsa-message.c, src/balsa-mime-widget-crypto.c,
	  src/balsa-mime-widget-message.c, src/balsa-print-object-header.c:
	  use getter functions instead of accessing the object properties
	* libbalsa/libbalsa-gpgme.c: use setter functions
	  instead of manipulating the object propertiy directly
	* libbalsa/libbalsa-gpgme-widgets.[ch]: key argument to libbalsa_gpgme_key() is const

2019-06-02  Albrecht Dreß  <albrecht.dress@arcor.de>

	Make GpgME/E2EE support a hard requirement

	* INSTALL: ancient file, add pointer to README
	* README: remove --with-gpgme option; add gpgme as requirement;
	  briefly describe Balsa's E2EE support; clarify --with-libsecret
	* configure.ac, meson.build, meson_options.txt: remove --with-gpgme option;
	  fail if gpgme-config is unavailable; require gpgme >= 1.6.0
	* libbalsa/Makefile.am, libbalsa/meson.build: remove conditional building with/without gpgme
	* libbalsa/body.[ch], libbalsa/imap-server.c,
	  libbalsa/mailbox.[ch], libbalsa/message.[ch],
	  libbalsa/rfc3156.[ch], libbalsa/send.[ch],
	  src/balsa-app.[ch], src/balsa-icons.[ch],
	  src/balsa-message.[ch], src/balsa-mime-widget-crypto.[ch],
	  src/balsa-mime-widget-message.c, src/balsa-mime-widget-multipartc,
	  src/balsa-mime-widget.c, src/balsa-print-object-header.[ch],
	  src/balsa-print-object.c, src/main.c, src/print-gtk.c,
	  src/save-restore.c, src/sendmsg-window.[ch],
	  src/toolbar-factory.c: remove conditional compilation (HAVE_GPGME)
	* libbalsa/identity.c: remove conditional compilation (HAVE_GPGME);
	  simplify append_ident_notebook_page()
	* src/mailbox-conf.c: remove conditional compilation (HAVE_GPGME);
	  remove useless scope in mailbox_conf_view_new_full()

2019-06-02  Albrecht Dreß  <albrecht.dress@arcor.de>

	libnetclient: use G_DECLARE*

	* libnetclient/net-client-pop.[ch]: use G_DECLARE_FINAL_TYPE(),
	  and drop storing the private object data in a separate structure;
	  • net_client_pop_get_capa(): enable pipelining only if included
	    in the server's capabilities
	* libnetclient/net-client-siobuf.[ch], libnetclient/net-client-smtp.[ch]:
	  use G_DECLARE_FINAL_TYPE(), and drop storing the private object
	  data in a separate structure
	* libnetclient/net-client-utils.h: suppress Flexelint 9.00 false-positive
	* libnetclient/net-client.[hc]: use G_DECLARE_DERIVABLE_TYPE();
	  use net_client_get_instance_private() to access private data

2019-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/imap/imap-commands.h: remove redundant declaration of
	imap_mbox_handle_can_do().

2019-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/address-book-rubrica.c (lbab_rubrica_load_xml):
	  reduce scope of a GList* variable so that another does not
	  shadow it.

2019-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	various: remove redundant declarations

	Some cleanup from using G_DEFINE_TYPE{,WITH_PRIVATE} macros

	* libbalsa/gmime-filter-header.c:
	* libbalsa/server-config.c:
	* src/main-window.c:

2019-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	address-books: remove redundant declarations

	Some cleanup from using G_DECLARE_{DERIVABLE,FINAL}_TYPE macros

	* libbalsa/address-book-ldap.c:
	* libbalsa/address-book-osmo.h:
	* libbalsa/address-book-rubrica.c:
	* libbalsa/address-book-text.c:
	* libbalsa/address-book-vcard.c:

2019-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaAddressBookVcard

	Make the structure private; no need for getters and setters.

	* libbalsa/address-book-vcard.c (libbalsa_address_book_vcard_init),
	  (libbalsa_address_book_vcard_new):
	* libbalsa/address-book-vcard.h:

2019-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* meson.build: specify meson version >= 0.43

2019-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* meson.build: Bump default version to 2.5.7;
	  use compiler.get_supported_arguments() to check all arguments at once,
	  instead of looping through a list and checking them one at a time.

2019-05-26  Pawel Salek  <pawsa0@gmail.com>

	* NEWS, configure.ac: correct typos; bump version base for git builds.

2019-05-25  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaAddressBookRubrica

	Make the structure private; no need for getters and setters.

	* libbalsa/address-book-rubrica.c:
	* libbalsa/address-book-rubrica.h:

2019-05-25  Pawel Salek  <pawsa0@gmail.com>

	* NEWS, configure.ac: Release balsa-2.5.7

2019-05-22  Albrecht Dreß  <albrecht.dress@arcor.de>

	Mitigate “Re: What's Up Johnny?” vulnerabilities

	* src/balsa-app.h: add flag whether the user wants to be warned
	  when replying to an encrypted message
	* src/save-restore.c:
	  • save/restore new flag
	  • add reply selection dialogue to geometry manager
	* src/sendmsg-window.c:
	  • tree_add_quote_body(): refactoring, add information whether
	    the part has been decrypted
	  • scan_bodies(): use new tree_add_quote_body(), propagate
	    information about encrypted containers
	  • unselect_decrypted(): new function for deselecting all
	    decrypted parts in the dialogue for selecting cited parts
	  • quote_parts_select_dlg(): add message when replying to a
	    fully or partially encrypted message, use geometry manager
	  • show_decrypted_warning(): show dialogue when the user
	    replies to a single-part decrypted message
	  • collect_for_quote(): use new scan_bodies() api

2019-05-16  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Do not break user's config

	* libbalsa/address-book.c
	(libbalsa_address_book_new_from_config): if the type is
	LibBalsaAddressBookExtern, it is no longer recognized, so we use
	LibBalsaAddressBookExternq instead.

2019-05-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaAddressBookOsmo

	Make the structure private; no need for getters and setters.

	Adopt ab_osmo as the identifier.

	* libbalsa/address-book-osmo.c (osmo_read_addresses):
	* libbalsa/address-book-osmo.h:

2019-05-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaAddressBookLdif

	Make the structure private; no need for getters and setters.

	* libbalsa/address-book-ldif.c (libbalsa_address_book_ldif_init),
	(libbalsa_address_book_ldif_new):
	* libbalsa/address-book-ldif.h:

2019-05-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaAddressBookLdap

	Make the structure private, and provide and use the necessary
	getters and setters.

	Adopt ab_ldap as the identifier.

	* libbalsa/address-book-ldap.c
	(libbalsa_address_book_ldap_class_init),
	(libbalsa_address_book_ldap_init),
	(libbalsa_address_book_ldap_finalize),
	(libbalsa_address_book_ldap_new),
	(libbalsa_address_book_ldap_close_connection), (abl_interaction),
	(libbalsa_address_book_ldap_open_connection),
	(libbalsa_address_book_ldap_load),
	(libbalsa_address_book_ldap_get_address),
	(libbalsa_address_book_ldap_add_address),
	(libbalsa_address_book_ldap_remove_address),
	(libbalsa_address_book_ldap_modify_address),
	(libbalsa_address_book_ldap_save_config),
	(libbalsa_address_book_ldap_load_config),
	(libbalsa_address_book_ldap_alias_complete),
	(libbalsa_address_book_ldap_get_host),
	(libbalsa_address_book_ldap_get_base_dn),
	(libbalsa_address_book_ldap_get_bind_dn),
	(libbalsa_address_book_ldap_get_passwd),
	(libbalsa_address_book_ldap_get_book_dn),
	(libbalsa_address_book_ldap_get_enable_tls),
	(libbalsa_address_book_ldap_set_host),
	(libbalsa_address_book_ldap_set_base_dn),
	(libbalsa_address_book_ldap_set_bind_dn),
	(libbalsa_address_book_ldap_set_passwd),
	(libbalsa_address_book_ldap_set_book_dn),
	(libbalsa_address_book_ldap_set_enable_tls):
	* libbalsa/address-book-ldap.h:
	* src/address-book-config.c (create_ldap_dialog), (create_book),
	(modify_book):

2019-05-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaAddressBookGpe

	Make the structure private; no need for getters and setters.

	Adopt ab_gpe as the identifier.

	* libbalsa/address-book-gpe.c
	(libbalsa_address_book_gpe_class_init),
	(libbalsa_address_book_gpe_init),
	(libbalsa_address_book_gpe_finalize),
	(libbalsa_address_book_gpe_new),
	(libbalsa_address_book_gpe_close_db),
	(libbalsa_address_book_gpe_open_db), (gpe_read_address),
	(libbalsa_address_book_gpe_load):
	* libbalsa/address-book-gpe.h:

2019-05-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	address-book: Adopt ab as the identifier

	* libbalsa/address-book.c (libbalsa_address_book_new_from_config):
	* libbalsa/address-book.h:

2019-05-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_FINAL_TYPE to declare LibBalsaAddressBookExternq

	Make the structure private, and provide and use the necessary
	getters and setters.

	Adopt libbalsa_address_book_externq as the namespace, and
	ab_externq as the identifier.

	* libbalsa/address-book-extern.c
	(libbalsa_address_book_externq_class_init),
	(libbalsa_address_book_externq_init),
	(libbalsa_address_book_externq_finalize),
	(libbalsa_address_book_externq_new), (lbe_load_cb),
	(libbalsa_address_book_externq_load), (parse_externq_file),
	(libbalsa_address_book_externq_add_address),
	(libbalsa_address_book_externq_save_config),
	(libbalsa_address_book_externq_load_config),
	(libbalsa_address_book_externq_alias_complete),
	(libbalsa_address_book_externq_get_load),
	(libbalsa_address_book_externq_get_save),
	(libbalsa_address_book_externq_set_load),
	(libbalsa_address_book_externq_set_save):
	* libbalsa/address-book-extern.h:
	* libbalsa/libbalsa.c (libbalsa_init):
	* src/ab-main.c (bab_window_set_title),
	(file_new_externq_activated), (get_main_menu), (bab_init):
	* src/ab-window.c (balsa_ab_window_set_title):
	* src/address-book-config.c (create_dialog_from_type),
	(create_externq_dialog), (handle_close), (create_book),
	(modify_book), (add_externq_cb):
	* src/pref-manager.c (update_address_books):

2019-05-14  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_DERIVABLE_TYPE to declare LibBalsaAddressBookText

	and provide and use the necessary getters and setters.

	* libbalsa/address-book-ldif.c (libbalsa_address_book_ldif_new):
	* libbalsa/address-book-rubrica.c
	(libbalsa_address_book_rubrica_class_init),
	(libbalsa_address_book_rubrica_init),
	(libbalsa_address_book_rubrica_new),
	(libbalsa_address_book_rubrica_load),
	(libbalsa_address_book_rubrica_alias_complete),
	(libbalsa_address_book_rubrica_add_address),
	(libbalsa_address_book_rubrica_modify_address),
	(lbab_rubrica_load_xml):
	* libbalsa/address-book-text.c (lbab_text_item_free),
	(libbalsa_address_book_text_class_init),
	(libbalsa_address_book_text_init),
	(libbalsa_address_book_text_finalize),
	(lbab_text_address_book_need_reload), (lbab_text_load_file),
	(lbab_text_lock_book), (lbab_text_unlock_book),
	(lbab_text_open_temp), (lbab_text_close_temp),
	(libbalsa_address_book_text_load),
	(libbalsa_address_book_text_add_address),
	(libbalsa_address_book_text_modify_address),
	(libbalsa_address_book_text_save_config),
	(libbalsa_address_book_text_load_config),
	(libbalsa_address_book_text_alias_complete),
	(libbalsa_address_book_text_get_path),
	(libbalsa_address_book_text_get_item_list),
	(libbalsa_address_book_text_get_mtime),
	(libbalsa_address_book_text_get_name_complete),
	(libbalsa_address_book_text_set_path),
	(libbalsa_address_book_text_set_item_list),
	(libbalsa_address_book_text_set_mtime),
	(libbalsa_address_book_text_set_name_complete):
	* libbalsa/address-book-text.h:
	* libbalsa/address-book-vcard.c (libbalsa_address_book_vcard_new):
	* src/address-book-config.c (create_local_dialog), (modify_book):

2019-05-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use G_DECLARE_DERIVABLE_TYPE to declare LibBalsaAddressBook

	The macro defines _LibBalsaAddressBook to be a bare structure
	with a single GObject member. The instance data must be in a
	_LibBalsaAddressBookPrivate structure, access to which is
	channeled through getters and setters.

	* libbalsa/address-book-extern.c
	(libbalsa_address_book_externq_new),
	(libbalsa_address_book_externq_alias_complete):
	* libbalsa/address-book-gpe.c (libbalsa_address_book_gpe_init),
	(libbalsa_address_book_gpe_new), (libbalsa_address_book_gpe_load):
	* libbalsa/address-book-ldap.c (libbalsa_address_book_ldap_init),
	(libbalsa_address_book_ldap_new),
	(libbalsa_address_book_ldap_open_connection),
	(libbalsa_address_book_ldap_add_address),
	(libbalsa_address_book_ldap_remove_address),
	(libbalsa_address_book_ldap_modify_address),
	(libbalsa_address_book_ldap_load_config),
	(libbalsa_address_book_ldap_alias_complete):
	* libbalsa/address-book-ldif.c (libbalsa_address_book_ldif_new):
	* libbalsa/address-book-osmo.c (libbalsa_address_book_osmo_init),
	(libbalsa_address_book_osmo_new),
	(libbalsa_address_book_osmo_load),
	(libbalsa_address_book_osmo_alias_complete):
	* libbalsa/address-book-rubrica.c
	(libbalsa_address_book_rubrica_new),
	(libbalsa_address_book_rubrica_alias_complete),
	(lbab_rubrica_load_xml):
	* libbalsa/address-book-text.c (lbab_text_load_file),
	(libbalsa_address_book_text_alias_complete):
	* libbalsa/address-book-vcard.c (libbalsa_address_book_vcard_new):
	* libbalsa/address-book.c (libbalsa_address_book_class_init),
	(libbalsa_address_book_init), (libbalsa_address_book_finalize),
	(libbalsa_address_book_set_status),
	(libbalsa_address_book_load_config),
	(libbalsa_address_is_dist_list),
	(libbalsa_address_book_real_save_config),
	(libbalsa_address_book_real_load_config),
	(libbalsa_address_book_strerror),
	(libbalsa_address_book_get_expand_aliases),
	(libbalsa_address_book_get_is_expensive),
	(libbalsa_address_book_get_dist_list_mode),
	(libbalsa_address_book_get_name),
	(libbalsa_address_book_get_config_prefix),
	(libbalsa_address_book_set_name),
	(libbalsa_address_book_set_is_expensive),
	(libbalsa_address_book_set_expand_aliases),
	(libbalsa_address_book_set_dist_list_mode):
	* libbalsa/address-book.h:
	* libbalsa/address-view.c (lbav_get_matching_addresses):
	* src/ab-main.c (bab_set_address_book), (bab_window_set_title),
	(address_book_change_state), (set_address_book_menu_items),
	(address_book_change), (file_delete_activated),
	(bab_set_intial_address_book):
	* src/ab-window.c (balsa_ab_window_load_books),
	(balsa_ab_window_init), (balsa_ab_window_set_title),
	(balsa_ab_window_load), (balsa_ab_window_dist_mode_toggled),
	(balsa_ab_window_menu_changed):
	* src/address-book-config.c (add_radio_buttons),
	(create_local_dialog), (create_osmo_dialog),
	(create_externq_dialog), (create_ldap_dialog), (create_gpe_dialog),
	(create_book), (modify_book):
	* src/pref-manager.c (update_address_books):
	* src/save-restore.c (address_book_section_path),
	(config_address_book_delete), (config_save):
	* src/store-address.c (store_address_book_frame),
	(store_address_add_list):

2019-05-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Clean up conditional compilations after bumping required
	versions.

	* libbalsa/libbalsa.c (libbalsa_dialog_flags):
	* libbalsa/libbalsa.h:
	* src/ab-main.c (libbalsa_dialog_flags):
	* src/ab-window.c (balsa_ab_window_new):
	* src/balsa-message.c (balsa_message_init):
	* src/balsa-mime-widget-image.c (balsa_mime_widget_image_dispose),
	(balsa_mime_widget_new_image):
	* src/filter-run-dialog.c (balsa_filter_run_dialog_new):
	* src/pref-manager.c (pm_grid_attach):

2019-05-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Bump required version of GLib to 2.48, and Gtk3 to 3.18

	* configure.ac:
	* meson.build:

2019-05-12  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix “Johnny you are fired” vulnerabilities

	* configure.ac: require gnutls >= 3.0
	* libbalsa/body.[ch]: add helper functions for detecting multipart
	    and inline signed bodies
	* libbalsa/gmime-gpgme-signature.[ch]:
	  • g_mime_gpgme_sigstat_new_from_gpgme_ctx() classify multiple
	    signatures as possible attack, always load key if available;
	  • add g_mime_gpgme_sigstat_info() giving the protocol,
	    signer and signature status;
	  • g_mime_gpgme_sigstat_to_gchar() use changed
	    libbalsa_gpgme_sig_stat_to_gchar() interface, hide signature
	    timestamp if it is missing;
	  • add g_mime_gpgme_sigstat_signer() to get the OpenPGP or
	    S/MIME signer as human-readable string;
	  • add tokenize_subject() and cert_subject_cn_mail()
	    for better evaluation of a certificate DN, and use them in
	    libbalsa_cert_subject_readable()
	* libbalsa/html.c: fix segfault on NULL body (detected with one
	    of the broken “Johnny” samples)
	* libbalsa/libbalsa-gpgme.[ch]:
	  • add libbalsa_gpgme_protocol_name() to get consistent
	    protocol naming (replaces gpgme_get_protocol_name() or
	    hardcoded values);
	  • define error code for multiple signatures
	* libbalsa/rfc3156.[ch]:
	  • change libbalsa_gpgme_sig_stat_to_gchar() to return a
	    newly allocated string, possibly including error information
	    from gpgme;
	  • remove duplicated #define's
	* src/balsa-message.c:#
	  • get_crypto_content_icon() print extended signature info
	    in the tree view;
	  • libbalsa_msg_try_mp_signed() and libbalsa_msg_part_2440()
	    use new libbalsa_gpgme_sig_stat_to_gchar() api
	* src/balsa-mime-widget-crypto.c: drop code to
	    load a signature's key as this is now done in
	    g_mime_gpgme_sigstat_new_from_gpgme_ctx()
	* src/balsa-mime-widget-message.c:
	  • use new helpers for detecting signed parts;
	  • use new libbalsa_gpgme_sig_stat_to_gchar() api
	* src/balsa-print-object-header.[ch]:
	  • use new helpers for detecting signed parts and
	    g_mime_gpgme_sigstat_info();
	  • remove now unused parameter from
	    balsa_print_object_header_crypto(), and drop code to load a
	    signature's key
	* src/balsa-print-object.c: use modified
	    balsa_print_object_header_crypto() api
	* src/print-gtk.c: refactoring and simplification of printing
	    signed and/or encrypted parts
	* src/sendmsg-window.c: use libbalsa_gpgme_protocol_name()

2019-05-11  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix issue #15: NULL-pointer deref in pop3 code

	* libnetclient/net-client-pop.c: make sure
	net_client_pop_read_reply() does not return a NULL server reply
	string on success (fix issue #15)
	* libnetclient/net-client-siobuf.c: silence a bunch of Flexelint
	warnings, no change in code behaviour
	* libnetclient/test/echoserver.py: add missing executable flag

2019-05-10  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-message.c (bm_find_bar_new): connect to
	GtkSearchEntry's "search-changed" signal instead of GtkEditable's
	"changed" signal; it provides a 150 msec delay:
	"To make filtering appear more reactive, it is a good idea
	to not react to every change in the entry text immediately,
	but only after a short delay. To support this, GtkSearchEntry
	emits the “search-changed” signal which can be used instead
	of the “changed” signal."


2019-05-10  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main-window: Clear the view filter when the search text is
	cleared.

	* src/main-window.c (bw_sos_icon_release): callback for the
	"icon-release" signal from the GtkEntry; act on it.
	(bw_create_index_widget): connect to the signal.

2019-05-09  Peter Bloomfield  <pbloomfield@bellsouth.net>

	main-window: Port the subject-or-sender search bar to GtkSearchEntry

	* src/main-window.c (bw_create_index_widget):

2019-05-09  Peter Bloomfield  <pbloomfield@bellsouth.net>

	balsa-message: Port the find-in-message bar to GtkSearchBar and
	GtkSearchEntry

	* src/balsa-message.c (bm_find_bar_new), (bm_disable_find_entry),
	(balsa_message_init), (balsa_message_find_in_message):

2019-05-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-local: Use g_ptr_array_new_with_free_func() to manage
	deallocation of threading_info structures.

	* libbalsa/mailbox_local.c
	(libbalsa_mailbox_local_set_threading_info),
	(libbalsa_mailbox_local_msgno_removed)

2019-05-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox: Use g_ptr_array_new_with_free_func() to manage
	deallocation of LibBalsaMailboxIndexEntry.

	* libbalsa/mailbox.c (lbm_index_entry_free),
	(libbalsa_mailbox_free_mindex), (libbalsa_mailbox_open),
	(libbalsa_mailbox_msgno_removed)

2019-05-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-mbox: Use g_ptr_array_new_with_free_func() to manage
	deallocation of message_info structures.

	* libbalsa/mailbox_mbox.c (free_message_info): refactor;
	(libbalsa_mailbox_mbox_open): use g_ptr_array_new_with_free_func()
	instead of g_ptr_array_new();
	(libbalsa_mailbox_mbox_check),
	(libbalsa_mailbox_mbox_close_mailbox),
	(libbalsa_mailbox_mbox_sync): no need to manually deallocate.

2019-04-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	address-view: drop almost duplicate code

	* libbalsa/address-view.c (lbav_insert_text_cb): use
	lbav_clean_text to replace non-printable chars by spaces,
	instead of using almost duplicative code.

2019-04-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	send: Fix a compiler warning

	* libbalsa/send.c (libbalsa_set_message_id): strncpy() with n ==
	sizeof(dest) generates:
	"error: ‘__builtin_strncpy’ specified bound 16 equals
	destination size [-Werror=stringop-truncation]"
	We now specify one fewer bytes, and explicitly nullify the last
	byte.

2019-04-18  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix the build after commit e92ec3140a1c81dbf86d90d0155cb2e08f519db2

	* src/main-window.c (bw_update_progress_bar): cast with
	'(GSourceFunc)', not with 'G_SOURCE_FUNC()', since we do not yet
	require GLib 2.58!

2019-04-18  Albrecht Dreß  <albrecht.dress@arcor.de>

	geometry-manager: Remove a not-reached assertion

	* libbalsa/geometry-manager.c (geometry_manager_init): a second
	call with the same key is not necessarily an error.

2019-04-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Call Gtk only from the main thread
	https://mail.gnome.org/archives/balsa-list/2019-April/msg00006.html

	* src/main-window.c (bw_update_progress_bar_idle_cb): idle
	handler for calling gtk_status_bar_set_{fraction,text};
	(bw_update_progress_bar): schedule the idle handler;
	(bw_progress_bar_set_text), (bw_progress_bar_set_fraction):
	convenience functions for calling bw_update_progress_bar();
	(balsa_window_increase_activity),
	(balsa_window_decrease_activity), (balsa_window_setup_progress),
	(balsa_window_increment_progress): use them.

2019-04-03  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use more precise types

	* libbalsa/mailbox.c (mbox_model_init), (mbox_model_get_value):
	Use the GTypes that are expected in
	gtk_cell_renderer_text_set_property().

2019-04-01  Albrecht Dreß  <albrecht.dress@arcor.de>

	Improve IMAP folder parent selection, subscription management

	* libbalsa/folder-scanners.[ch]: implement new function
	libbalsa_scanner_imap_tree() for scanning an IMAP server's
	folder structure and subscription state into a GtkTreeStore,
	requires a bunch of helper functions
	* libbalsa/imap-server.[ch]: implement new function
	libbalsa_imap_server_subscriptions() for subscribing to and
	unsubscribing from arrays of folders using a single IMAP
	connection
	* libbalsa/mailbox_imap.[ch]: remove unused function
	libbalsa_mailbox_imap_subscribe() (obsoleted by
	libbalsa_imap_server_subscriptions())
	* src/folder-conf.c: implement new style subscription and parent
	folder selection:
	  • imap_apply_subscriptions() collects folders with modified
	  subscription states from the GtkTreeView;
	  • imap_update_subscriptions() applies changed subscription
	  states, called from folder_conf_clicked_ok();
	  • on_subscription_toggled() callback for subscription state checkbox;
	  • create_imap_folder_dialog() create the dialogue for parent
	  folder selection and subscription management;
	  • folder_conf_imap_subscriptions() runs the subscription
	  management dialogue;
	  • fcw_subscribed_toggled() callback for activating the
	  subscription management button;
	  • folder_conf_imap_node() add button for subscription management;
	  • select_parent_folder() find parent of a folder in the GtkTreeModel;
	  • on_parent_double_click() callback for double-click folder selection;
	  • browse_button_cb() modified, runs the parent selection dialogue;
	  • remove obsolete functions browse_button_select_row_cb(),
	  browse_button_row_activated(), browse_button_response(),
	  folder_selection_func(), browse_button_data_free()
	* src/mailbox-node.c: remove obsolete mailbox tree view entries
	for (un)subscribing
	* src/save-restore.c: add the two new dialogues to the geometry manager

2019-03-23  Albrecht Dreß  <albrecht.dress@arcor.de>

	Do not include a trailing period ('.') when matching an URL.
	Most often it's end-of-sentence punctuation rather than part of
	the URL. See the thread at
	<URL:https://mail.gnome.org/archives/balsa-list/2018-July/msg00000.html>.

	* libbalsa/mime.c (get_url_reg): do not match a trailing period.

2019-03-21  Albrecht Dreß  <albrecht.dress@arcor.de>

	I noticed that /sometimes/ closing the config dialogue of an
	existing maildir mailbox segfaults.  It appears that this
	is caused by an uninitialised file chooser (I modified the
	particular code snippet a while ago…).  I am quite sure I
	tested the changes, including maildir (the format I typically
	use), no idea why this slipped through, sorry!

	* src/mailbox-conf.c (create_local_mailbox_dialog):  Fix maildir
	config crash

2019-03-12  Albrecht Dreß  <albrecht.dress@arcor.de>

	Broken mailbox view after moving IMAP folder sideways

	I noticed a bug when a folder on a IMAP server is moved sideways,
	e.g. from “INBOX/Folder1/Test” to “INBOX/Folder2/Test”:
	after moving, a partial re-scan of the mailbox tree is performed,
	which makes all my local folders disappear.  The effect does
	not occur if the folder is moved up or down the tree.  I could
	track down the source of the issue to src/folder-conf.c, function
	subfolder_conf_clicked_ok().

	* src/folder-conf.c (subfolder_conf_clicked_ok): rescan the
	whole IMAP folder tree after a sideways move.

2019-03-05  Albrecht Dreß  <albrecht.dress@arcor.de>

	* libbalsa/send.c (libbalsa_create_rfc2440_buffer): fix confusing
	bcc: encryption warning in libbalsa_create_rfc2440_buffer()
	if no bcc: recipients are present;
	(do_multipart_crypto): use singular/plural form of this warning
	in do_multipart_crypto().

2019-03-03  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Do not attach files in response to clicking a "mailto:" URL

	Only if the URL is passed to Balsa on the command line by "-m"
	or "--compose".

	Also, accept either "attach=" or "attachment=" in a "mailto:"
	URL.

	* src/sendmsg-window.c (sendmsg_window_process_url),
	(sw_attach_file), (sendmsg_window_set_field),
	(set_list_post_rfc2369): attach a file only if the request comes
	from the command line;
	* src/balsa-mime-widget-text.c (url_send_cb), (handle_url): this
	request is not from the command line;
	* src/main.c (balsa_check_open_compose_window): this request is
	from the command line;
	* src/sendmsg-window.h: new argument "gboolean
	from_command_line" for sendmsg_window_process_url() and
	sendmsg_window_set_field().

2019-02-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Simplify handling "mailto:" URLs

	* src/sendmsg-window.c (decode_and_strdup): simplify;
	(sendmsg_window_process_url): drop the "field_setter func"
	argument; it's always "sendmsg_window_set_field";
	(set_list_post_rfc2369): use new API;
	* src/sendmsg-window.h: export new API;
	* src/balsa-mime-widget-text.c (handle_url): use new API;
	* src/main.c (balsa_check_open_compose_window): ditto.

2019-02-24  Pawel Salek  <pawsa0@gmail.com>

	Fix some issues raised by scan-build, the clang static analyzer

	* libbalsa/imap/imap-commands.c (imap_mbox_store_flag): insert
	missing "else";
	* libbalsa/imap/imap-handle.c (imap_get_flag),
	(imap_cmd_get_tag): always null-terminate the string;
	(imap_message_deserialize): omit a dead increment;
	(imap_cmd_exec_cmds): store the return code for return;
	* libbalsa/imap/imap_tst.c (test_mbox_append_common): check the
	return code for error.

2019-02-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	gtk_window_present() will be deprecated in later versions of
	Gtk-2.24, in favor of gtk_window_present_with_time().

	We never have a time-stamp readily available, so just pass
	gtk_get_current_event_time().

	* libbalsa/identity.c (libbalsa_identity_select_dialog),
	(libbalsa_identity_config_dialog):
	* libbalsa/smtp-server.c (libbalsa_smtp_server_dialog):
	* src/address-book-config.c (balsa_address_book_config_new):
	* src/balsa-index.c (balsa_index_pipe):
	* src/filter-edit-dialog.c (filters_edit_dialog):
	* src/filter-export-dialog.c (filters_export_dialog):
	* src/filter-run-dialog.c (filters_run_dialog):
	* src/folder-conf.c (folder_conf_imap_node),
	(folder_conf_imap_sub_node):
	* src/mailbox-conf.c (mailbox_conf_new), (mailbox_conf_edit):
	* src/main-window.c (check_new_messages_real):
	* src/main.c (balsa_activate_cb), (handle_remote):
	* src/message-window.c (mw_set_selected), (message_window_new):
	* src/pref-manager.c (open_preferences_manager):
	* src/sendmsg-window.c (address_book_cb),
	(sw_spell_check_activated), (sendmsg_window_continue):
	* src/store-address.c (balsa_store_address_from_messages):
	* src/toolbar-prefs.c (customize_dialog_cb):

2019-02-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/html.c: simpler regular expression for non-cid schemes.

2018-02-23  Albrecht Dreß  <albrecht.dress@arcor.de>

	Error in IMAP mailbox encoding

	Balsa has a bug in encoding IMAP mailbox names to modified UTF-7
	as defined in RFC 3501, sect. 5.1.3 [1], as the '\' (0x5c) is
	encoded as '\\' which is explicitly prohibited.  To reproduce:
	activate main() in libbalsa/imap/util.c, compile it, and run
	e.g. (yes, the mailbox name is weird, but it includes all special
	cases from the RFC…)

	/util 'ϴä ab c&d+e/f\~ßx'
	orig='ϴä ab c&d+e/f\~ßx' mbx='&A,QA5A- ab c&-d+e/f\\~&AN8-x' back='ϴä ab c&d+e/f\\~ßx'
	WRONG CONVERSION: --------------------------------^^

	* libbalsa/imap/util.c (imap_utf8_to_mailbox),
	  (imap_mailbox_to_utf8): replace the hand-coded conversion by
	  utilising g_convert(), and also fix the bug
	* libbalsa/imap/util.h: declare them with the
	  G_GNUC_WARN_UNUSED_RESULT attribute.

2019-02-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/html.c (lbh_web_view_new): use a static location when
	registering 'cid:' scheme; fix the regular expression for
	matching non-cid schemes (it was also matching 'cid:')

2019-02-19  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/mailbox_imap.c (lbm_imap_get_msg_part_from_cache):
	plug memory leaks in error return paths;

2019-02-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-mime-widget-image.c (img_check_size): avoid scan-build
	false positive.

2019-02-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/imap/imap-handle.c (imap_body_from_stringi): guard
	against NULL pointer.

2019-02-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-print-object-text.c (collect_attrs): initialize a
	region by structure assignment instead of g_memdup().


2019-02-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/send.c (libbalsa_message_create_mime_message): do not
	leak mime_type in error return paths; also reduce scope of
	mime_type.

2019-02-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/address.c (vcard_strsplit): eliminate one decrement,
	and add an assertion to avoid a scan-build false positive

2019-02-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/mailbox.c (libbalsa_mailbox_view_new): initialize a
	view by structure assignment instead of g_memdup().

2019-02-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/address.c (libbalsa_address_new_from_vcard): do not
	leak a string.

2019-02-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Cast weak-pointer-location to (gpointer *) in calls to
	g_object{add,remove}_weak_pointer()

	* libbalsa/identity.c (libbalsa_identity_config_dialog):
	* libbalsa/mailbox_maildir.c (free_message_info):
	* libbalsa/mailbox_mbox.c (free_message_info):
	* libbalsa/mailbox_mh.c (lbm_mh_free_message_info):
	* src/balsa-index.c (bndx_clear_if_last_ref), (bndx_pipe_response):
	* src/balsa-mblist.c (balsa_mblist_get_store),
	(update_mailbox_idle), (bmbl_mailbox_changed_cb):
	* src/balsa-mime-widget-image.c
	(balsa_mime_widget_image_resize_all), (img_check_size):
	* src/filter-edit-callbacks.c (fe_edit_condition):
	* src/folder-conf.c (folder_conf_imap_node),
	(folder_conf_imap_sub_node):
	* src/information-dialog.c (balsa_information_list):
	* src/mailbox-conf.c (mailbox_conf_new):
	* src/mailbox-node.c (imap_scan_attach_mailbox),
	(balsa_mailbox_node_scan_children), (bmbn_scan_children_idle):
	* src/main-window.c (balsa_window_new),
	(bw_real_open_mbnode_idle_cb), (bw_real_open_mbnode_thread),
	(balsa_window_real_open_mbnode), (bw_focus_idle),
	(balsa_window_real_close_mbnode), (bw_notebook_switch_page_cb):
	* src/main.c (balsa_activate_cb):
	* src/message-window.c (destroy_message_window),
	(message_window_new):
	* src/toolbar-prefs.c (customize_dialog_cb):

2019-02-17  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/mailbox.c: remove an unused function;
	* libbalsa/mailbox.h: do not export it.

2019-02-16  Peter Bloomfield  <pbloomfield@bellsouth.net>

	mailbox-local: Do not leak LibBalsaMessage

	* libbalsa/mailbox_local.c (lbml_message_pool_take_message): new
	name for 'lbml_add_message_to_pool', emphasizing that it takes
	over the reference count;
	(lbm_local_get_message_with_msg_info): use the new name;
	(libbalsa_mailbox_local_get_message): always return a reference
	to the LibBalsaMessage.

2019-02-16  Peter Bloomfield  <pbloomfield@bellsouth.net>

	imap-mbox-handle: Do not leak a GNode tree

	* libbalsa/imap/imap-handle.c (imap_mbox_handle_finalize):
	destroy the thread-root GNode tree.

2018-02-15  Albrecht Dreß  <albrecht.dress@arcor.de>

	Relax secret key selection

	Currently, the user can only select a key with a uid which matches
	the account's email address.  However, there are use-cases where
	this is not sufficient.  At work, we have an isolated network
	with “internal” email addresses.  Outgoing messages are
	re-written to public addresses, but the internal ones shall
	not be exposed to the outside world (see e.g. [1]), i.e. the
	key /must not/ carry a user-id for the internal address.  Thus,
	neither auto-selection nor defining the key id in the gui works
	(it would be possible to run gpg[sm] on the console to print
	the id, and then copy it into the input field, though).

	The patch enables selecting any valid private key in the identity
	dialogue, but /not/ when a message shall be sent and the private
	key cannot be determined.  Note that the vast majority of users
	will probably never use this feature, i.e. use automatic key
	selection (id is empty in the identity setup).

	* libbalsa/libbalsa-gpgme.c (libbalsa_gpgme_get_seckey): relax
	the selection of the private key in the identity setup dialogue

2018-02-15  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix broken decryption of s/mime messages loaded from imap

	* libbalsa/mailbox_imap.c
	(libbalsa_mailbox_imap_fetch_structure): fetch part if it is not
	multipart/*, instead of only fetching text/*.

2018-02-15  Albrecht Dreß  <albrecht.dress@arcor.de>

	Printing of HTML message parts

	* libbalsa/html.[ch]: implement function for rendering to a
	Cairo surface; refactor for extracting common code
	* src/balsa-print-object-html.[ch]: implement printing the HTML
	Cairo surface (new module)
	* src/Makefile.am, src/meson.build: add new module
	* src/balsa-print-object.c: use the new module for HTML (falls
	back to default if built w/o HTML support)
	* src/balsa-print-object.h: add the “volatile” HTML printing
	options to BalsaPrintSetup
	* src/print-gtk.c: refactor print dialogue to use GtkGrid;
	add new options; add function for selecting the proper part
	from multipart/alternative
	* src/balsa-print-object-html.[ch]: new files

2019-02-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/mailbox-node.c (balsa_mailbox_node_dispose): now that we
	unref POP3 mailboxes, which do not need to be saved in the
	config file, we must not try to save them.

2019-02-14  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Plug some memory leaks

	* src/balsa-mime-widget.[ch]: No need for a 'finalize' method
	* src/balsa-message.c: Unref the BalsaMimeWidget
	* src/balsa-app.c: Unref the POP3 mailboxes and free the list
	* libbalsa/mailbox_pop3.c: Do not leak the filter-cmd
	* libbalsa/address-book-rubrica.c: Do not leak the completion

2019-02-07  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Preserve tab order of open mailboxes across instances (#12)

	* libbalsa/mailbox.c (libbalsa_mailbox_set_position),
	  (libbalsa_mailbox_get_position): manage the mailbox's position
	  in the notebook;
	  (libbalsa_mailbox_set_open): unset the position when the
	  mailbox is closed;
	* libbalsa/mailbox.h: new member 'position';
	* libbalsa/mailbox_local.c (lbml_set_threading): guard against
	  NULL msg_tree;
	* src/balsa-app.c (position_compare_func),
	  (balsa_add_open_mailbox_urls): sort the mailboxes to be opened
	  by their position in the last instance;
	* src/balsa-app.h: new member 'gboolean in_destruction';
	* src/balsa-index.c (bndx_destroy), (bndx_selection_changed),
	  (balsa_index_load_mailbox_node): take a strong ref on the
	  BalsaMailboxNode instead of a weak ref;
	* src/mailbox-node.c (balsa_mailbox_node_dispose): do not bother
	  to close the mbnode;
	* src/main-window.c (bw_notebook_page_notify_cb): callback for
	  the "child-notify::position" signal;
	  (bw_real_open_mbnode_idle_cb): connect to it;
	  (balsa_window_destroy): set 'in_destruction';
	* src/save-restore.c (config_load_mailbox_view),
	  (config_save_mailbox_view): save and restore positions;
	  (config_mailbox_get_int_property),
	  (config_mailbox_get_position): new functions to get position;
	* src/save-restore.h: new API.

2019-02-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* meson_options.txt: make 'autocrypt' a boolean option, default
	false;
	* meson.build: rename 'autocryptcfg' to 'autocrypt', since it is
	now boolean.

2019-02-03  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Restore running the address book editor

	* src/meson.build: build the editor with the correct name:
	"balsa-ab", not "balsa_ab";
	* ui/balsa-ab.gresource.xml: use the correct prefix:
	"/org/desktop/BalsaAb", not "/org/desktop/Balsa".

2018-01-30  Albrecht Dreß  <albrecht.dress@arcor.de>

	LDAP address book: use all email attributes

	* libbalsa_address_book_ldap_get_address(): assign the GList
	  of all mail attribute strings to LibBalsaAddress instead of the
	  first one only;
	* lbabl_get_internet_address(): append separate InternetAddress
	  to a GList instead on returning the first one only.

2018-01-24  Albrecht Dreß  <albrecht.dress@arcor.de>

	* libbalsa/html.c (lbh_web_process_terminated_cb): new signal in
	  webkit version 2.20;
	  (libbalsa_html_new): do not auto-load images if any are
	  external (that is, not cid: data)
2019-01-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	More menu shuffling

	* ui/main-window.ui:
	  move "File → New → Message" to "Message → New…";
	  move  "Mailbox → Close" to the foot of the "Mailbox" menu, and
	  group "Remove Duplicates" and "Expunge Deleted Messages"
	  immediately above it;
	  move "Message → Next Message" and three friends to a new
	  "Go" top-level menu.

2019-01-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* ui/main-window.ui: Shuffle some menu items;
	see https://gitlab.gnome.org/GNOME/balsa/issues/14

2019-01-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* ui/main-window.ui: Restore 'm' shortcut for "New message"

2019-01-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove application menu

	GNOME has decided that application menus, shown in the top bar
	of the GNOME desktop, are a bad idea. It was kind of a stretch
	for Balsa to implement one, so it shouldn't be too hard to drop
	it.

	* src/main-window.c (settings_activated),
	(bw_add_win_action_entries), (balsa_window_add_action_entries),
	(bw_set_menus): move the appmenu items that are not already
	duplicate in the File: menu back there;
	* ui/main-window.ui: ditto.

2018-01-20  Albrecht Dreß  <albrecht.dress@arcor.de>

	Do not trigger a CRITICAL message when request for a Message
	Disposition Notification is activated
	Fixes
	https://mail.gnome.org/archives/balsa-list/2019-January/msg00018.html

	* libbalsa/message.c (libbalsa_message_set_dispnotify): test
	whether message->headers->dispnotify_to is NULL before unreffing
	it.

2018-01-13  Albrecht Dreß  <albrecht.dress@arcor.de>

	Get the Autocrypt headers from Balsa's user-headers instead of
	from a GMimeMessage, which doesn't always exist.

	* libbalsa/autocrypt.c (scan_autocrypt_headers): new function
	for scanning Balsa's user-headers;
	(autocrypt_from_message): use it, instead of
	g_mime_object_get_header_list() and friends;
	(parse_autocrypt_header): extend the (debug) output when
	checking the key data from an Autocrypt header fails.

2019-01-11  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Check for NULL message

	* libbalsa/imap/imap-commands.c (imap_mbox_sort_msgno_client):
	check for NULL message and for a message with a NULL envelope,
	to avoid dereferencing NULL pointers.

2018-01-10  Albrecht Dreß  <albrecht.dress@arcor.de>

	Minor autocrypt fixes

	* libbalsa/autocrypt.c: set a proper error message if no
	  fingerprint of a usable private key can be identified for a
	  mailbox; fix memory leak; attach Autocrypt database window to
	  geometry manager
	* libbalsa/send.c: do not add Autocrypt header when postponing;
	  propagate error from creating Autocrypt header
	* src/save-restore.c: restore Autocrypt database window geometry

2018-01-05  Albrecht Dreß  <albrecht.dress@arcor.de>

	make IMAP messages translatable

	* libbalsa/imap/auth-cram.c, libbalsa/imap/auth-gssapi.c,
	libbalsa/imap/imap-commands.c, libbalsa/imap/imap-handle.c:
	  make message strings translatable
	* libbalsa/imap/imap-handle.c, libbalsa/imap/imap_private.h:
	  implement imap_mbox_handle_set_msg() as function
	* libbalsa/imap/imap-commands.h, libbalsa/imap/imap-tls.c:
	  add GError to imap_handle_starttls() api

2019-01-05  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Fix the meson build

	* libbalsa/meson.build: add geometry manager module

2018-01-05  Albrecht Dreß  <albrecht.dress@arcor.de>

	Simplify window geometry management

	* libbalsa/Makefile.am: add geometry manager module
	* libbalsa/geometry-manager.[hc]: geometry manager module
	  implementation
	* libbalsa/libbalsa-gpgme-cb.c: use geometry manager for the
	  key list dialogue
	* libbalsa/libbalsa-gpgme-widgets.c: use geometry manager for
	  the key dialogue
	* libbalsa/libbalsa.h: simplify libbalsa_show_message_source()
	  api, remove unimplemented function prototype
	* libbalsa/source-viewer.c: use geometry manager, simplify
	  libbalsa_show_message_source() api
	* src/balsa-app.c: remove initialisation of obsolete balsa_app
	  items
	* src/balsa-app.h: remove obsolete balsa_app items
	* src/balsa-index.c: use new libbalsa_show_message_source() api
	* src/folder-conf.c, src/main-window.c, src/main.c,
	src/message-window.c, src/sendmsg-window.c: use geometry manager
	  and new libbalsa_show_message_source() api
	* src/save-restore.c: use geometry manager to load and save values

2018-01-05  Albrecht Dreß  <albrecht.dress@arcor.de>

	minor Autocrypt fixes

	* libbalsa/autocrypt.c:
	  * add missing include, required on Debian stretch
	  * make sure the ~/.balsa folder exists before initialising
	    the autocrypt sub-system (otherwise an error is thrown when
	    balsa is started for the first time)
	  * clarify debug messages, indicating if a database entry
	    has actually been changed

2018-12-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/mailbox-conf.c (create_local_mailbox_dialog): avoid
	possibly dereferencing a NULL pointer.

2018-12-18  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix broken display of expired application/pgp-keys parts

	* libbalsa/libbalsa-gpgme-keys.[hc]: add flag to
	  libbalsa_gpgme_list_keys() for listing expired etc. keys, use
	  the new api w/o allowing expired etc. keys
	* libbalsa/libbalsa-gpgme.c, libbalsa/rfc3156.c: use the new
	  api w/o allowing expired etc. keys
	* src/balsa-mime-widget-crypto.c: use the new api, allowing
	  expired etc. keys


2018-12-18  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix buffer overflow and missing include

	* libbalsa/folder-scanners.c: fix missing include on old systems
	  which do not indirectly import string.h, remove obsolete macro
	* libbalsa/libbalsa.c: fix one-byte buffer overflow in
	  x509_fingerprint()

2018-12-18  Albrecht Dreß  <albrecht.dress@arcor.de>

	SMTP, POP: fall back to auth w/ password if GSS failed

	* libnetclient/net-client-pop.c, libnetclient/net-client-smtp.c:
	  retry auth with password if GSS auth failed; small performance
	  improvement checking the various auth methods
	* libnetclient/net-client-utils.c: print more (internal) debug
	  info about failed GSS operations, fix nit-picks

2018-12-14  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Stop using GSlice; it may go away

	* libbalsa/mailbox.c (libbalsa_mailbox_search_iter_new): use
	g_new(), not g_slice_new();
	(libbalsa_mailbox_search_iter_unref): use g_free(), not
	g_slice_free().

2018-12-13  Albrecht Dreß  <albrecht.dress@arcor.de>

	Replace readdir() by g_dir_read_name()

	* libbalsa/folder-scanners.c: replace opendir/readdir/closedir
	  by g_dir_*, and refactor functions libbalsa_scanner_mdir()
	  and libbalsa_scanner_local_dir_helper
	* libbalsa/mailbox_imap.c: replace opendir/readdir/closedir
	  by g_dir_*

2018-12-09  Albrecht Dreß  <albrecht.dress@arcor.de>

	Clean up deadwood

	* src/mailbox-conf.c (run_mailbox_conf),
	(create_local_mailbox_dialog): remove the “deadwood”, and
	a stray debug message…

2018-12-08  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix some issues detected by cppcheck

	* libbalsa/imap/auth-gssapi.c: fix (unlikely) uninitialised use of rc
	* libbalsa/imap/imap-auth.c: do not dereference NULL pointer if
	  an error occurred
	* libbalsa/libbalsa.c: fix signed/unsigned mismatch, and use
	  g_debug instead of printf
	* libbalsa/mailbox_imap.c: fix signed/unsigned mismatch
	* libinit_balsa/assistant_page_directory.c: fix different
	  parameters names in function prototype and implementation
	* src/balsa-message.c, src/save-restore.c: do no dereference
	  pointer before checking it it is not NULL
	* src/sendmsg-window.c: fix false-positive about NULL pointer dereference
	* src/store-address.c: fix false-positive by splitting an
	  over-complex construct

2018-12-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Deprecation cleanup

	* libbalsa/mime.c (libbalsa_text_to_html):
	pango_unichar_direction() is deprecated in Pango 1.44; a commit
	message suggests using fribidi directly.
	* configure.ac: add direct fribidi dependency; it is already an
	indirect dependency through Pango.
	* meson.build: ditto.

2018-12-03  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Do not include no-longer-existing libbalsa/libbalsa-marshal.h

	* src/main-window.c:

2018-11-30  Albrecht Dreß  <albrecht.dress@arcor.de>

	Replace custom ELEMENTS macro with Glib G_N_ELEMENTS

	* libbalsa/filter-funcs.c (libbalsa_condition_new_from_string),
	(append_header_names), (append_flag_names):
	* libbalsa/identity.c (md_sig_path_changed):
	* libbalsa/imap/imap-commands.c (need_fetch), (imap_mbox_status),
	(enum_flag_to_str):
	* libbalsa/imap/imap-handle.c (ir_capability_data),
	(ir_resp_text_code), (ir_list_lsub), (ir_status),
	(ir_msg_att_flags), (ir_fetch_seq), (ir_handle_response):
	* libbalsa/libbalsa.h:
	* libbalsa/mailbox.c (mbox_model_get_value):
	* src/balsa-index.c (bndx_instance_init), (bndx_popup_menu_create):
	* src/balsa-mblist.c (balsa_mblist_default_signal_bindings):
	* src/filter-edit-callbacks.c (build_condition_dialog):
	* src/filter-edit-dialog.c (build_match_page), (build_action_page):
	* src/main-window.c (bw_create_index_widget):
	* src/sendmsg-window.c (find_locale_index_by_locale),
	(create_email_entry), (sw_attachment_list), (create_text_area),
	(create_lang_menu):
	* src/toolbar-factory.c:

2018-11-30  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix confusing signature info

	* libbalsa/gmime-gpgme-signature.c: hide unavailable data if a
	signature is bad, the public key missing, or without signature
	data at all
	* libbalsa/libbalsa-gpgme-widgets.c: find proper subkey even if
	only the end of the fingerprint is given
	* src/balsa-mime-widget-crypto.c: remove useless debug message

2018-11-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Pass NULL instead of a stock marshaller to g_signal_new().

	* libbalsa/address-view.c (libbalsa_address_view_class_init):
	* libbalsa/cell-renderer-button.c
	(libbalsa_cell_renderer_button_class_init):
	* libbalsa/imap/imap-handle.c (imap_mbox_handle_class_init):
	* libbalsa/mailbox.c (libbalsa_mailbox_class_init):
	* src/balsa-index.c (bndx_class_init):
	* src/balsa-mblist.c (bmbl_class_init):
	* src/balsa-message.c (balsa_message_class_init):
	* src/filter-run-dialog.c (balsa_filter_run_dialog_class_init):
	* src/mailbox-node.c (balsa_mailbox_node_class_init):
	* src/main-window.c (balsa_window_class_init):
	* src/toolbar-factory.c (balsa_toolbar_model_class_init):

2018-11-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove marshal lists

	* libbalsa/imap/libimap-marshal.list:
	* libbalsa/libbalsa-marshal.list:

2018-11-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	GNotification does not use HTML markup

	* libbalsa/information.c (libbalsa_information_varg): so do not
	escape markup characters in the text

2018-11-27  Albrecht Dreß  <albrecht.dress@arcor.de>

	Clear passwords if authentication fails

	* libbalsa/mailbox_pop3.c, libbalsa/send.c: clear appropriate
	password when libnetclient reports an authentication failure
	(SMTP, POP), or could not decrypt a user certificate's private key
	* libnetclient/net-client-pop.[ch]: report auth failure if the
	server reports any error in the authentication phase (AUTH,
	APOP, USER/PASS); fix nagging by Flexelint
	* libnetclient/net-client-smtp.[ch]: report auth failure if
	the server replies with status codes 534 or 535; fix nagging
	by Flexelint
	* libnetclient/net-client.[ch]: report a certificate key
	decryption error if the passphrase is wrong


2018-11-27  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix broken IMAP special folders & other migration issues

	* libbalsa/mailbox.[ch]: tell libbalsa_mailbox_new_from_config()
	if a folder is special, so it is processed even if it is an
	IMAP one
	* libbalsa/mailbox_imap.c: always set the "Migrated" flag for
	LibBalsaMailboxImap mailboxes
	* src/save-restore.c: in the migration process, track "user@host"
	folder ids in a hash table to avoid duplicates; keep special IMAP
	folders; load folders before mailboxes so special IMAP mailboxes
	do not overwrite the folder's IMAP configs (the server config
	originates from the first server seen)

2018-11-27  Albrecht Dreß  <albrecht.dress@arcor.de>

	Password dialogue improvements

	* libbalsa/imap-server.c, libbalsa/server-config.c,
	libinit_balsa/assistant_page_user.c, src/save-restore.c: use
	changed libbalsa_server_set_password() api
	* libbalsa/libbalsa.[c]: implement GTK_DIALOG_USE_HEADER_BAR
	detection as boolean for GCR dialogue
	* libbalsa/server.[ch]: clean up signal definitions (remove
	obsolete marshallers); remove unused class method;
	adjust api's for libbalsa_server_set_password(),
	libbalsa_server_get_password() and libbalsa_server_get_cert_pass()
	* libnetclient/net-client.[ch]: pass cert subject only
	instead of full binary data in the passphrase signal
	* src/balsa-app.[ch]: use GCR password dialogue if available;
	drop set_passwd_from_matching_server() which is never used

2018-11-04  Albrecht Dreß  <albrecht.dress@arcor.de>

	Unified server configuration GUI

	* libbalsa/Makefile.am, libbalsa/meson.build: add new
	server-config module
	* libbalsa/imap-server.c: use common config class; ensure server
	hash key required by changed folder conf approach
	* libbalsa/libbalsa-conf.[ch]: add option for obfuscated private
	string, so libbalsa_rot() is used only locally
	* libbalsa/address-book-ldap.c: use changed libbalsa-conf api
	* libbalsa/libbalsa.[ch]: libbalsa_rot() moved to
	libbalsa/libbalsa-conf.c
	* libbalsa/mailbox_pop3.c: properly initialise procmail command
	* libbalsa/send.c: fix broken signal connections if a user
	certificate is used
	* libbalsa/server-config.[ch]: implement new server config
	gui class
	* libbalsa/server.[ch]: use new config gui; refactor libsecret
	stuff; store user cert passphrase using libsecret if requested;
	clean up exported types
	* libbalsa/smtp-server.c: use new config gui
	* src/folder-conf.c: use new config gui; Note: slightly changed
	approach for adding an IMAP folder
	* src/mailbox-conf.[ch]: use new config gui, removes loads of
	obsolete exported code
	* src/mailbox-node.c: use g_debug() for debug messages
	* src/save-restore.c: use changed libbalsa-conf api

2018-10-17  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/main-window.c (bw_create_index_widget):
	gtk_container_*_focus_chain functions are deprecated.

2018-10-17  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-mime-widget-callbacks.c (bmw_set_can_focus),
	(balsa_mime_widget_limit_focus), (balsa_mime_widget_unlimit_focus):
	gtk_container_*_focus_chain functions are deprecated.

2018-09-14  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/information.c (libbalsa_information_varg): use
	  g_markup_escape_text to entity-escape the body of a
	  GNotification, instead of our home-brewed non-UTF8-safe version.

2018-09-05  Albrecht Dreß  <albrecht.dress@arcor.de>

	Fix crash listing S/MIME certificates

	* libbalsa/gmime-gpgme-signature.c
	(libbalsa_cert_subject_readable): restore a missing termination
	check.

2018-08-29  Albrecht Dreß  <albrecht.dress@arcor.de>

	Move single IMAP mailboxes to folders

	* libbalsa/mailbox.c: print paranoid warning if
	  libbalsa_mailbox_new_from_config() is called for an IMAP mailbox
	* src/mailbox-conf.[ch]: remove obsolete
	  mailbox_conf_add_imap_cb(), create_imap_mailbox_dialog() and
	  dependent functions
	* src/mailbox-node.[ch]: make sure BalsaMailboxNode::dir
	  is properly initialised; remove obsolete
	  balsa_mailbox_node_new_imap()
	* src/pref-manager.c: clean up menu
	* src/save-restore.c: migrate IMAP mailboxes to IMAP folders

2018-08-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Apply threading changes on 'Update'

	* src/mailbox-conf.c (thread_messages_toggled),
	(mailbox_conf_view_new_full), (mailbox_conf_view_check):
	apply threading changes on 'Update' instead of instantly on
	checking the boxes.

2018-08-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Check for valid msgno

	* libbalsa/mailbox.c (mbox_get_thread_date_traverse_func): check
	that the msgno that we get from the GNode is in the valid range
	1 <= msgno <= mindex->len.

2018-08-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Clear timeout source id in handler

	* libbalsa/mailbox_local.c (lbm_local_sync_real),
	(lbm_local_sync_idle): clear LibBalsaMailboxLocal::sync_id in
	the timeout handler, not in the thread that it creates.

2018-08-25  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Add UI for 'merge threads by subject'

	* libbalsa/mailbox.c (libbalsa_mailbox_set_subject_gather),
	(libbalsa_mailbox_get_subject_gather): new methods.
	* libbalsa/mailbox.h: add LibBalsaMailboxView::subject_gather
	and declare the getter/setter.
	* src/balsa-index.c (balsa_index_set_thread_messages): use
	thread-messages and subject-gather to decide whether threading
	is flat, simple, or JWZ.
	* src/mailbox-conf.c (thread_messages_toggled),
	(subject_gather_toggled), (mailbox_conf_view_new_full),
	(mailbox_conf_view_check): add the UI to the mailbox config
	dialog.
	* src/main-window.c (bw_enable_mailbox_menus),
	(balsa_window_set_thread_messages): export -set-thread-messages.
	* src/main-window.h: ditto.

2018-08-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Limit use of LibBalsaMailboxThreadingType in src/ to balsa-index.c

	* src/main-window.c (threading_change_state): pass
	gboolean thread_messages to balsa-index, instead of
	LibBalsaMailboxThreadingType threading_type;
	* src/balsa-index.c (balsa_index_set_thread_messages): ditto;
	* src/balsa-index.h: change API.

2018-08-19  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Simplify threading

	Change THREADING_SIMPLE to mean JWZ without the 'subject gather'
	phase, and change the UI to enable or disable threading instead
	of offering the choice of threading algorithms.

	Still to do: add UI for choosing JWZ instead of SIMPLE.

	* libbalsa/mailbox.c (lbm_need_threading_idle_cb),
	(libbalsa_mailbox_set_view_filter), (lbm_set_threading_idle_cb),
	(lbm_set_threading), (libbalsa_mailbox_set_threading): do not
	pass threading type to _set_threading, just get it from the
	view.
	* libbalsa/mailbox.h: ditto.
	* libbalsa/mailbox_local.c (libbalsa_mailbox_local_close_mailbox),
	(lbml_set_threading), (lbml_set_threading_idle_cb),
	(libbalsa_mailbox_local_set_threading), (lbm_local_thread_idle),
	(lbml_thread_messages), (lbml_unthread_message),
	(lbml_threading_flat): change THREADING_SIMPLE to mean JWZ
	without the 'subject gather' phase, and simplify THREADING_FLAT.
	* src/balsa-index.c (balsa_index_set_threading_type): do nothing
	if the type has not changed.
	* src/balsa-index.h: the threading type is
	LibBalsaMailboxThreadingType.
	* src/main-window.c (threading_change_state),
	(bw_add_win_action_entries), (balsa_window_new),
	(bw_enable_expand_collapse), (bw_enable_mailbox_menus),
	(bw_set_thread_messages), (bw_real_open_mbnode_idle_cb): remove
	the threading type radio buttons, and replace them with a
	'Thread messages' check-box.
	* src/main.c (balsa_get_stats): new API for
	libbalsa_mailbox_set_threading.
	* src/pref-manager.c (update_view_defaults), (apply_prefs),
	(set_prefs), (pm_grid_add_threading_group),
	(open_preferences_manager): remove the threading type combo box,
	and replace it with a 'Thread messages by default' check-box.
	* ui/main-window.ui: remove the threading type radio buttons,
	and replace them with a 'Thread messages' check-box.

2018-08-11  Albrecht Dreß  <albrecht.dress@arcor.de>

	Improve IMAP folder configuration
	Commit b821fb65cec529f52fee7757c870fb9ef131d653 was erased from
	the git log by a later merge--oops!

	* src/folder-conf.c: simplify folder_conf_imap_sub_node()
	  which is now used only for modifying an existing folder,
	  not for creating a new one;
	  put the logic for the latter into folder_conf_add_imap_sub_cb().
	  Note that folder_conf_imap_sub_node() still needs some refactoring…
	* src/mailbox-node.[ch]: replace empty items by separators in add_menu_entry();
	  export helper balsa_mailbox_node_is_imap()
	  indicating if a BalsaMailboxNode is on an IMAP server;
	  in balsa_mailbox_node_get_context_menu() remove the “Remote IMAP folder”
	  and show “Remote IMAP subfolder” for IMAP BalsaMailboxNodes only
	* src/main-window.c: “Remote IMAP folder”, activate “Remote IMAP subfolder”
	  for selected IMAP BalsaMailboxNodes only
	* ui/main-window.ui: remove “Remote IMAP folder” from the ui

2018-07-24  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* meson.build: Change the pkg-config test for enchant from
	  "<= 1.6.0" to "!= 1.6.1"; Gentoo provides enchant versions 2.x.x
	  with enchant.pc, not enchant-2.pc.

2018-07-24  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* configure.ac: Change the pkg-config test for enchant from
	  "<= 1.6.0" to "!= 1.6.1"; Gentoo provides enchant versions 2.x.x
	  with enchant.pc, not enchant-2.pc.

2018-07-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Oops, forgot this in the previous commit.

	* src/sendmsg-window.c (create_text_area): MR
	  gtk!236 has been merged; the fix will be in Gtk 3.24 when it
	  is released, but for building against unstable versions the
	  test is GTK_CHECK_VERSION(3, 23, 1).

2018-07-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-mime-widget-text.c (balsa_mime_widget_new_text): MR
	  gtk!236 has been merged; the fix will be in Gtk 3.24 when it
	  is released, but for building against unstable versions the
	  test is GTK_CHECK_VERSION(3, 23, 1).

2018-07-19  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/html.c: Handle the deprecation of GtkAction more
	  cleanly.

2018-07-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	More work around MR gtk!236

	* src/balsa-mime-widget-text.c (balsa_mime_widget_new_text): set
	  the GtkTextView margins to zero;
	* src/sendmsg-window.c (create_text_area): ditto.

2018-07-18  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Work around MR gtk!236

	* src/balsa-mime-widget-text.c (balsa_mime_widget_new_text): use
	GtkWidget margins instead of GtkTextView margins, to make the
	window shrinkable and to avoid button creep;
	* src/sendmsg-window.c (create_text_area): ditto, to make the
	window shrinkable (does not fix the problem when GtkSourceView
	is used).

2018-07-07  Albrecht Dreß <albrecht.dress@arcor.de>

	Fix HTML rendering with webkit2gtk-4.0 < 2.20

	* README: document use of G_MESSAGES_DEBUG=…
	* libbalsa/html.c (lbh_navigation_policy_decision):
	  allow the rendering of “about:blank”.

2018-07-07  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use g_debug() instead of conditionally compiled printing

	* libbalsa/html.c (lbh_navigation_policy_decision),
	(lbh_new_window_policy_decision), (lbh_response_policy_decision),
	(lbh_resource_notify_response_cb), (lbh_web_process_crashed_cb),
	(lbh_cid_cb), (libbalsa_html_new):

2018-07-05  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-mime-widget.c (balsa_mime_widget_new): Do not leak
	  the GtkAdjustment.

2018-07-05  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-message.c (bm_find_scroll_to_rectangle), (select_part):
	  Use gtk_scrolled_window_get_{h,v}adjustment() instead of
	  GObject properties (and consequently, do not leak the
	  adjustments).

2018-07-03  Albrecht Dreß <albrecht.dress@arcor.de>

	libnetclient private data fixes

	* libnetclient/net-client-pop.c, libnetclient/net-client-siobuf.c,
	  libnetclient/net-client-smtp.c: properly access and destroy the private data
	* libnetclient/test/Makefile.am: fix lcov cleaning the test app
	  from the coverage data
	* libnetclient/test/cert.pem, libnetclient/test/cert_u.pem:
	  replace expired snakeoil certs for testing

2018-06-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/mailbox-conf.c: Really build with gpgme desabled.

2018-06-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libnetclient/net-client.c (net_client_class_init),
	(net_client_init): g_type_class_add_private() is soon to be
	deprecated; use G_DEFINE_TYPE_WITH_PRIVATE intead;
	also use net_client_get_instance_private() instead of
	G_TYPE_INSTANCE_GET_PRIVATE().

2018-06-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/main-window.c (about_activated): Update the 'about'
	dialog.

2018-06-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/main-window.c (bw_real_open_mbnode_idle_cb),
	(bw_real_open_mbnode_thread), (balsa_window_real_open_mbnode),
	(bw_mailbox_check): Use g_application_{hold,release} to keep the
	GApplication alive while mailboxes are being opened.

2018-06-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/mailbox.c (libbalsa_mailbox_finalize),
	(lbm_changed_idle_cb), (lbm_changed_schedule_idle),
	(lbm_run_filters_on_reception_idle_cb),
	(libbalsa_mailbox_run_filters_on_reception): manage idle ids.
	* libbalsa/mailbox.h: new idle id for run-filters-on-reception
	idle handler.

2018-06-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/libbalsa-conf.c (libbalsa_conf_foreach_group): check
	that the key-file has not been dropped.

2018-06-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/imap/imap_search.c (imap_search_exec): keep the
	handle alive while searching.

2018-06-24  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Make the 'Balsa closes…' notification outlive the main window,
	and close it when shut-down is complete.

	* src/main-window.c (quit_activated): NULL parent makes the
	notification outlive the window.
	* src/main.c (balsa_shutdown_cb): send an empty notification
	string to withdraw the notification.

2018-06-24  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/information.c (libbalsa_information_varg): if message
	is an empty string, withdraw the notification.

2018-06-24  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/imap-server.c (lb_imap_server_info_free),
	(lb_imap_server_cleanup): Check for NULL 'struct handle_info *'.

2018-06-24  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/main.c (balsa_activate_cb): Present the main-window, if we
	already have one.

2018-06-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Migrate from libnotify to GNotification

	* README: Remove reference to libnotify.
	* configure.ac: Do not configure it.
	* meson.build: Ditto.
	* meson_options.txt: Ditto.
	* libbalsa/information.c (lbi_notification_parent_weak_notify),
	(libbalsa_information_varg), (libbalsa_notification_new): Use
	GNotification instead, and we do not need to drop through to
	balsa-information.
	* libbalsa/information.h: New function libbalsa_notification_new.
	* libbalsa/libbalsa.c (libbalsa_init): Clean up initialization.
	* libbalsa/libbalsa.h: Ditto.
	* src/main.c (balsa_notification_notify_cb),
	(balsa_setup_libbalsa_notification), (balsa_startup_cb): Get a
	GNotification, and use its "notify" signal to show or withdraw
	it.
	* src/ab-main.c (balsa_ab_notification_notify_cb),
	(balsa_ab_notification_shutdown_cb),
	(balsa_ab_setup_libbalsa_notification), (main): Ditto.

2018-06-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-icons.c (balsa_icon_id): Return NULL if the
	icon-table has been destroyed;
	(balsa_register_pixbufs): cope with it;
	* src/toolbar-prefs.c (tp_store_set): ditto.

2018-06-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/mailbox_imap.c (lbm_imap_check): Object-ref handle
	while we check for a list-response.

2018-06-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/main-window.c (bw_is_active_notify),
	(bw_display_new_mail_notification):
	get the application from the window, not using g_object_get();

2018-06-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* configure.ac, Makefile.am, meson.build: Rename balsa.desktop
	to org.desktop.Balsa.desktop.

2018-06-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/main-window.c (view_source_activated), (bw_set_menus):
	get the application from the window, not using g_object_get();
	(balsa_window_new): do not leak adjustments.

2018-06-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Migrate new mail notification from NotifyNotification to
	GNotification.

	* src/main-window.c (bw_is_active_notify),
	(check_new_messages_count), (bw_display_new_mail_notification):
	Migrate new mail notification from NotifyNotification to
	GNotification.
	* src/main-window.h: Use a boolean to remember when a
	notification is being shown.

2018-06-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/main-window.c (view_source_activated), (bw_set_menus): Do
	not leak application.

2018-06-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/main-window.c
	(balsa_window_new): Pass the GtkApplication as an argument to
	balsa_window_new();
	(view_source_activated), (bw_set_menus): Get the GtkApplication
	as a property of BalsaWindow, instead of from the balsa-app
	structure;
	* src/main-window.h: New API for balsa_window_new().

2018-06-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/main.c (balsa_startup_cb), (balsa_shutdown_cb),
	(balsa_activate_cb), (balsa_command_line_cb), (main): Use all the
	GApplication signals, instead of doing it all in the
	command-line handler.

2018-06-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/mailbox-conf.c: Build with gpgme desabled.

2018-06-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libinit_balsa/assistant_page_directory.c
	(unconditional_mailbox): adapt to new libbalsa_server_set_host()
	API.

2018-06-07  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/imap/meson.build: Edit libimap_a_sources to reflect
	the previous commit, and add libnetclient_include to the
	include_directories for imap_tst.

2018-06-05  Albrecht Dreß <albrecht.dress@arcor.de>

	IMAP goes GIO

	Changes to libnetclient/*:
	As I mentioned above, in the libnetclient library I added a module
	which “simulates” the character-buffering methods of libbalsa/imap/siobuf.[hc].
	Other improvements include:
	- transparent compression (RFC 4978) support – which revealed a bug
	  in GIO sending crap when finalising the connection.
	  This is not really harmful, but may confuse a network-based IDS
	  (see <https://bugzilla.gnome.org/show_bug.cgi?id=795985>);
	- helper function for wiping auth data with random chars
	  before freeing the string;
	- improved unit tests.

	Changes to libbalsa/imap/*:
	- siobuf.[hc] are removed, siobuf-nc.h providing a “glue layer”
	  for libnetclient is added
	- auth-cram.c, imap-auth.[ch]: partly re-written; uses libnetclient signals;
	  replace fixed-length strings by dynamically allocated glib strings
	  which is safer; simplifications by using libnetclient functions
	- auth-gssapi.c: simplified by using libnetclient helpers;
	  glib strings as above
	- imap-commands.c, imap-handle.[ch], imap_search.c, imap_tst.c:
	  simplifications by using libnetclient functions, removed some unused functions
	- imap-tls.c, imap_compress.[ch]: massive simplification
	  as all “real” work is implemented in GIO via libnetclient
	- imap_private.h: modification of struct _ImapMboxHandle
	  to use libnetclient stuff, and remove obsolete fields
	- util.c: simplified quoting function, removed unused unquoting
	In all modules, I replaced the mixture of debugging functions ([f]printf)
	by g_debug etc.

	Changes to libbalsa/*:
	- imap-server.c: cleaned up unused monitor cb, use unified security
	  (from libnetclient) instead of separate ssl/tls settings
	- libbalsa.c: replace OpenSSL-based certificate functions
	  by GTlsCertificate and GnuTLS (if GCR is not available,
	  remember that GIO is based on GnuTLS)
	- misc.c: tiny improvement for assuring ~/.balsa
	- server.[ch]: use NetClientCryptMode instead of use_ssl and tls_mode;
	  remove obsolete libbalsa_server_user_cb (replaced by libnetclient's signals);
	  simplify libbalsa_server_check_cert
	- smtp-server.c: use changed server api

	Changes to libinit_balsa/*:
	- assistant_page_user.c: use changed server api

	Changes to src/*:
	- folder-conf.c: configure IMAP according to changed server api
	  (note: widget (de)activation logic not yet fully functional)
	- src/mailbox-conf.[ch]: ditto, but with a working (de)activation logic
	  (I think)
	- mailbox-node.c: use g_debug instead of printf
	- main.c: remove IMAP debug option (use G_MESSAGES_DEBUG, as always)
	- save-restore.c: remove obsolete item

	On the top-level:
	- the configure/meson checks for OpenSSL and ZLib have been removed

2018-06-05  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/address-book-rubrica.c (extract_net): Fix a typo that
	broke the build.

2018-06-05  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Do not seg fault on delayed exit

	* libbalsa/mailbox.c
	(lbm_changed_schedule_idle): ref the mailbox
	(lbm_changed_idle_cb): and unref it;
	* src/main-window.c (check_new_messages_real): check for
	balsa_app.mblist_tree_store == NULL, and do not dereference it.

2018-06-01  Pawel Salek  <pawsa0@gmail.com>

	* NEWS, configure.ac: release balsa-2.5.6
	* src/Makefile.am: add missing xml files

2018-06-01  Pawel Salek  <pawsa0@gmail.com>

	* src/balsa-icons.c: don't let missing icons stop balsa.

2018-05-31  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use g_strcmp0() for NULL-safe comparisons

	* libbalsa/address-book-rubrica.c (extract_net):
	* libbalsa/gmime-gpgme-signature.c
	(libbalsa_cert_subject_readable):
	* libbalsa/html.c (lbh_mouse_target_changed_cb),
	(libbalsa_html_search):
	* libbalsa/identity.c (libbalsa_identity_combo_box):
	* libbalsa/mailbox.c (libbalsa_mailbox_set_identity_name),
	(lbm_try_reassemble):
	* libbalsa/mailbox_mbox.c (lbm_mbox_message_new):
	* libbalsa/smtp-server.c (smtp_server_compare):
	* src/ab-main.c (bab_config_init):
	* src/balsa-app.c (find_path), (balsa_quote_regex_new):
	* src/balsa-icons.c (load_balsa_pixmap):
	* src/filter-edit-callbacks.c (change_filter_name):
	* src/folder-conf.c (subfolder_conf_clicked_ok),
	(folder_conf_imap_sub_node):
	* src/mailbox-node.c (remove_special_mailbox_by_url):
	* src/pref-manager.c (open_preferences_manager_idle):
	* src/save-restore.c (config_address_book_load):
	* src/sendmsg-window.c (sw_preferred_charset),
	(find_locale_index_by_locale), (has_file_attached):

2018-05-31  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/filter-edit-callbacks.c (fe_new_pressed): Do not leak
	new_item.

2018-05-31  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-index.c (bndx_pipe_queue_last): Do not leak
	PipeData.

2018-05-31  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/mailbox_imap.c (libbalsa_mailbox_imap_get_matchings):
	Do not leak ImapSearchData.

2018-05-31  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/imap/imap-handle.c (ir_body_type_1part): Do not leak
	ImapEnvelope.

2018-05-31  Albrecht Dreß <albrecht.dress@arcor.de>

	Mitigate EFail vulnerability for Webkit2

	* libbalsa/html.c (lbh_navigation_policy_decision): ignore all
	decisions except WEBKIT_NAVIGATION_TYPE_LINK_CLICKED;
	(libbalsa_html_new): disable Java and JavaScript.

2018-05-31  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-index.c (bndx_compose_foreach): Count skipped
	messages only when replying to group.

2018-05-30  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-index.c (bndx_compose_foreach): When replying to
	group, count how many messages were skipped for not having the
	"list-post" header, and report them.

2018-05-30  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/message-window.c (message_window_new): Disable "reply to
	group" when the message is not from an RFC-2369-compliant
	mailing list.
	<URL:https://tools.ietf.org/html/rfc2369>

2018-05-29  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-index.c (bndx_selection_changed): Emit
	"index-changed" even if the preview does not need to be updated,
	so that the main window menus can be enabled/disabled
	appropriately.

2018-05-29  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/sendmsg-window.c (sendmsg_window_reply): If the message is
	a reply to a mailing list, check that the message we are
	replying to actually came from a mailing list; if not, return
	NULL.

2018-05-29  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/main-window.c (bw_enable_message_menus): Disable "reply to
	group" when the message is not from an RFC-2369-compliant mail list.
	<URL:https://tools.ietf.org/html/rfc2369>

2018-05-10  Peter Bloomfield  <pbloomfield@bellsouth.net>

	New files for migrating to GResource

	* ui/balsa-ab.gresource.xml:
	* ui/balsa.gresource.xml:

2018-05-01  Albrecht Dreß <albrecht.dress@arcor.de>

	Display time stamps of date-only RFC 5545 iCalendar events

I noticed that “VALUE=DATE” time stamps (date only, without time) in RFC 5545 iCalendar parts (MIME type text/calendar) are not displayed.

The attached trivial patch add parsing, displaying and printing such values  As to simplify life, the date-only values are printed using the “%x” conversion specification, instead of extracting the date part from balsa_app.date_string.

	* libbalsa/rfc2445.c (libbalsa_vcal_new_from_body),
	(date_time_2445_to_time_t):
	* libbalsa/rfc2445.h:
	* src/balsa-mime-widget-vcalendar.c (balsa_vevent_widget):
	* src/balsa-print-object-text.c (balsa_print_object_text_calendar):

2018-04-11  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Fix the "scroll on click" issue
	(https://bugzilla.gnome.org/show_bug.cgi?id=795085)

	* src/balsa-message.c (balsa_message_init): wrap the
	BalsaMimeWidget::widget in a GtkViewport; if we do not,
	GtkContainer does it for us, but also sets it up to scroll when
	first clicked, which leaves the wrong text under the pointer.

2018-03-19  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/imap/imap-commands.c (imap_mbox_handle_fetch_body):
	silence a gcc gripe about snprintf.

2018-03-19  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/imap/imap-commands.c (imap_mbox_handle_fetch_body):
	silence a gcc gripe about strncpy.

2018-02-27  Pawel Salek <pawsa0@gmail.com>

	* src/main-window.c: update a date.
	* meson.build, configure.ac: update version strings.
	* NEWS: balsa-2.5.5 release notes

2018-02-12  Albrecht Dreß <albrecht.dress@arcor.de>

	Crypto performance improvements

	* libbalsa/body.c: calculate protection state without the key
	* libbalsa/gmime-gpgme-signature.[ch]: do not try to load the key when
	creating the signature object, add and rename some signature-only
	related functions from rfc3156.[hc], set 'crypto' log domain
	* libbalsa/libbalsa-gpgme-keys.[ch]: add function to load a public key,
	properly restore the context attributes when listing keys, set 'crypto'
	log domain
	* libbalsa/libbalsa-gpgme-widgets.[ch]: improved function for creating a
	string from the key data (shifted from rfc3156.[hc]), set 'crypto' log
	domain
	* libbalsa/rfc3156.[ch]: refoctoring; shift some signature-only related
	functions to gmime-gpgme-signature.[ch], set 'crypto' log domain
	* src/balsa-message.c: use renamed signature info functions, calculate
	protection state without the key
	* src/balsa-mime-widget-crypto.c: add callback to load the key when the
	user wants to show it, drop condition which cannot be TRUE, use renamed
	signature info functions
	* src/balsa-mime-widget-message.c: use renamed signature info functions
	* src/balsa-print-object-header.c: try to load the key before printing,
	use renamed signature info functions
	* README, configure.ac, meson.build: require gpgme ≥ 1.5.0
	* libbalsa/libbalsa-gpgme.c: set 'crypto' log domain, adjust debug
	messages
	* libbalsa/gmime-application-pkcs7.c, libbalsa/gmime-multipart-crypt.c,
	libbalsa/gmime-part-rfc2440.c, libbalsa/libbalsa-gpgme-cb.c: set
	'crypto' log domain

2018-02-10  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Clean up generated marshalling files

	* libbalsa/Makefile.am: create a CLEANFILES variable to arrange
	for libbalsa-marshal.[ch] to be removed with "make clean".

2018-02-09  Peter Bloomfield  <pbloomfield@bellsouth.net>

	In glib-2.56, g_object_ref() propagates the type from its argument
	to its return type, which can raise incompatible-pointer-type
	warnings; previously it returned a gpointer, which could conceal
	a coding error.

	* src/main-window.c (bw_check_mailbox_done),
	(bw_check_mailbox_list): make the mailbox member of
	bw_pop_mbox_t a LibBalsaMailbox, so that it can accept the value
	of g_object_ref(mailbox) without a warning; rename it from
	'object' to 'mailbox' because, well, that's what it is.

2018-02-07  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/mailbox.c (lbm_sort): check for zero-length array.

2018-02-07  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Fix two use-after-free false positives

	* src/filter-edit-callbacks.c (change_filter_name): Use
	g_list_delete_link() with a valid link instead of
	g_list_remove() with the address of freed data.

2018-02-07  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Fix a use-after-free bug

	* src/sendmsg-window.c (edit_with_gnome_check): unlink the file
	before freeing its name.

2018-01-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* meson.build: use Unicode quotation marks.

2018-01-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* meson.build: fix the definition of HAVE_CTIME_R.

2018-01-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* meson.build: test for <locale.h> and set HAVE_LOCALE_H if
	found.

2018-01-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Meson build system changes to mirror the autotools changes in
	the previous commit

	* meson.build: check if the selected conversion tool
	accepts “--unicode-snob”.

2018-01-20  Albrecht Dreß <albrecht.dress@arcor.de>

	 Improve replying to html-only messages

	* configure.ac: check if the selected conversion tool
	accepts “--unicode-snob”.
	* libbalsa/html.c (html2text): run the conversion tool
	with “--unicode-snob” if supported.

2018-01-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Meson build system changes to mirror the autotools changes in
	the previous commit

	* libnetclient/meson.build: add c_args: '-DG_LOG_DOMAIN="libnetclient"'
	to static_library arguments.
	* meson.build: drop sed and ncat prerequisites.

2018-01-20  Albrecht Dreß <albrecht.dress@arcor.de>

	Improve low-level network library, POP3 responsiveness on error

	* configure.ac: add missing flags and libs for libnetclient unit tests,
	drop sed and ncat prerequisites
	* libbalsa/mailbox_pop3.c: shut down the connection on error,
	so un'refing it does not wait for the QUIT command
	* libnetclient/Makefile.am: fix log domain
	* libnetclient/README: update documentation
	* libnetclient/net-client-pop.c: execute QUIT only if the connection exists
	* libnetclient/net-client-smtp.c: fix FlexeLint warnings
	about ignored function return values,
	execute QUIT only if the connection exists
	* libnetclient/net-client.[ch]: implement new methods
	for shutting down the network connection
	and for checking the connection status
	* libnetclient/test/Makefile.am: drop sed and ncat requirements,
	fix test application build error
	* libnetclient/test/echoserver.py: (new file) trivial echo server in Python
	* libnetclient/test/start-test-env.sh.in: control the echo server for testing
	* libnetclient/test/tests.c: improve unit tests

2018-01-11  Albrecht Dreß <albrecht.dress@arcor.de>

	Fix progress dialogue on error

	* libbalsa/mailbox_pop3.c (libbalsa_mailbox_pop3_check): send
	the “finalise” notification to the dialogue even if opening
	the connection fails.

2018-01-06  Albrecht Dreß <albrecht.dress@arcor.de>

	Fix the meson build

	* src/meson.build: threads.h is no more.

2018-01-05  Albrecht Dreß <albrecht.dress@arcor.de>

	Enable multi-threaded POP3 retrieval

	* libbalsa/libbalsa-marshal.list, libbalsa/mailbox.[ch]:
	new simplified signature for the mailbox '' signal
	and the related helper libbalsa_mailbox_progress_notify()
	* libbalsa/libbalsa-progress.[ch]: heavy re-factoring of the progress dialogue,
	including a fully thread-safe interface, simplified access functions,
	and a new activity mode
	* libbalsa/mailbox_pop3.c, libbalsa/send.[ch]:
	use new progress dialogue interface,
	pass option to disable send progress dialogue
	* src/balsa-app.[ch]: define and initialise enable progress dialogue settings,
	use changed send function signature
	* src/balsa-message.c, src/balsa-mime-widget-message.c,
	src/balsa-mime-widget-vcalendar.c, src/sendmsg-window.c:
	use changed send function signature
	* src/main-window.[ch]: implement multi-threaded POP3 retrieval,
	remove old progress implementation, use changed send function signature,
	replace two-state enum by bool
	* src/main.c: remove old progress implementation stuff
	* src/pref-manager.c: replace progress dialogue settings
	by two new bool values and related check boxes
	* src/save-restore.c: save/restore new progress dialogue bool values
	* src/threads.h: completely remove the file

2018-01-04  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Fix a use-after-free bug

	* libbalsa/mailbox.c (mbox_model_get_value): get the date format
	string indirectly through balsa_app.date_string.
	* libbalsa/mailbox.h: declare libbalsa_mailbox_date_format as
	gchar **.
	* src/main.c (real_main): initialize it here
	* src/save-restore.c (config_global_load): ...not here.

2017-12-11  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Avoid possible repeated dynamic cast

	* src/main-window.c (balsa_window_setup_progress): cast the
	result of g_object_ref() instead of its argument.

2017-12-10  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Revise configuration of enchant spell-checking lib

	Version 2.1.3 of enchant is parallel-installable with version
	1.6, so we first check for enchant-2. If that fails, check for
	enchant; we want version <= 1.6.0, to avoid issues with 1.6.1.

	* configure.ac: do it.
	* meson.build: ditto.

2017-12-08  Peter Bloomfield  <pbloomfield@bellsouth.net>

	In glib-2.56, g_object_ref() propagates the type from its argument
	to its return type, which can raise incompatible-pointer-type
	warnings; previously it returned a gpointer, which could conceal
	a coding error.

	* libbalsa/send.c (send_message_info_new): do not cast arguments
	to GObject.
	* src/main-window.c (balsa_window_setup_progress): cast argument
	window->progress_bar to GtkProgressBar.

2017-12-03  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove a webkitgtk workaround

	* src/main.c (main): do not set the
	WEBKIT_DISABLE_COMPOSITING_MODE environment variable to "1"--it
	doesn't seem to be needed any more.

2017-12-03  Albrecht Dreß <albrecht.dress@arcor.de>

	Fix documentation

	* README: remove description of two configure options (--with-gpg-app,
	--enable-smime) that have gone away.

2017-12-02  Albrecht Dreß <albrecht.dress@arcor.de>

	Expand lists in address book window

	* src/ab-window.c (balsa_ab_window_init): use GtkWidget's
	hexpand and vexpand functions to properly expand the
	address lists in the address book window when the dialogue is
	enlarged.

2017-11-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Do not crash if no spell-checker dictionaries are found

	* src/sendmsg-window.c (create_text_area): do not set up
	spell checker if no dictionary is found;
	(create_lang_menu): return value is now the current locale;
	first check whether any dictionaries can be found, and return
	NULL if none;
	(set_locale): check whether spell-checking is disabled;
	(sendmsg_window_new): set up language menu early, so that we can
	find out whether any dictionaries are found.

2017-11-16  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/toolbar-prefs.c (tp_store_set): map the pixmap id.

2017-11-08  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Fix some icon issues

	* images/meson.build: remove pointless comment.
	* meson.build: install desktop icon.

2017-11-08  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Install appstream metadata to non-deprecated location

	Fixes bgo 790076, thanks to Jeremy Bicha
	<URL:https://bugzilla.gnome.org/show_bug.cgi?id=790076>

	* Makefile.am: install balsa.appdata.xml in $(datarootdir)/metainfo.
	* meson.build: ditto.

2017-11-05  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Old glib-genmarshal has no --output option

	Thanks to Jack for the report
	<URL:https://mail.gnome.org/archives/balsa-list/2017-November/msg00003.html>

	* libbalsa/imap/meson.build: use the 'capture' option of
	customtarget, because the old glib-genmarshal has no --output
	option.
	* libbalsa/meson.build: ditto.

2017-09-30  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove unused make_gradient function, and build with
	quote-color.[ch] only if spell-checker == internal

	* src/Makefile.am: move quote-color.[ch] to
	balsa_spell_extra[,_dist]
	* src/meson.build: move quote-color.[ch] to balsa_spell_extra
	* src/quote-color.c: remove unused make_gradient function.
	* src/quote-color.h: ditto.

2017-09-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/imap/meson.build: fix prefix in marshal files.
	* libbalsa/meson.build: ditto.

2017-09-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/imap/meson.build: fix basename of marshal files.
	* libbalsa/meson.build: ditto.

2017-09-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* meson.build: .split() strings returned by custom config commands.

2017-09-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use gnome.genmarshal if glib is new enough

	* meson.build: check whether glib version >= 2.53.4.
	* libbalsa/imap/meson.build: use gnome.genmarshal if glib is new
	enough; otherwise, use glib-genmarshal directly instead of in a
	sh command.
	* libbalsa/meson.build: ditto.

2017-09-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use --output option of glib-genmarshal

	* libbalsa/imap/meson.build:
	* libbalsa/meson.build:

2017-09-25  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use include_directories instead of explicit -I…

	* libbalsa/imap/meson.build:
	* libbalsa/meson.build:
	* libinit_balsa/meson.build:
	* libnetclient/meson.build:
	* libnetclient/test/meson.build:
	* meson.build:
	* src/meson.build:

2017-09-25  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/filter-run-dialog.c: include filter-funcs.h instead of
	libbalsa/filter-funcs.h, same as elsewhere.

2017-09-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-app.c (balsa_find_iter_by_data): we no longer ever define
	BALSA_DEBUG_THREADS.

2017-09-23  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove 'debug-threads' option

	* meson.build: do not use it.
	* meson_options.txt: do not define it.

2017-09-23  Albrecht Dreß <albrecht.dress@arcor.de>

	Remove deprecated gdk_threads_* stuff

	In an attempt to clean up the code and to simplify the configure
	file, this patch:
	* removes gdk_threads_(enter|leave) calls from the code,
	* removes the related “--enable-debug-threads” configure option and
	* replaces the calls to gdk_threads_add_idle() by g_idle_add().

	* configure.ac:
	* libbalsa/address-view.c (lbav_ensure_blank_line):
	* libbalsa/identity.c (sd_response_ok):
	* libbalsa/information.c (libbalsa_information_idle_handler):
	* libbalsa/libbalsa-gpgme-cb.c (get_passphrase_idle):
	* libbalsa/libbalsa.c (ask_idle), (libbalsa_ask):
	* libbalsa/libbalsa.h:
	* libbalsa/mailbox.c (libbalsa_mailbox_close),
	(libbalsa_mailbox_msgno_inserted),
	(libbalsa_mailbox_msgno_filt_in), (libbalsa_mailbox_msgno_removed),
	(libbalsa_mailbox_msgno_filt_out), (lbm_set_threading),
	(mbox_set_sort_column_id), (libbalsa_mailbox_unlink_and_prepend),
	(lbm_set_msg_tree), (libbalsa_mailbox_set_msg_tree):
	* libbalsa/mailbox_imap.c (idle_unread_update_cb),
	(imap_exists_idle):
	* libbalsa/mailbox_local.c (lbm_local_restore_tree),
	(lbml_load_messages_idle_cb),
	(libbalsa_mailbox_local_set_threading):
	* libbalsa/send.c:
	* libinit_balsa/assistant_init.c (balsa_init_begin):
	* src/balsa-app.c (ask_passwd_idle), (balsa_open_mailbox_list),
	(balsa_find_mailbox), (balsa_find_dir):
	* src/balsa-index.c (bndx_destroy),
	(bndx_mailbox_row_inserted_idle), (balsa_index_load_mailbox_node),
	(balsa_index_expunge):
	* src/balsa-mblist.c (bmbl_set_property_node_style),
	(balsa_mblist_close_lru_peer_mbx), (bmbl_sort_idle),
	(balsa_mblist_mailbox_node_append):
	* src/balsa-mime-widget-image.c (img_check_size):
	* src/balsa-mime-widget-text.c (statusbar_pop):
	* src/balsa-mime-widget.c (resize_idle):
	* src/information-dialog.c (status_bar_refresh):
	* src/mailbox-node.c (bmbn_scan_children_idle):
	* src/main-window.c (bw_focus_idle), (mail_progress_notify_cb),
	(bw_idle_replace), (bw_progress_timeout):
	* src/main.c (initial_open_unread_mailboxes), (initial_open_inbox),
	(balsa_get_stats), (scan_mailboxes_idle_cb), (periodic_expunge_cb),
	(balsa_progress_set_fraction), (balsa_progress_set_activity),
	(real_main), (handle_remote):
	* src/message-window.c (message_window_idle_handler):
	* src/pref-manager.c (open_preferences_manager_idle):
	* src/save-restore.c (config_warning_idle):
	* src/sendmsg-window.c (edit_with_gnome_check),
	(sw_autosave_timeout_cb), (sw_grab_focus_to_text):
	* src/spell-check.c (highlight_idle):

2017-09-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Drop 'enable-' and 'with-', inherited from autotools,
	from option names.

	* libnetclient/meson.build:
	* libnetclient/test/meson.build:
	* meson.build:
	* meson_options.txt:

2017-09-22  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* sounds/meson.build: use documented option syntax for msgfmt.

2017-09-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Replace 'yes'|'no' option values inherited from autotools with
	'true'|'false' string values.

	* libbalsa/meson.build:
	* meson.build:
	* meson_options.txt:

2017-09-21  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* sounds/meson.build: make an absolute path to the po dir.

2017-09-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Pass '-lz' link argument as a dependency of libimap instead of through
	add_global_link_arguments

	* libbalsa/imap/meson.build: add the dependency.
	* meson.build: do not use add_global_link_arguments.

2017-09-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use 'glib-genmarshal --header --body' to generate marshal.c
	files, instead of catting a header line to the file

	* libbalsa/imap/meson.build:
	* libbalsa/meson.build:

2017-09-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Do not include internal dependencies in declare_dependency()

	* libbalsa/imap/meson.build:
	* libbalsa/meson.build:
	* libinit_balsa/meson.build:
	* libnetclient/meson.build:
	* libnetclient/test/meson.build:
	* src/meson.build:

2017-09-19  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* meson.build: adapt the meson build to reflect the GNOME option
	changes.
	* meson_options.txt: ditto.

2017-09-19  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove obsolete option to build with deprecated GnomeKeyring

	* configure.ac: do not check for the lib and do not define
	HAVE_GNOME_KEYRING and friends.
	* libbalsa/imap-server.c (libbalsa_imap_server_new_from_config):
	do not use it.
	* libbalsa/server.c (libbalsa_server_load_config),
	(libbalsa_server_save_config): ditto.
	* libbalsa/server.h: ditto.
	* src/balsa-app.c (ask_password_real): ditto.
	* src/folder-conf.c (folder_conf_imap_node): ditto.
	* src/mailbox-conf.c (create_imap_mailbox_dialog): ditto.

2017-09-19  Peter Bloomfield  <pbloomfield@bellsouth.net>

	HAVE_GNOME is redundant

	* configure.ac: do not define it.
	* libbalsa/filter-file.c (libbalsa_condition_new_2_0): do not
	refer to it.
	* src/toolbar-factory.c (balsa_toolbar_model_finalize),
	(tm_gsettings_change_cb), (balsa_toolbar_model_new),
	(tm_default_style): use GSettings without checking it.

2017-09-14  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Allow installing the help files

	* meson.build:
	* src/meson.build:

2017-09-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Meson uses msgfmt rather than intltool-merge, so we do not use
	underscore prefixes to mark strings for translation.

	* balsa-mailto-handler.desktop.meson: new file
	* balsa.desktop.meson: ditto
	* sounds/balsa.soundlist.meson: ditto

2017-09-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/meson.build: make balsa and balsa_ab installable.

2017-09-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* meson.build: fix install directory.
	* ui/meson.build: ditto.

2017-08-29  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/misc.c (libbalsa_get_domainname): use
	utsname.domainname if it is available.

2017-08-29  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/libbalsa.c (libbalsa_init): drop unused call to
	uname.

2017-08-22  Tony Nelson <tonynelson@georgeanelson.com>

	Fix https://bugzilla.redhat.com/show_bug.cgi?id=1483354,
	balsa message window Queue toolbar button sends immediately

	* src/sendmsg-window.c: respect
	balsa_app.always_queue_sent_mail.

2017-08-20  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Do not crash if DSN header is absent

	Fixes https://bugzilla.redhat.com/show_bug.cgi?id=1483355

	* libbalsa/send.c (lbs_process_queue_msg): check for missing
	X-Balsa-DSN header, and do not pass NULL to atoi.

2017-08-11  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/imap/imap-handle.c (idle_start): assert that the
	  handle is not NULL, to avoid the appearance of dereferencing a
	  NULL pointer.

2017-08-10  Albrecht Dreß

	Crypto-related (mostly) fixes and improvements

	* libbalsa/gmime-multipart-crypt.c: do not qp-encode 7-bit parts for encryption
	* libbalsa/identity.[ch]: implement separate forced signing key id's
	  for gpg and s/mime including selection from the key list; clarify option text
	* libbalsa/libbalsa-gpgme-cb.c: simplify key list, show key details on double-click
	* libbalsa/libbalsa-gpgme-keys.[ch]: add functions for exporting
	  and importing ascii-armoured keys; re-factor import result evaluation
	* libbalsa/libbalsa-gpgme-widgets.c: extend subkey details
	* libbalsa/libbalsa-gpgme.[ch]: fix context creation for s/mime;
	  add helpers for configuring the gpgme context's home folder,
	  for exporting a key to ASCII and for identifying the proper key id of a secret key;
	  fix confusing comment
	* libbalsa/message.[ch]: use a reference to the sending identity
	  instead of copying the key id
	* libbalsa/misc.c: re-factor deleting a folder and creating a temp folder
	  (re-sent from last week's patch)
	* libbalsa/rfc3156.c: fix mem leak when encrypting a message
	  (re-sent from last week's patch)
	* libbalsa/send.c: add helper for creating a gpg public key attachment
	  and attach the key on request; fix mem leak in encryption
	* libbalsa/smtp-server.c: remove misleading/confusing comment
	  (re-sent from last week's patch)
	* src/balsa-mime-widget-crypto.[ch]: implement display of application/pgp-keys parts
	  and the import of the keys within them
	* src/balsa-mime-widget.c: call handler for application/pgp-keys parts
	* src/information-dialog.c: add missing dialogue flags
	* src/sendmsg-window.[ch], ui/sendmsg-window.ui: add user interface
	  for attaching the GnuPG public key

2017-08-05  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/imap/imap-tls.c (imap_create_ssl): unlock
	global_tls_lock and print the SSL error stack before returning.

2017-08-05  Zhouyang Jia <jiazhouyang09@gmail.com>

	* libbalsa/imap/imap-tls.c (imap_create_ssl): check for NULL
	value from SSL_CTX_new.

2017-08-03  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Save and restore the spell checking language when built with the
	internal checker

	* src/balsa-app.h: include the spell_check_lang member in all
	builds.
	* src/save-restore.c (config_global_load), (config_save): save
	and restore it in all builds.
	* src/sendmsg-window.c (create_lang_menu), (lang_set_cb): use it
	in all builds.

2017-07-17  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/libbalsa-gpgme.c (get_key_from_name): do not
	dereference a NULL pointer.

2017-07-17  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Avoid some whining from the clang static analyzer

	* libbalsa/libbalsa-gpgme-keys.c (gpgme_import_key):
	value stored to 'gpgme_err' is never read.
	* libbalsa/libbalsa-gpgme-widgets.c (create_subkey_widget):
	value stored to 'subkey_row' is never read.

2017-07-17  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-mime-widget-message.c (foreach_label): the only
	children that have a "populate-popup" signal are GtkLabels.

2017-07-16  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/server.c (libbalsa_server_load_config): dereference
	server->cert_passphrase.

2017-07-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Do not use local variables that shadow other variables

	* libbalsa/address-book-text.c (lbab_text_load_file):
	* libbalsa/address-view.c (lbav_set_text):
	* libbalsa/gmime-part-rfc2440.c (g_mime_part_rfc2440_verify),
	(g_mime_part_rfc2440_decrypt):
	* libbalsa/imap/imap-tls.c (imap_check_server_identity):
	* libbalsa/libbalsa-conf.c (lbc_init):
	* libbalsa/libbalsa.c (libbalsa_is_cert_known):
	* libbalsa/mailbox.c (libbalsa_mailbox_add_messages):
	* libbalsa/mailbox_imap.c (imap_expunge_cb),
	(internet_address_new_list_from_imap_address),
	(libbalsa_mailbox_imap_add_messages), (icm_restore_from_cache):
	* libbalsa/mailbox_local.c
	(libbalsa_mailbox_local_prepare_threading):
	* libbalsa/mailbox_mh.c (libbalsa_mailbox_mh_get_message_stream),
	(libbalsa_mailbox_mh_check), (libbalsa_mailbox_mh_sync),
	(libbalsa_mailbox_mh_fetch_message_structure),
	(lbm_mh_add_message):
	* libbalsa/mime.c (libbalsa_text_to_html):
	* libbalsa/send.c (libbalsa_message_create_mime_message):
	* src/balsa-mblist.c (bmbl_select_mailbox):
	* src/balsa-message.c (balsa_part_info_free):
	* src/filter-run-dialog.c (filters_run_dialog):
	* src/main-window.c:
	* src/save-restore.c (config_global_load):
	* src/sendmsg-window.c (sw_edit_activated),
	(update_bsmsg_identity), (scan_bodies), (create_lang_menu),
	(send_message_handler), (sendmsg_window_new_from_list),
	(sendmsg_window_continue):

2017-07-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/balsa-app.c (balsa_find_dir): put braces around empty "if"
	block.

2017-07-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* libbalsa/address.c (libbalsa_address_get_edit_widget): do not
	use old style declaration.

2017-07-15  Albrecht Dreß

	* libbalsa/libbalsa-progress.c (revealer_destroy_notify),
	(libbalsa_progress_dialog_update), (remove_progress_widget):
	save a time-out id and remove the source if the progress dialog
	is closed before the time-out expires.

2017-07-02  Albrecht Dreß

	Gpgme-related improvements

	* libbalsa/libbalsa-gpgme-keys.[ch]: (new) implement key listing
	  and key server operations
	* libbalsa/libbalsa-gpgme-widgets.[ch]: (new) implement key widget and dialogue
	* configure.ac: drop otions "--with-gpg-app" and "--enable-smime"
	* libbalsa/Makefile.am: remove option for building without s/mime support
	* libbalsa/gmime-multipart-crypt.c, libbalsa/identity.c,
	libbalsa/send.c, src/balsa-print-object.c, src/sendmsg-window.c: remove conditionals
	  for s/mime support
	* libbalsa/libbalsa-gpgme-cb.[ch]: use new key dialogue, fix prototype indent
	* libbalsa/libbalsa-gpgme.[ch]: export functions for setting a gpgme error
	  and creating a context, do not set gpg application, remove conditionals
	  for s/mime support, fix loading a key for a name or fingerprint,
	  use new key listing function
	* libbalsa/rfc3156.[ch}: remove conditionals for s/mime support,
	  use convenience functions exported by libbalsa-gpgme.c,
	  export new function creating a short signature status,
	  remove functions talking to the keyserver through gpg directly,
	  use GLib functions to check to the trust db update lock,
	  check for public key availibility by using the new key list function
	* src/balsa-mime-widget-crypto.c: use new key widget, drop GPG-related conditionals

2017-06-30  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Add assertions to remove some clang-static-analyzer false
	positives

	* libbalsa/imap-server.c (lb_imap_server_info_free): assert that
	info is non-NULL.
	* libbalsa/mailbox_imap.c (imap_expunge_cb): assert that
	msg_info is non-NULL;
	(get_struct_from_cache): assert that message->headers is
	non-NULL.
	* libbalsa/mailbox_local.c (libbalsa_mailbox_local_set_path):
	assert that klass is non-NULL.

2017-06-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Assert that a child widget is non-NULL

	* src/balsa-mime-widget-message.c (foreach_label): assert that
	the widget is non-NULL.

2017-06-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Assert that the BalsaWindow is not NULL

	* src/main-window.c (bw_action_set_enabled): assert that the
	BalsaWindow is not NULL.

2017-06-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Handle GError pointer more carefully

	* libbalsa/body.c
	(libbalsa_message_body_set_text_rfc822headers): do not create a
	GError and then ignore it;
	(libbalsa_message_body_get_stream): allow NULL GError pointer,
	and take more care in setting errors when it is non-NULL.

2017-06-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Assert that a node is not NULL

	* libbalsa/mailbox.c (lbm_next): assert that node is not NULL
	before testing whether it is the root node


2017-06-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Check for NULL pointer

	* libbalsa/mailbox.c (lbm_sort): check for NULL prev.

2017-06-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Handle broken pipe and other errors before writing to pipe

	* src/balsa-index.c (pipe_in_watch): handle G_IO_HUP or G_IO_ERR
	and return, before writing to the pipe.

2017-06-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove dead assignment

	* libbalsa/rfc6350.c (rfc6350_eval_line):

2017-06-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Assert that getpwuid returns a valid passwd structure

	* libbalsa/rfc3156.c (gpg_updates_trustdb): Assert that
	  getpwuid returns a valid passwd structure.

2017-06-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Assert that a mailbox is either IMAP or local

	* src/main-window.c (bw_mailbox_check): assert that a mailbox is
	either IMAP or local.

2017-06-25  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Do not store label values that are never read

	* src/folder-conf.c (folder_conf_imap_sub_node):

2017-06-25  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove unused initializer

	* src/toolbar-prefs.c (tp_page_swap_rows):

2017-06-25  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Decode all RFC-2047-encoded headers

	* libbalsa/message.c
	  (prepend_header_misc): decode header value;
	  (libbalsa_message_user_hdrs_from_gmime): streamline code.

2017-06-19  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Possible fix for Red Hat Bugzilla #1462546, reported by jamesbdonovan@rambler.ru

	* src/balsa-mime-widget-text.c (statusbar_pop): check that the
	  main window and the status bar are still valid.

2017-06-18  Albrecht Dreß

	Implement automatic sending in background

	* libbalsa/libbalsa-progress.[ch]: new files, implementing the progress dialogue.
	    Its update operation shall be called using idle callbacks.  For the time being,
	    it is used for SMTP only, but it might also be useful for receiving messages.
	* libbalsa/Makefile.am: add the aforementioned new files
	* libbalsa/send.c: implement the core of the patch, and do some re-factoring
	    to make the source better readable.  Add functions for the auto-send timer stuff.
	    Remove the old send message dialogue implementation.
	* libbalsa/send.h: export functions for controlling the auto-send feature,
	    and remove the old progress dialogue stuff
	* libbalsa/smtp-server.[ch]: extend the smtp server class by a lock flag,
	    implemented as atomic variable
	* src/balsa-app.c: implement auto-send callback, and initialise the feature
	* src/balsa-app.h: add auto-send application variables
	* src/main-window.c: remove old progress dialogue callback
	* src/main.c, src/threads.h: remove old progress dialogue globals and initialisation
	* src/pref-manager.c: configuration of the auto-send feature
	* src/save-restore.c: load and save the configuration of the auto-send feature

2017-06-16  Albrecht Dreß

	Build with Gtk version < 3.22

	* src/toolbar-factory.c (tm_popup_context_menu_cb): GdkEvent has
	no member "time"; use gtk_get_current_event_time.

2017-06-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use gdk_event_triggers_context_menu instead of checking event
	type and button

	* src/balsa-index.c (bndx_button_event_press_cb):
	* src/balsa-mblist.c (bmbl_button_press_cb):
	* src/balsa-message.c (tree_button_press_cb):
	* src/balsa-mime-widget-image.c (balsa_image_button_press_cb):
	* src/balsa-mime-widget-text.c (balsa_gtk_html_button_press_cb):
	* src/sendmsg-window.c (attachment_button_press_cb):

2017-06-15  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Simplify popping up a toolbar's context menu, and make icons
	visible after changing style

	* src/toolbar-factory.c
	  (tm_populate): set the toolbar style before showing-all;
	  (tm_changed_cb): tm_set_style is redundant and has been removed;
	  (tm_popup_context_menu_cb): new callback for
	    "popup-context-menu" signal;
	  (balsa_toolbar_new): no need to connect to "realized" signal;
	    connect to GtkToolbar's "popup-context-menu" signal instead of
	    GtkWidget's "button-press-event" and "popup-menu" signals.

2017-06-14  Albrecht Dreß

	Use John Jack's new icons for "mail-queue" and
	"balsa-send-queued" actions

	* images/16x16/Makefile.am: add the file names.
	* images/24x24/Makefile.am: ditto.
	* src/balsa-icons.c (balsa_register_pixmaps): use them.
	* src/balsa-icons.h: ditto.
	* src/main-window.c: ditto.
	* src/sendmsg-window.c: ditto.
	* src/toolbar-factory.c: ditto.

2017-06-13  Peter Bloomfield  <pbloomfield@bellsouth.net>

	* src/filter-run-dialog.c (balsa_filter_run_dialog_new): build
	with gtk version < 3.12.

2017-06-12  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use a wrapper for an environment variable

	* src/filter-run-dialog.c (balsa_filter_run_dialog_new): use
	  libbalsa_dialog_flags() instead of directly checking the
	  BALSA_DIALOG_HEADERBAR environment variable.

2017-06-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove obsolete reference in configure summary

	* configure.ac: $install_mimeicons was removed in commit
	4400b65d2325e0446cbc45bcf0c250476c8caea7.

2017-06-01  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Recent pref-manager changes break display

	* src/pref-manager.c (open_preferences_manager): put a
	horizontal box in the dialog's content area, instead of making
	the content area horizontal.

2017-05-31  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Code cleanup

	* src/pref-manager.c (option_menu_cb), (pgdown_modified_cb):
	simplify callback placement.

2017-05-31  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Port preferences window from GtkNotebook to GtkStack

	* src/pref-manager.c (pm_combo_box_info_free), (pm_combo_box_new),
	(pm_combo_box_set_level), (pm_combo_box_get_level),
	(pm_selection_changed), (destroy_pref_window_cb),
	(update_view_defaults), (check_font_button), (apply_prefs),
	(set_prefs), (update_address_books), (add_other_server),
	(add_button_to_box), (add_show_menu), (create_pref_option_menu),
	(create_layout_types_menu), (create_action_after_move_menu),
	(balsa_help_pbox_display), (create_information_message_menu),
	(create_mdn_reply_menu), (update_smtp_servers), (pm_grid_new),
	(pm_grid_attach), (pm_group_label), (pm_grid_attach_check),
	(pm_grid_attach_label), (pm_grid_attach_pref_menu),
	(pm_grid_attach_entry), (pm_grid_attach_color_box),
	(font_button_check_font_size), (pm_grid_attach_font_button),
	(pm_grid_attach_information_menu), (properties_modified_cb),
	(server_edit_cb), (smtp_server_update), (smtp_server_add_cb),
	(smtp_server_edit_cb), (smtp_server_del_cb), (smtp_server_changed),
	(address_book_change), (address_book_edit_cb),
	(address_book_set_default_cb), (add_menu_cb),
	(address_book_delete_cb), (pop3_add_cb), (server_add_menu_widget),
	(server_del_cb), (timer_modified_cb), (browse_modified_cb),
	(mark_quoted_modified_cb), (wrap_modified_cb),
	(pgdown_modified_cb), (option_menu_cb),
	(mailbox_close_timer_modified_cb), (filter_modified_cb),
	(expunge_on_close_cb), (expunge_auto_cb), (imap_toggled_cb),
	(convert_8bit_cb), (use_system_fonts_cb), (font_modified_cb),
	(default_font_size_cb), (response_cb),
	(pm_grid_add_main_window_group), (pm_grid_add_threading_group),
	(pm_grid_add_progress_group), (pm_append_page),
	(pm_mailserver_page), (pm_incoming_page), (pm_outgoing_page),
	(pm_display_page), (pm_threading_page), (pm_message_page),
	(pm_colors_page), (pm_format_page), (pm_status_messages_page),
	(create_address_book_page), (pm_spelling_page), (pm_startup_page),
	(pm_misc_page), (create_mail_options_section),
	(create_display_section), (open_preferences_manager_idle),
	(open_preferences_manager), (update_mail_servers): replace
	mutiple notebooks by a single stack; refactor code into groups
	of options, pages of one or more groups, and sections where
	multiple pages are related.

2017-05-30  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Port preferences window to GtkGrid

	* src/pref-manager.c (add_button_to_box), (pm_grid_new),
	(pm_grid_attach), (pm_group_label), (pm_grid_attach_check),
	(pm_grid_attach_label), (pm_grid_attach_pref_menu),
	(pm_grid_attach_entry), (pm_grid_attach_color_box),
	(font_button_check_font_size), (pm_grid_attach_font_button),
	(pm_grid_attach_information_menu),
	(pm_grid_add_remote_mailbox_servers_group),
	(pm_grid_add_local_mail_group), (pm_grid_add_outgoing_mail_group),
	(mailserver_subpage), (pm_grid_add_checking_group),
	(pm_grid_add_mdn_group), (incoming_subpage),
	(pm_grid_add_word_wrap_group), (pm_grid_add_other_options_group),
	(outgoing_subpage), (create_mail_options_page),
	(pm_grid_add_main_window_group),
	(pm_grid_add_message_window_group), (display_subpage),
	(pm_grid_add_threading_group), (threading_subpage),
	(pm_grid_add_preview_font_group), (pm_grid_add_quoted_group),
	(pm_grid_add_alternative_group), (message_subpage),
	(pm_grid_add_message_colors_group), (pm_grid_add_link_color_group),
	(colors_subpage), (pm_grid_add_display_formats_group),
	(pm_grid_add_broken_8bit_codeset_group), (format_subpage),
	(pm_grid_add_information_messages_group),
	(pm_grid_add_progress_group), (status_messages_subpage),
	(create_display_page), (pm_grid_add_address_books_group),
	(create_address_book_page), (pm_grid_add_misc_spelling_group),
	(create_spelling_page), (pm_grid_add_startup_options_group),
	(pm_grid_add_folder_scanning_group), (create_startup_page),
	(pm_grid_add_misc_group), (pm_grid_add_deleting_messages_group),
	(create_misc_page): make each page a single GtkGrid and use
	fewer nested GtkBoxes.

2017-05-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use widget alignment instead of label alignment

	* src/pref-manager.c (attach_entry_full), (attach_label),
	  (checking_group), (quoted_group), (mdn_group), (main_window_group),
	  (add_pref_menu), (deleting_messages_group),
	  (folder_scanning_group), (pm_group_new): scrap set_align, and use
	  gtk_widget_set_[hv]align instead of gtk_label_set_[xy]align or
	  deprecated gtk_misc_set_alignment.

2017-05-28  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use widget alignment instead of label alignment

	* src/balsa-mime-widget-message.c (add_header_gchar): use
	  gtk_widget_set_halign instead of gtk_label_set_xalign or
	  deprecated gtk_misc_set_alignment.

2017-05-28  Albrecht Dreß

	Adjust SMTP timeouts

	* libnetclient/net-client-smtp.c (net_client_smtp_connect),
	  (net_client_smtp_send_msg): adjust all SMTP client transaction timeouts
	  to the minimum values (which are *very* long imho!)
	  required by RFC 5321, sect. 4.5.3.2.1. - 4.5.3.2.6.


2017-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Increase a timeout interval

	* src/main.c (real_main): increase the fix-panes timeout again,
	  from 700 to 800 msec.

2017-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove unused code

	* libbalsa/misc.c: libbalsa_guess_pop_server and
	libbalsa_guess_ldif_file are not used.
	* libbalsa/misc.h: do not export libbalsa_guess_ldif_file.
	* libbalsa/libbalsa.h: do not export libbalsa_guess_pop_server.

2017-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Clean up file finder code

	* libbalsa/files.c (balsa_file_finder): remove unused arguments.
	* libbalsa/files.h: ditto.

2017-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Remove unused code

	* libinit_balsa/assistant_helper.c: remove balsa_init_get_png,
	  as it is not used.
	* libinit_balsa/assistant_helper.h: do not export it.

2017-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use Balsa's main window as parent of a dialog

	* src/sendmsg-window.c (send_message_handler): use
	  balsa_app.main_window as the parent for the sending progress
	  dialog, to allow the compose window to close before sending is
	  finished.

2017-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	After a transient error, leave messages ready to resend

	* libbalsa/send.c (balsa_send_message_real): clear FLAGGED flag
	  if sending failed because of a transient error, so that the
	  messages can be resent just using send-queued-mail.

2017-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Keep a parent window alive

	* libbalsa/send.c
	  (lbs_process_queue): object-ref the parent window...
	  (lbs_check_reachable_cb): and unref it.

2017-05-27  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Plug leak

	* libbalsa/libbalsa.c (libbalsa_source_view_new): use the
	  default GtkSourceStyleSchemeManager instead of leaking a new
	  one.

2017-05-26  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Plug leak

	* src/sendmsg-window.c (sendmsg_window_new): free ui_file
	string.

2017-05-26  Albrecht Dreß

	Test whether we can reach an SMTP server

	* libbalsa/send.c: use atomic operations for the sending state;
	  check if the smtp server is reachable before sending;
	  simplify some API's;
	  replace the term "MTA" in user dialogues by "SMTP server" which is more common
	* libbalsa/send.h: export simplified API
	* libbalsa/server.c: ignore port in server host string
	* src/balsa-message.c,
	  src/balsa-mime-widget-message.c,
	  balsa-mime-widget-vcalendar.c,
	  src/main-window.c,
	  src/sendmsg-window.c: use simplified API

2017-05-25  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Use is-maximized property instead of window-state-event signal

	* src/main-window.c (bw_notify_is_maximized_cb),
	(balsa_window_new): connect to "notify::is-maximized" signal
	instead of "window-state-event" to avoid irrelevant state
	changes.
	* src/main.c (real_main): increase the fix-panes timeout again,
	from 600 to 700 msec.

2017-05-25  Peter Bloomfield  <pbloomfield@bellsouth.net>

	Revert 45b7ce83a56690beb40c37f911f7c61b553d8828, and just
	increase the timeout from 500 to 600 msec.

	* src/main-window.c (bw_window_state_event_cb), (balsa_window_new),
	(balsa_window_fix_paned): revert 45b7ce83a56690beb40c37f911f7c61b553d8828.
	* src/main.c (real_main): increase the fix-panes timeout from 500 to 600 msec.

